/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, runOn, markDep } from "igniteui-angular-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-angular-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let AnchoredRadialBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
        constructor(a) {
            super(a);
            this.f = null;
            this.f = a;
        }
        getBucket(a) {
            let b = this.f.cw.s4;
            let c = Math.min(a * this.b, b.count - 1);
            let d = Math.min(c + this.b - 1, b.count - 1);
            let e = NaN;
            let f = NaN;
            for (let g = c; g <= d; ++g) {
                let h = b.item(g);
                if (!isNaN_(e)) {
                    if (!isNaN_(h)) {
                        e = Math.min(e, h);
                        f = Math.max(f, h);
                    }
                }
                else {
                    e = h;
                    f = h;
                }
            }
            if (!isNaN_(e)) {
                return [0.5 * (c + d), e, f];
            }
            return [0.5 * (c + d), NaN, NaN];
        }
    }
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeries = /*@__PURE__*/ (() => {
    class AnchoredRadialSeries extends RadialBase {
        constructor() {
            super();
            this.sz = null;
            this.s3 = null;
            this.t6 = { $type: Point_$type, x: 0, y: 0 };
            this.s1 = null;
            this.s0 = null;
            this.s1 = new RadialFrame(3);
            this.sz = new CategoryLineRasterizer();
        }
        bx() {
            return new AnchoredRadialSeriesView(this);
        }
        ku() {
            super.ku();
            this.rl = null;
            this.rs = null;
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == AnchoredRadialSeries.$$p[2]) {
                return this.hx(a, b, this.tk);
            }
            return super.hw(a, b);
        }
        lz(a) {
            super.lz(a);
            this.sy = a;
        }
        hj(a, b) {
            return this.hk(a, b, this.rl, null, this.s4);
        }
        hh(a, b) {
            return this.hi(a, b, this.rl, null, this.s4);
        }
        f3(a, b, c, d, e) {
            if (this.s4 == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.f4(a, b, this.rl, d, e, this.s4.count, null);
        }
        gj(a, b, c) {
            let d = this.getEffectiveViewport1(this.b0);
            let e = this.s9(this.rl, this.b0.bv, this.b0.bu, d);
            let f = new ScalerParams(0, this.b0.bv, this.b0.bu, this.rl.cg, d);
            f.c = this.cd.su;
            return this.gl(this.s4, a, this.rl, f, e, null, b, c);
        }
        pm(a, b, c) {
            if (this.rs == null || this.rl == null || this.b0 == null || this.b0.bv.isEmpty || this.b0.bu.isEmpty) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.getEffectiveViewport1(this.b0);
            let e = new ScalerParams(0, this.b0.bv, this.b0.bu, this.rs.cg, d);
            e.c = this.getEffectiveViewport1(this.b0);
            let f = this.gj(a, b, c);
            f = this.rs.ei(f, e);
            let g = this.rt.c(a);
            if (!b && this.rl != null) {
                let h = this.hj(a, c);
                let i = this.hh(a, c);
                let j = this.s9(this.rl, this.b0.bv, this.b0.bu, d);
                let k = new ScalerParams(0, this.b0.bv, this.b0.bu, this.rl.cg, d);
                k.c = this.cd.su;
                let l = this.f3(a, h, this.rl, k, j);
                let m = this.f3(a, i, this.rl, k, j);
                if (m <= l) {
                    g = this.rl.ei(i, k) + j;
                }
                else {
                    g = this.rl.ei(h, k) + j;
                }
            }
            let n = this.rt.d(g, f, this.b0.bv, this.b0.bu);
            let o = this.rt.e(g, f, this.b0.bv, this.b0.bu);
            return { $type: Point_$type, x: n, y: o };
        }
        get s4() {
            return this.s3;
        }
        set s4(a) {
            if (this.s3 != a) {
                let b = this.s3;
                this.s3 = a;
                this.raisePropertyChanged("ValueColumn", b, this.s3);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = new DataLegendSeriesValueInfo();
            c.a = 0;
            c.l = this.gj({ $type: Point_$type, x: a, y: b }, false, false);
            c.p = this.tk != null ? this.tk : "Value";
            c.q = this.tg != null ? this.tg : "V:";
            c.r = this.ti != null ? this.ti : "";
            let d = new DataLegendSeriesContext();
            d.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(c);
                return $ret;
            })());
            d.b = this.av();
            return d;
        }
        get t2() {
            return this.c(AnchoredRadialSeries.tr);
        }
        set t2(a) {
            this.h(AnchoredRadialSeries.tr, a);
        }
        ap(a) {
            if (a != null && a == this.rl && this.s4 != null && this.s4.count > 0) {
                return new AxisRange(0, this.s4.count - 1);
            }
            if (a != null && a == this.rs && this.s4 != null && this.s4.count > 0) {
                return new AxisRange(this.s4.minimum, this.s4.maximum);
            }
            return null;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            if (this.sy.cx.g$b(a, b, c, d)) {
                this.mi(false);
                this.lp();
            }
            let e = typeCast(NumericAxisBase.$, this.rs);
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) !== null) {
                        c.deregisterColumn(this.s4);
                        this.s4 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) !== null) {
                        this.s4 = this.ch(this.tk);
                        this.sy.cs.e(this.ft);
                    }
                    if (e != null && !e.c0()) {
                        this.sy.cs.e(this.ft);
                        this.mi(false);
                    }
                    break;
                case AnchoredRadialSeries.$$p[2]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.s4);
                        this.s4 = this.ch(this.tk);
                    }
                    break;
                case "ValueColumn":
                    if (e != null && !e.c0()) {
                        this.sy.cs.e(this.ft);
                        this.mi(false);
                    }
                    break;
                case "TrendLineBrush":
                    this.mw();
                    break;
                case "TrendLineType":
                    this.lp();
                    break;
            }
        }
        k0(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.sy.cs.e(this.ft);
                    break;
            }
            this.sy.cx.g$e(a, b, c, d);
            switch (a) {
                case 4:
                    if (this.rs != null && !this.rs.c0()) {
                        this.mi(true);
                    }
                    break;
                case 1:
                    if (this.rs != null && !this.rs.c0()) {
                        this.mi(true);
                    }
                    break;
                case 0:
                    if (this.rs != null && !this.rs.c0()) {
                        this.mi(true);
                    }
                    break;
                case 2:
                    if (this.tk != null && this.sy.cs.b > 0 && this.rs != null && !this.rs.c0()) {
                        this.mi(true);
                    }
                    break;
                case 3:
                    if (d == this.tk) {
                        if (this.rs != null && !this.rs.c0()) {
                            this.mi(true);
                        }
                    }
                    break;
            }
        }
        e9(a, b, c) {
            let d = super.e9(a, b, c);
            let e = c;
            if (this.ck == null || this.ck.count == 0 || this.rl == null || this.s4 == null || this.rl.le == 0 || this.rs == null || isInfinity(this.rs.lv) || isInfinity(this.rs.lu) || e.cs.b < 1) {
                d = false;
            }
            return d;
        }
        getOffsetValue() {
            return this.s9(this.rl, this.b0.bv, this.b0.bu, this.getEffectiveViewport1(this.b0));
        }
        getCategoryWidth() {
            return this.rl.getCategorySize(this.b0.bv, this.b0.bu, this.getEffectiveViewport1(this.b0));
        }
        get_s7() {
            return false;
        }
        get s7() {
            return this.get_s7();
        }
        get_c6() {
            return true;
        }
        get_ej() {
            return this.rs != null && this.rs.cg;
        }
        s9(a, b, c, d) {
            let e = 0;
            let f = this.preferredCategoryMode(a);
            if (f == 0 && a.categoryMode != 0) {
                f = 1;
            }
            switch (f) {
                case 0:
                    e = 0;
                    break;
                case 1:
                    e = 0.5 * a.getCategorySize(b, c, d);
                    break;
                case 2:
                    e = a.getGroupCenter(this.sf(), b, c, d);
                    break;
            }
            if (a.cg) {
                e = -e;
            }
            return e;
        }
        sn(a, b) {
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.rl;
            let g = this.rs;
            let h = g.lv;
            let i = g.lu;
            a.f.clear();
            a.m.clear();
            a.p.clear();
            let j = this.qf();
            let k = 0;
            let l = b;
            let m = new CollisionAvoider();
            let n = 0;
            let o = b.cs.d;
            n = this.s9(f, c, d, e);
            l.cx.i = this.rs.nm;
            l.cx.h = this.rs.nl;
            l.cx.j = (p, q) => this.ta(p, q, c, d);
            l.cx.k = (p, q) => this.tb(p, q, c, d);
            let p = ((() => {
                let $ret = new Clipper(0, d, false);
                $ret.i = a.p;
                return $ret;
            })());
            let q = ((() => {
                let $ret = new TrendResolutionParams();
                $ret.c = b.cs.b;
                $ret.d = b.cs.c;
                $ret.e = o;
                $ret.a = n;
                $ret.b = this.ft;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })());
            l.cx.l(a.p, this.s2, this.s4, this.td, (r) => this.rl.getScaledAngle(r), (r) => this.rs.ns(r), q, p);
            let r = true;
            if (this.s8(b)) {
                o--;
            }
            for (let s = b.cs.c; s <= o; ++s) {
                let t = s;
                if (t * b.cs.b >= this.rl.le) {
                    t -= intDivide((this.rl.le), b.cs.b);
                }
                let u = b.cs.getBucket(t);
                if (!isNaN_(u[0])) {
                    u[0] = f.getScaledAngle(u[0]) + n;
                    if (u[1] < h || u[1] > i) {
                        continue;
                    }
                    u[1] = g.ns(u[1]);
                    if (b.cs.b > 1) {
                        if (u[2] < h || u[2] > i) {
                            continue;
                        }
                        u[2] = g.ns(u[2]);
                    }
                    else {
                        u[2] = u[1];
                    }
                    if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.s7 && this.s6()) {
                        o++;
                    }
                    else {
                        r = false;
                    }
                    a.f.add(u);
                    if (j) {
                        let v = Math.min(t * b.cs.b, this.ck.count - 1);
                        let w = this.rt.d(u[0], u[1], c, d);
                        let x = this.rt.e(u[0], u[1], c, d);
                        let y = new Rect(0, w - 5, x - 5, 11, 11);
                        if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                            a.m.add({ $type: Point_$type, x: w, y: x });
                            let z = b.ct.item(k);
                            z.al = t;
                            z.ak = v;
                            z.content.item = this.ck.item(v);
                            ++k;
                        }
                    }
                }
                else {
                    if (r && this.s7 && this.s6()) {
                        o++;
                    }
                }
            }
            b.ct.count = k;
            return;
        }
        ta(a, b, c, d) {
            return this.rt.d(a, b, c, d);
        }
        tb(a, b, c, d) {
            return this.rt.e(a, b, c, d);
        }
        s8(a) {
            let b = a;
            return !this.s7 && b.cs.c == 0 && b.cs.d == this.rl.le;
        }
        sx(a, b, c) {
            let d = null;
            let e = c.bv;
            let f = c.bu;
            if (b > -1 && !e.isEmpty && !f.isEmpty) {
                let g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
                let h = f.bottom + 10;
                let i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
                let j = f.top - 10;
                d = new Clipper(1, g, h, i, j, false);
            }
            return d;
        }
        tq(a, b, c, d, e) {
            if (a.count > 0 && d.count > 0) {
                if (!e || this.s5()) {
                    a.add(this.t6);
                    a.add(a._inner[0]);
                    d.add(this.t6);
                    d.add(d._inner[0]);
                }
            }
        }
        s6() {
            return !this.s5();
        }
        s5() {
            let a = this.b0.bv;
            return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            if (a) {
                c.ct.clear();
            }
            c.cx.g$d();
        }
        sq(a, b) {
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pr(b);
            let g = b;
            g.cx.g$g(a.p);
            CategoryMarkerManager.e(this, a.m, g.ct, this.qh);
            this.tn(b, a);
            g.cm();
            this.tm(d, c, e, f, g);
        }
        sw(a, b, c) {
            if (b < a || a < 0 || a > this.s4.count || b < 0 || b > this.s4.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cm;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.ck.item(g);
            }
            return d;
        }
        to(a, b, c, d, e, f) {
            let g = this.bk != 1;
            this.rz.a1(this.rz.d, d.cm, a, b, c, d, e, f, true);
            this.rz.aa(this.fr);
            let h = this.rz.av;
            let i = null;
            let j = this.ck;
            let k = null;
            if (g && this.cd != null) {
                i = this.cd.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                if (this.cd.a3.isCrossSeriesHighlight(this)) {
                    k = this.cd.a3.getHighlightingInfo(this, j, h.o, h.n, true);
                }
                h.b = i;
            }
            h.f = f;
            this.so(h);
            this.rz.y(this, i, f, g, h.m, this.cd.a3.totalHighlightingProgress);
        }
        tp(a, b, c, d, e, f) {
            let g = this.bk != 1;
            this.rz.a1(this.rz.b, d.cm, a, b, c, d, e, f, false);
            this.rz.ab(this.fr);
            let h = this.rz.aw;
            let i = null;
            let j = this.ck;
            if (g && this.cd != null) {
                i = this.cd.a3.getHighlightingInfo(this, j, h.o, h.n, false);
                h.b = i;
            }
            h.f = f;
            this.sp(h);
            this.rz.z(this, i, f, g, b < 0);
        }
        tn(a, b) {
            a.b3 = true;
            this.rz.az(this, this.sa(), runOn(this, this.ri), this.sd(a), this.se(a));
            let c = this.rz.d;
            let d = c != null;
            let e = this.rl;
            if (e == null) {
                return;
            }
            let f = this.getEffectiveViewport1(a);
            let g = new ScalerParams(0, a.bv, a.bu, e.cg, f);
            let h = this.ck == null ? 0 : this.ck.count;
            let i = a;
            let j = b.f;
            let k = i.cs.c;
            let l = i.cs.d;
            let m = i.cs.b;
            let n = k * m;
            for (let o = 0; o < a.ct.count; o++) {
                let p = a.ct.item(o);
                let q = p.content;
                if (d) {
                    let r = p.al;
                    this.to(j, r, h, e, g, a.q);
                }
                this.rz.ac(p, q);
            }
        }
        tm(a, b, c, d, e) {
            e.cy(a, b, c, d);
        }
        mw() {
            super.mw();
            if (this.index < 0) {
                return;
            }
            this.sy.cz();
        }
        hz(a, b) {
            if (a == this.sy.cx.g$j) {
                return null;
            }
            return super.hz(a, b);
        }
        en(a) {
            let b = this.b0.bv;
            b = b.copy();
            let c = this.b0.bu;
            let d = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
            if (this.rl == null || this.s4 == null || this.rs == null) {
                return false;
            }
            if (d < 0 || d > this.s4.count - 1) {
                return false;
            }
            let e = this.rl.getScaledAngle(d);
            let f = this.rs.ns(this.s4.item(d));
            if (isNaN_(f)) {
                f = (this.rs.nl + this.rs.nm) / 2;
            }
            let g = 0.5 + (Math.cos(e) * f);
            let h = 0.5 + (Math.sin(e) * f);
            if (!isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.b8 != null) {
                this.b8.au(this.cd, b, true);
            }
            return d >= 0;
        }
        mk(a, b) {
            super.mk(a, b);
            if (!this.ez) {
                this.b0.a2(b);
                return;
            }
            this.b0.a2(b);
            let c = typeCast(AnchoredRadialSeriesView.$, this.bz);
            c.cs.e(this.ft);
            if (this.cx(this.bz)) {
                return;
            }
            if (!this.et) {
                this.s1 = new RadialFrame(3);
                this.sn(this.s1, c);
            }
            this.et = false;
            this.sq(this.s1, c);
            this.ez = false;
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            let g = f;
            g.cs.e(this.ft);
            f.a1(c);
            if (this.cx(g)) {
                return;
            }
            if (this.s0 == null) {
                this.s0 = new RadialFrame(3);
            }
            this.s0.u();
            this.sn(this.s0, g);
            this.sq(this.s0, g);
        }
        k7(a) {
            super.k7(a);
            this.a8.exportTrendlineData(this, a, this.sy.cx.g$j);
        }
    }
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.tr = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberAsLegendLabel:tg:tz', [2, null], 'ValueMemberAsLegendUnit:ti:t0', [2, null], 'ValueMemberPath:tk:t1', [2, null], 'TrendLineType:s2:tx', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:tc:tw', [1, 1.5], 'TrendLinePeriod:td:tv', [1, 7], 'TrendLineZIndex:te:ty', [1, 1], 'TrendLineBrush:t3:ts', [Brush.$, null], 'TrendLineDashArray:t4:tt', [DoubleCollection.$], 'TrendLineDashCap:t5:tu', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
})();
/**
 * @hidden
 */
export let AnchoredRadialSeriesView = /*@__PURE__*/ (() => {
    class AnchoredRadialSeriesView extends RadialBaseView {
        constructor(a) {
            super(a);
            this.cw = null;
            this.cx = null;
            this.cs = new AnchoredRadialBucketCalculator(this);
            this.cw = a;
            this.cx = new RadialTrendLineManager();
        }
        cy(a, b, c, d) {
        }
        cz() {
            this.cw.t2 = null;
            if (this.cw.t3 != null) {
                this.cw.t2 = this.cw.t3;
            }
            else {
                this.cw.t2 = this.cw.oz;
            }
        }
        a5(a, b) {
            if (a.d) {
                if (!b) {
                }
                if (this.cw.s2 != 0 && !b) {
                    let c = this.cx.g$j;
                    c.ac = this.cw.tc;
                    c._stroke = this.cw.t2;
                    c.ai = this.cw.t4;
                    c.ad = this.cw.t5;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'>";
            if (this.cw.rl.fz != null) {
                a += "<span>${item." + this.cw.rl.fz + "}</span><br/>";
            }
            a += "<span";
            let b = this.e.a6.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.tk + "}</span></div>";
            return a;
        }
    }
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
})();
