/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, delegateCombine, delegateRemove, markType } from "igniteui-angular-core";
import { IAnnotationLayerProxy_$type } from "./IAnnotationLayerProxy";
import { CalloutLayer } from "./CalloutLayer";
import { DataToolTipLayer } from "./DataToolTipLayer";
/**
 * @hidden
 */
export let AnnotationLayerProxy = /*@__PURE__*/ (() => {
    class AnnotationLayerProxy extends Base {
        matchesType(a) {
            if (!a.dc) {
                return false;
            }
            return true;
        }
        setCrosshairHorizontalLineVisibility(a, b) {
            a.tx = b;
        }
        setCrosshairVerticalLineVisibility(a, b) {
            a.ty = b;
        }
        setCrosshairHorizontalLineStroke(a, b) {
            a.tn = b;
        }
        setCrosshairVerticalLineStroke(a, b) {
            a.to = b;
        }
        setCrosshairXAxisForeground(a, b) {
            a.tr = b;
        }
        setCrosshairYAxisForeground(a, b) {
            a.tu = b;
        }
        setCrosshairXAxisBackground(a, b) {
            a.tp = b;
        }
        setCrosshairYAxisBackground(a, b) {
            a.ts = b;
        }
        setCrosshairYAxisPrecision(a, b) {
            a.rw = b;
        }
        setCrosshairXAxisPrecision(a, b) {
            a.rv = b;
        }
        setCrosshairOnAxesEnabled(a, b) {
            a.re = b;
        }
        setCrosshairUseInterpolation(a, b) {
            a.rg = b;
        }
        setCrosshairThickness(a, b) {
            a.gz = b;
        }
        setFinalValuePrecision(a, b) {
            a.rl = b;
        }
        setFinalValueBackground(a, b) {
            a.sf = b;
        }
        setFinalValueForeground(a, b) {
            a.sh = b;
        }
        setContentMemberPath(a, b) {
            a.to = b;
        }
        setCalloutsAllowedPositions(a, b) {
            a.rj = b;
        }
        setLabelMemberPath(a, b) {
            a.ty = b;
        }
        setXMemberPath(a, b) {
            a.t9 = b;
        }
        setYMemberPath(a, b) {
            a.uc = b;
        }
        setTargetSeries(a, b) {
            a.rn = b;
        }
        setCollisionChannel(a, b) {
            a.tl = b;
        }
        isCalloutLayer(a) {
            if (typeCast(CalloutLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isDataToolTipLayer(a) {
            if (typeCast(DataToolTipLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        addCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateCombine(c.calloutStyleUpdating, b);
        }
        removeCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateRemove(c.calloutStyleUpdating, b);
        }
        addCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateCombine(c.calloutRenderStyleUpdating, b);
        }
        removeCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateRemove(c.calloutRenderStyleUpdating, b);
        }
        setCalloutStyleUpdatingEventEnabled(a, b) {
            a.se = b;
        }
        setCalloutRenderStyleUpdatingEventEnabled(a, b) {
            a.sd = b;
        }
        updateDataToolTipPropertyByName(a, b, c) {
            a.wl(b, c);
        }
    }
    AnnotationLayerProxy.$t = markType(AnnotationLayerProxy, 'AnnotationLayerProxy', Base.$, [IAnnotationLayerProxy_$type]);
    return AnnotationLayerProxy;
})();
