/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, Boolean_$type, runOn, delegateRemove, typeCast, delegateCombine, fromEnum, fromEn, markType, markDep } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { XamDataChart } from "./XamDataChart";
import { Tuple$2 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export let AnnotationLayer = /*@__PURE__*/ (() => {
    class AnnotationLayer extends Series {
        constructor() {
            super();
            this.q7 = null;
            this.p6 = null;
            this.p5 = null;
            this.p7 = null;
            this.q5 = { $type: Point_$type, x: NaN, y: NaN };
            this.p8 = false;
            this.q7 = { $type: Point_$type, x: NaN, y: NaN };
        }
        bx() {
            return new AnnotationLayerView(this);
        }
        lz(a) {
            super.lz(a);
            this.p4 = a;
        }
        qc(a) {
            if (a == null) {
                return false;
            }
            if (a.dc) {
                return false;
            }
            if (a.isValueOverlay) {
                return false;
            }
            if (a == this) {
                return false;
            }
            return a.e9(a.b0.bu, a.b0.bv, a.b0);
        }
        get_dj() {
            return this.p9;
        }
        bp() {
            if (this.bq == 0) {
                return 1;
            }
            else {
                return super.bp();
            }
        }
        get_dy() {
            return this.qe || this.qf;
        }
        get_isUsableInLegend() {
            return this.qf;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    let e = c;
                    let f = d;
                    if (e != null) {
                        this.qy(e.series);
                        let g = e.series;
                        g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.qv));
                        if (typeCast(XamDataChart.$, e) !== null) {
                            let h = e;
                            this.qx(h.axes);
                            let i = h.axes;
                            i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.ql));
                        }
                    }
                    if (f != null) {
                        this.qt(f.series);
                        let j = f.series;
                        j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.qv));
                        if (typeCast(XamDataChart.$, f) !== null) {
                            let k = f;
                            this.qs(k.axes);
                            let l = k.axes;
                            l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.ql));
                        }
                    }
                    break;
                case AnnotationLayer.$$p[3]:
                case AnnotationLayer.$$p[2]:
                    if (this.dy) {
                        if (this.index == -1) {
                            this.index = XamDataChart.u1(this);
                        }
                    }
                    else {
                        this.index = -1;
                        this.oz = null;
                        this.o2 = null;
                    }
                    if (this.cd != null) {
                        this.cd.mk();
                    }
                    this.mi(true);
                    break;
                case "TransitionProgress":
                    this.p7.c(this.g0, this.p6, this.p5);
                    if (this.cx(this.b0)) {
                        return;
                    }
                    if (this.g0 == 1) {
                        this.qu(this.p5, this.b0);
                    }
                    else {
                        this.qu(this.p7, this.b0);
                    }
                    if (this.cd != null) {
                        this.cd.nn(this);
                    }
                    break;
                case AnnotationLayer.$$p[1]:
                    if (this.cd != null) {
                        this.cd.mi();
                    }
                    break;
                case AnnotationLayer.$$p[0]:
                    this.q7 = this.q6;
                    this.lt(this.q6);
                    break;
                case "ShouldRenderAsOverlay":
                    if (this.cd != null) {
                        this.b0.ak(this.cd);
                        this.b0.ag(this.cd);
                    }
                    break;
            }
        }
        qy(a) {
            for (let b of fromEnum(a)) {
                if (!(b == this)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qw));
                }
            }
            this.mi(true);
        }
        qx(a) {
            for (let b of fromEnum(a)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qm));
            }
            this.mi(true);
        }
        qt(a) {
            for (let b of fromEnum(a)) {
                if (!(b == this)) {
                    b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.qw));
                }
            }
            this.mi(true);
        }
        qs(a) {
            for (let b of fromEnum(a)) {
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.qm));
            }
            this.mi(true);
        }
        qa(a) {
            if (a == null) {
                return false;
            }
            return true;
        }
        qm(a, b) {
            if (this.qa(a)) {
                this.qo(a, b.animate);
            }
        }
        qb(a) {
            if (a == null) {
                return false;
            }
            if (a.dc) {
                return false;
            }
            return true;
        }
        qw(a, b) {
            if (this.qb(a)) {
                this.qp(a, b.animate);
            }
        }
        qo(a, b) {
        }
        qp(a, b) {
        }
        qv(a, b) {
            this.qq(b);
        }
        ql(a, b) {
            this.qn(b);
        }
        q3() {
            if (this.oz != null) {
                return this.oz;
            }
            return this.o3;
        }
        q4() {
            if (this.o2 != null) {
                return this.o2;
            }
            return this.o8;
        }
        qn(a) {
            if (a.oldItems != null) {
                for (let b of fromEn(a.oldItems)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qm));
                }
            }
            if (a.newItems != null) {
                for (let c of fromEn(a.newItems)) {
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.qm));
                }
            }
            this.mi(true);
        }
        qq(a) {
            if (a.oldItems != null) {
                for (let b of fromEn(a.oldItems)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.qw));
                }
            }
            if (a.newItems != null) {
                for (let c of fromEn(a.newItems)) {
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.qw));
                }
            }
            this.mi(true);
        }
        m6(a, b) {
            this.mi(false);
        }
        m5(a, b) {
            this.mi(true);
        }
        mj(a) {
            super.mj(a);
            if (this.cx(this.b0)) {
                return;
            }
            if (this.eo(a) && !this.es) {
                let b = this.p6;
                if (this.cv()) {
                    if (this.ce.g) {
                        this.ce.t();
                    }
                    this.p6 = this.p7;
                    this.p7 = b;
                }
                else {
                    this.p6 = this.p5;
                    this.p5 = b;
                }
                this.qr(this.p5, this.b0);
                this.mr();
            }
            else {
                if (!this.es) {
                    this.qr(this.p5, this.b0);
                }
                this.qu(this.p5, this.b0);
            }
        }
        get_dc() {
            return true;
        }
        qr(a, b) {
        }
        qu(a, b) {
            this.p4.b1();
        }
        qk(a) {
            let b = { $type: Point_$type, x: this.q5.x, y: this.q5.y };
            if (a.isVertical) {
                if (isNaN_(this.q5.y)) {
                    return new Tuple$2(Boolean_$type, Point_$type, false, b);
                }
                if (isNaN_(this.q5.x)) {
                    b.x = 0;
                    return new Tuple$2(Boolean_$type, Point_$type, true, b);
                }
            }
            else {
                if (isNaN_(this.q5.x)) {
                    return new Tuple$2(Boolean_$type, Point_$type, false, b);
                }
                if (isNaN_(this.q5.y)) {
                    b.y = 0;
                    return new Tuple$2(Boolean_$type, Point_$type, true, b);
                }
            }
            return new Tuple$2(Boolean_$type, Point_$type, true, b);
        }
        lt(a) {
            super.lt(a);
            if (isNaN_(this.q7.x) && isNaN_(this.q7.y)) {
                if (isNaN_(a.x) && isNaN_(a.y)) {
                    this.p4.b0();
                    return;
                }
                else {
                    this.p4.b2();
                    this.q5 = a;
                }
            }
            else {
                this.p4.b2();
                this.q5 = this.q7;
            }
            this.mi(true);
        }
        e9(a, b, c) {
            let d = super.e9(a, b, c);
            if (!this.b0.t()) {
                d = false;
                return d;
            }
            return d;
        }
        get_e5() {
            return this.qd;
        }
        get qd() {
            return this.p8;
        }
        set qd(a) {
            let b = this.p8;
            this.p8 = a;
            this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.p8);
        }
    }
    AnnotationLayer.$t = markType(AnnotationLayer, 'AnnotationLayer', Series.$);
    AnnotationLayer.$$p = markDep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:q6:qz', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:p9:q0', [0, true], 'UseIndex:qe:q1', [0, false], 'UseLegend:qf:q2', [0, false]]);
    return AnnotationLayer;
})();
/**
 * @hidden
 */
export let AnnotationLayerView = /*@__PURE__*/ (() => {
    class AnnotationLayerView extends SeriesView {
        constructor(a) {
            super(a);
            this.bx = null;
            this.by = false;
            this.bz = -1;
            this.bx = a;
        }
        b3() {
            if (this.by) {
                this.by = false;
                this.bz = -1;
                this.bx.q5 = { $type: Point_$type, x: NaN, y: NaN };
                this.bx.mi(true);
            }
        }
        b0() {
            this.by = true;
            if (this.e.g9 != null) {
                this.e.g9.setTimeout(runOn(this, this.b3), 300);
            }
            else {
                this.bz = window.setTimeout(runOn(this, this.b3), 300);
            }
        }
        b2() {
            if (this.by == true) {
                this.by = false;
                if (this.bz != -1) {
                    window.clearTimeout(this.bz);
                    this.bz = -1;
                }
            }
        }
        b1() {
            this.aq();
        }
    }
    AnnotationLayerView.$t = markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
    return AnnotationLayerView;
})();
