/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-angular-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-angular-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-angular-core";
import { IChartScaleLegend_$type } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, logBase } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let BubbleSeries = /*@__PURE__*/ (() => {
    class BubbleSeries extends ScatterBase {
        constructor() {
            super();
            this.wv = null;
            this.wu = null;
            this.vi = null;
            this.va = null;
            this.u9 = null;
            this.u8 = null;
            this.u6 = null;
            this.ab = BubbleSeries.$;
            this.r3 = new ScatterFrame();
            this.r5 = new ScatterFrame();
            this.r1 = new ScatterFrame();
        }
        get_c4() {
            return true;
        }
        bx() {
            return new BubbleSeriesView(this);
        }
        lz(a) {
            super.lz(a);
            this.u5 = a;
        }
        gv() {
            return 0.7;
        }
        p7() {
            if (this.p6 == 0) {
                return 2;
            }
            return super.p7();
        }
        isAttachedTo(a) {
            return this.a1 == a;
        }
        c3() {
            return true;
        }
        k9(a) {
            super.k9(a);
            if (this.vd != null && this.vi != null && this.vi.count > 0) {
                for (let b = 0; b < this.vi.count; b++) {
                    a(this.vi._inner[b]);
                }
            }
        }
        get vc() {
            return this.ve;
        }
        wt(a) {
            let b = typeCast(CustomPaletteBrushScale.$, this.u4);
            let c = typeCast(ValueBrushScale.$, this.u4);
            let d = this.u4;
            if (b != null && this.ck != null) {
                return b.getBrush1(a, this.ck.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.vb);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        }
        get legendReady() {
            return this.ve != null && this.ve.count != 0;
        }
        get minScaleText() {
            let a = this.u3(this.u7).b;
            return (Math.round(a * 1000) / 1000).toString();
        }
        get maxScaleText() {
            let a = this.u3(this.u7).a;
            return (Math.round(a * 1000) / 1000).toString();
        }
        forScaleColors(a) {
            for (let b = 0; b < this.ve.count; b++) {
                if (this.u4 == null || !this.u4.isReady) {
                    return false;
                }
                let c = NaN;
                if (this.vb != null) {
                    c = (this.vb.item(b) - this.vb.minimum) / (this.vb.maximum - this.vb.minimum);
                }
                let d = (this.ve.item(b) - this.ve.minimum) / (this.ve.maximum - this.ve.minimum);
                if (isNaN_(c)) {
                    c = 0;
                }
                if (isNaN_(d)) {
                    d = c;
                }
                let e = this.rd;
                let f = this.wt(b);
                let g = f != null ? f : e;
                a(g, d);
            }
            return true;
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == BubbleSeries.$$p[5]) {
                return this.hx(a, b, this.vx);
            }
            if (c == BubbleSeries.$$p[11]) {
                return this.hx(a, b, this.v7);
            }
            if (c == ScatterBase.$$p[10]) {
                return this.hx(a, b, this.te);
            }
            if (c == ScatterBase.$$p[14]) {
                return this.hx(a, b, this.tm);
            }
            if (c == BubbleSeries.$$p[2]) {
                return this.hx(a, b, this.vs);
            }
            return super.hw(a, b);
        }
        get ve() {
            return this.va;
        }
        set ve(a) {
            if (this.va != a) {
                let b = this.ve;
                this.va = a;
                this.raisePropertyChanged("RadiusColumn", b, this.ve);
            }
        }
        get vd() {
            return this.u9;
        }
        set vd(a) {
            if (this.u9 != a) {
                let b = this.vd;
                this.u9 = a;
                this.raisePropertyChanged("LabelColumn", b, this.vd);
            }
        }
        get vb() {
            return this.u8;
        }
        set vb(a) {
            if (this.u8 != a) {
                let b = this.vb;
                this.u8 = a;
                this.raisePropertyChanged("FillColumn", b, this.vb);
            }
        }
        tp(a, b, c, d, e) {
            if (c <= this.sy) {
                b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            }
            let f = this.sy;
            let g = this.ck;
            let h;
            let i;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(0, d, e, this.rx.d, j);
            let l = new ScalerParams(0, d, e, this.rx.e, j);
            let m = false;
            let n = 0;
            if (this.cd != null) {
                if (this.cd.e3()) {
                    let o = this.cd.ku(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            for (let p = 0; p < c; p++) {
                h = this.sd.item(p);
                i = this.se.item(p);
                let q = { $type: Point_$type, x: this.rx.a.ei(h, k), y: this.rx.b.ei(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!isInfinity(q.x) && !isInfinity(q.y)) {
                    let r = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r)) {
                            let s = { $type: Point_$type, x: h, y: i };
                            b.g.addItem(r, ((() => {
                                let $ret = new OwnedPoint();
                                $ret.a = r;
                                $ret.b = s;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            }
        }
        tx(a, b) {
            let c = typeCast(BubbleSeriesView.$, b);
            let d = c.cv;
            d.m = this.ve;
            super.tx(a, b);
            let e = Math.min(this.sd != null ? this.sd.count : 0, this.se != null ? this.se.count : 0);
            if (e < 1) {
                return;
            }
            c.dh();
            c.di();
        }
        wc() {
            if (this.cd == null) {
                return;
            }
            if (this.a1 == null) {
                return;
            }
            if (this.a1.isItemwise) {
                let a = this.a1;
                this.a1.clearLegendItemsForSeries(this);
                this.wb();
                a.renderItemwiseContent(this);
            }
            if (this.a1.isScale) {
                let b = this.a1;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        }
        static vj(a, b, c, d, e) {
            if (e <= a || isNaN_(e) || isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            let f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        }
        static vk(a, b, c, d, logBase_, e) {
            let f = logBase(e, logBase_);
            let g = logBase(a, logBase_);
            let h = logBase(b, logBase_);
            return BubbleSeries.vj(g, h, c, d, f);
        }
        e9(a, b, c) {
            let d = super.e9(a, b, c);
            if (this.ve == null || this.ck == null || this.ve.count == 0 || this.ck.count != this.ve.count) {
                d = false;
            }
            return d;
        }
        sm(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.te == a || this.tm == a || this.v7 == a) {
                return true;
            }
            return false;
        }
        wb() {
            let a = typeCast(IChartLegend_$type, this.a1);
            if (a == null || this.ck == null) {
                return;
            }
            this.vi = new List$1(UIElement.$, 0);
            let b = typeCast(CustomPaletteBrushScale.$, this.u4);
            let c = typeCast(ValueBrushScale.$, this.u4);
            let d = this.u4;
            let e = this.u2();
            let f = e.b;
            let g = e.a;
            let h = this.ck;
            for (let i = 0; i < h.count; i++) {
                let j = null;
                if (c != null && this.vb != null) {
                    let k = this.vb.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                let l = new ContentControl();
                let m = this.vd != null && this.vd.item(i) != null ? this.vd.item(i).toString() : "";
                l.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    return $ret;
                })());
                let n = this.nc;
                if (n == null) {
                    n = this.b0.bl(this.b5);
                }
                l.ah = n;
                this.vi.add(l);
            }
        }
        k0(a, b, c, d) {
            super.k0(a, b, c, d);
            if (this.u7 != null) {
                this.u7.aa();
            }
            if (this.u4 != null) {
                this.u4.x();
            }
            this.wc();
        }
        li() {
            super.li();
            this.wc();
        }
        lo() {
            super.lo();
            this.wc();
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    if (this.u7 != null) {
                        this.u7.aa();
                    }
                    if (this.u4 != null) {
                        this.u4.x();
                    }
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.ve);
                        c.deregisterColumn(this.vb);
                        c.deregisterColumn(this.vd);
                        this.ve = null;
                        this.vb = null;
                        this.vd = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.ve = this.ch(this.v7);
                        if (!stringIsNullOrEmpty(this.vs)) {
                            this.vb = this.ch(this.vs);
                        }
                        this.vd = this.cj(this.vx);
                    }
                    this.mi(false);
                    this.wc();
                    break;
                case BubbleSeries.$$p[11]:
                    if (this.u7 != null) {
                        this.u7.aa();
                    }
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.ve);
                        this.ve = this.ch(this.v7);
                        this.wc();
                    }
                    break;
                case "RadiusColumn":
                    if (this.u7 != null) {
                        this.u7.aa();
                    }
                    this.ry.cx.g$i();
                    this.mi(false);
                    this.lq();
                    break;
                case BubbleSeries.$$p[12]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case BubbleSeries.$$p[13]:
                    this.mi(false);
                    this.lp();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.wc();
                    break;
                case BubbleSeries.$$p[3]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.mi(false);
                    this.wc();
                    this.lp();
                    break;
                case BubbleSeries.$$p[4]:
                case BubbleSeries.$$p[8]:
                case BubbleSeries.$$p[7]:
                case BubbleSeries.$$p[6]:
                    this.mi(false);
                    this.wc();
                    this.lp();
                    break;
                case "FillColumn":
                    this.mi(false);
                    this.lp();
                    break;
                case BubbleSeries.$$p[2]:
                    if (this.u4 != null) {
                        this.u4.x();
                    }
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.vb);
                        this.vb = this.ch(this.vs);
                        this.wc();
                    }
                    break;
                case BubbleSeries.$$p[5]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.vd);
                        this.vd = this.cj(this.vx);
                        this.wc();
                    }
                    break;
                case "ActualLegend":
                    let e = typeCast(IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        let f = typeCast(IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        let g = typeCast(IChartScaleLegend_$type, e);
                        let h = true;
                        let i = null;
                        if (this.cd != null) {
                            for (let j of fromEnum(this.cd.series)) {
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                        }
                    }
                    this.wc();
                    break;
                case "SeriesViewer":
                    this.wc();
                    break;
            }
        }
        updateSizeScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.ve != null) {
                a.b = this.ve.minimum;
                a.a = this.ve.maximum;
            }
            if (this.u7 != null) {
                this.u7.ab(a.b, a.a);
            }
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.vb != null) {
                a.b = this.vb.minimum;
                a.a = this.vb.maximum;
            }
            if (this.u4 != null) {
                this.u4.z(a.b, a.a);
            }
        }
        u3(a) {
            let b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.ve != null) {
                b.b = this.ve.minimum;
                b.a = this.ve.maximum;
            }
            if (a != null) {
                a.x();
                if (this.vh) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        }
        u2() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.vb != null) {
                a.b = this.vb.minimum;
                a.a = this.vb.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.u4);
            if (b != null) {
                b.s();
                if (this.vf && this.u4.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        we(a, b, c, d) {
            let e = c.width;
            if (!this.b0.bu.isEmpty) {
                e = this.b0.bu.width;
            }
            else if (this.cd != null && !this.cd.su.isEmpty) {
                e = this.cd.su.width;
            }
            let f = DeviceUtils.c(e);
            this.u6 = this.u7 || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (this.u6 != null) {
                let g = this.u6.minimumValue;
                let h = this.u6.maximumValue;
                let i = this.u6.logarithmBase;
                let j = this.u3(this.u6);
                let k = j.b;
                let l = j.a;
                if (this.u6.isLogarithmic) {
                    for (let m = 0; m < b.count; m++) {
                        b._inner[m] = BubbleSeries.vk(k, l, g, h, i, b._inner[m]);
                    }
                }
                else {
                    for (let n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.vj(k, l, g, h, b._inner[n]);
                    }
                }
            }
            let o = 1;
            o = DeviceUtils.d();
            let p = this.u7 == null;
            if (d) {
                let q = c.width / e;
                for (let r = 0; r < b.count; r++) {
                    if (p) {
                        b._inner[r] = b._inner[r] / o;
                    }
                    b._inner[r] = b._inner[r] * q;
                }
            }
            for (let s = 0; s < a.count; s++) {
                let t = a._inner[s];
                if (p && !d) {
                    t.width = Math.max(0, b._inner[s] / o);
                    t.height = Math.max(0, b._inner[s] / o);
                }
                else {
                    t.width = Math.max(0, b._inner[s]);
                    t.height = Math.max(0, b._inner[s]);
                }
            }
        }
        wd(a) {
            let b = typeCast(BubbleSeriesView.$, this.bz);
            this.u5.b3 = false;
            if (b != null) {
                b.b3 = false;
            }
            let c = typeCast(CustomPaletteBrushScale.$, this.u4);
            let d = typeCast(ValueBrushScale.$, this.u4);
            let e = this.u4;
            let f = this.u2();
            let g = f.b;
            let h = f.a;
            let i = this.u4 == null || !this.u4.isReady || (d != null && this.vs == null);
            if (i) {
                this.u5.dg();
                if (b != null) {
                    b.dg();
                }
                return;
            }
            this.u5.b3 = true;
            if (b != null) {
                b.b3 = true;
            }
            let j = a.count;
            let k = this.ck;
            for (let l = 0; l < j; l++) {
                let m = a._inner[l];
                let n = typeCast(DataContext.$, m.content);
                if (n != null) {
                    let o = null;
                    let p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.vb != null) {
                        let q = this.vb.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.rf == null) {
                            o = this.rd;
                        }
                        else {
                            o = this.rf;
                        }
                    }
                    let r = null;
                    if (this.rg == null) {
                        r = this.re;
                    }
                    else {
                        r = this.rg;
                    }
                    if (this.vg && o != null) {
                        r = o;
                    }
                    if (r != null && !isNaN_(this.vm)) {
                        r = BrushUtil.l(r, this.vm);
                    }
                    if (o != null && !isNaN_(this.vl)) {
                        o = BrushUtil.l(o, this.vl);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ht(c);
            let e = d == null ? NaN : this.gb(d, "XMemberPath");
            let f = d == null ? NaN : this.gb(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.a = 13;
            g.l = e;
            g.p = this.te != null ? this.te : "X";
            g.q = this.ta != null ? this.ta : "X:";
            g.r = this.tc != null ? this.tc : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.p = this.tm != null ? this.tm : "Y";
            h.q = this.ti != null ? this.ti : "Y:";
            h.r = this.tk != null ? this.tk : "";
            let i = new DataLegendSeriesContext();
            i.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.b = this.av();
            if (!stringIsNullOrEmpty(this.v7)) {
                let j = d == null ? NaN : this.gb(d, "RadiusMemberPath");
                let k = new DataLegendSeriesValueInfo();
                k.l = j;
                k.a = 11;
                k.p = this.v7 != null ? this.v7 : "Radius";
                k.q = this.v3 != null ? this.v3 : "R:";
                k.r = this.v5 != null ? this.v5 : "";
                i.f.add(k);
            }
            else if (this.u6 != null) {
                let l = new DataLegendSeriesValueInfo();
                l.l = this.u6.maximumValue;
                l.a = 11;
                l.p = this.v7 != null ? this.v7 : "Radius";
                l.q = this.v3 != null ? this.v3 : "R:";
                l.r = this.v5 != null ? this.v5 : "";
                i.f.add(l);
            }
            if (!stringIsNullOrEmpty(this.vs)) {
                let m = d == null ? NaN : this.gb(d, "FillMemberPath");
                let n = new DataLegendSeriesValueInfo();
                n.l = m;
                n.a = 12;
                n.p = this.vs != null ? this.vs : "Fill";
                n.q = this.vo != null ? this.vo : "F:";
                n.r = this.vq != null ? this.vq : "";
                i.f.add(n);
            }
            return i;
        }
        get actualMarkerBrush() {
            return this.rd;
        }
    }
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:vo:wf', [2, null], 'FillMemberAsLegendUnit:vq:wg', [2, null], 'FillMemberPath:vs:wh', [2], 'FillScale:u4:wi', [BrushScale.$], 'FillScaleUseGlobalValues:vf:wj', [0, false], 'LabelMemberPath:vx:wk', [2], 'MarkerBrushBrightness:vl:wl', [1, NaN], 'MarkerOutlineBrightness:vm:wm', [1, NaN], 'MarkerOutlineUsesFillScale:vg:wn', [0, false], 'RadiusMemberAsLegendLabel:v3:wo', [2, null], 'RadiusMemberAsLegendUnit:v5:wp', [2, null], 'RadiusMemberPath:v7:wq', [2, null], 'RadiusScale:u7:wr', [SizeScale.$], 'RadiusScaleUseGlobalValues:vh:ws', [0, false]]);
    return BubbleSeries;
})();
/**
 * @hidden
 */
export let CustomPaletteBrushScale = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScale extends BrushScale {
        constructor() {
            super();
        }
        getBrush1(a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return super.getBrush(a % this.brushes.count);
            }
            let c = BubbleSeries.vj(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        }
        get_isReady() {
            return this.brushes != null && this.brushes.count > 0;
        }
    }
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
})();
/**
 * @hidden
 */
export let BubbleSeriesView = /*@__PURE__*/ (() => {
    class BubbleSeriesView extends ScatterBaseView {
        constructor(a) {
            super(a);
            this.df = null;
            this.df = a;
            this.cx = new ScatterTrendLineManager();
        }
        as() {
            super.as();
            if (!this.q) {
                this.b1.qd = Defaults.e;
            }
        }
        cu() {
            return new BubbleMarkerManager((a) => this.cy.item(a), (a) => this.cw.rx.c.item(a), runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz));
        }
        dh() {
            let a = this.cv;
            this.df.we(a.n, a.o, this.bu, this == this.e.bz);
            this.aq();
        }
        di() {
            let a = this.cv;
            this.df.wd(a.n);
        }
        dg() {
            let a = this.cv;
            for (let b of fromEnum(a.n)) {
                let c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a6.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.df.title + "</span><br/><span>" + "(${item." + this.df.te + "}, ${item." + this.df.tm + "})</span>";
            if (!stringIsNullOrEmpty(this.df.v7)) {
                a += "<span>, Radius: ${item." + this.df.v7 + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
})();
