/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { Defaults } from "./Defaults";
import { KDTree2D } from "./KDTree2D";
import { Point_$type, typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, markDep, toNullable } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-angular-core";
import { boxArray$1, arrayShallowClone } from "igniteui-angular-core";
import { dateNow } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
/**
 * @hidden
 */
export let HighDensityScatterSeries = /*@__PURE__*/ (() => {
    class HighDensityScatterSeries extends Series {
        constructor() {
            super();
            this.qh = null;
            this.qj = null;
            this.rs = 0;
            this.ql = false;
            this.q7 = Defaults.aq.o;
            this.q6 = Defaults.aq.n;
            this.q5 = Defaults.aq.m;
            this.q4 = Defaults.aq.l;
            this.q3 = Defaults.ap.o;
            this.q2 = Defaults.ap.n;
            this.q1 = Defaults.ap.m;
            this.q0 = Defaults.ap.l;
            this.p9 = null;
            this.qe = null;
            this.qf = null;
            this.qa = null;
            this.qc = null;
            this.qn = false;
            this.rt = 0;
            this.rv = 0;
            this.rp = 0;
            this.ro = 0;
            this.progressiveLoadStatusChanged = null;
            this.qs = null;
            this.qy = 0;
            this.qx = 0;
            this.qz = 0;
            this.re = 0;
            this.rc = 0;
            this.rd = 0;
            this.rf = 0;
            this.rh = 0;
            this.rj = 0;
            this.ri = 0;
            this.rg = 0;
            this.qu = 0;
            this.qv = 0;
            this.qw = 0;
            this.qt = 0;
            this.rr = 0;
            this.rq = 0;
            this.p6 = null;
            this.ru = 0;
            this.qm = false;
            this._itemIndexes = null;
            this.p7 = null;
            this.p4 = null;
            this.qg = null;
            this.ab = HighDensityScatterSeries.$;
            this.el = false;
        }
        get_d5() {
            return true;
        }
        gu() {
            if (!isNaN_(this.gt)) {
                return super.gu();
            }
            return Defaults.q;
        }
        get_ec() {
            return true;
        }
        get qi() {
            return this.qh;
        }
        set qi(a) {
            if (this.qh != a) {
                let b = this.qi;
                this.qh = a;
                this.raisePropertyChanged("XColumn", b, this.qi);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ht(c);
            let e = d == null ? NaN : this.gb(d, "XMemberPath");
            let f = d == null ? NaN : this.gb(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.l = e;
            g.a = 13;
            g.p = this.se != null ? this.se : "X";
            g.q = this.sa != null ? this.sa : "X:";
            g.r = this.sc != null ? this.sc : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.p = this.sm != null ? this.sm : "Y";
            h.q = this.si != null ? this.si : "Y:";
            g.r = this.sk != null ? this.sk : "";
            let i = new DataLegendSeriesContext();
            i.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.b = this.av();
            return i;
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == HighDensityScatterSeries.$$p[10]) {
                return this.hx(a, b, this.se);
            }
            if (c == HighDensityScatterSeries.$$p[14]) {
                return this.hx(a, b, this.sm);
            }
            return super.hw(a, b);
        }
        get qk() {
            return this.qj;
        }
        set qk(a) {
            if (this.qj != a) {
                let b = this.qk;
                this.qj = a;
                this.raisePropertyChanged("YColumn", b, this.qk);
            }
        }
        s1() {
            if (this.p9 == null) {
                return;
            }
            this.p9.s();
            let a = this.p9;
            a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.so));
            this.p9 = null;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    if (this.cd != null) {
                        let e = this.getEffectiveViewport1(this.b0);
                        this.qm = !e.isEmpty;
                    }
                    break;
                case "FastItemsSource":
                    this.s1();
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.qi);
                        c.deregisterColumn(this.qk);
                        this.qi = null;
                        this.qk = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.qi = this.ch(this.se);
                        this.qk = this.ch(this.sm);
                    }
                    if ((this.qd != null && !this.qd.c0()) || (this.qb != null && !this.qb.c0())) {
                        this.mi(false);
                    }
                    this.lq();
                    break;
                case HighDensityScatterSeries.$$p[7]:
                    let f = this.qa;
                    this.qa = this.qb;
                    this.s1();
                    if (f != null) {
                        f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.sr));
                    }
                    if (this.qa != null) {
                        let g = this.qa;
                        g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.sr));
                    }
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    if ((this.qb != null && !this.qb.c0()) || (d == null && c != null)) {
                        this.mi(false);
                    }
                    break;
                case HighDensityScatterSeries.$$p[11]:
                    let h = this.qc;
                    this.qc = this.qd;
                    this.s1();
                    if (h != null) {
                        h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.sr));
                    }
                    if (this.qc != null) {
                        let i = this.qc;
                        i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.sr));
                    }
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    if ((this.qd != null && !this.qd.c0()) || (d == null && c != null)) {
                        this.mi(false);
                    }
                    break;
                case "MouseOverEnabled":
                    this.qn = this.el;
                    this.mi(false);
                    break;
                case HighDensityScatterSeries.$$p[10]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.qi);
                        this.qi = this.ch(this.se);
                    }
                    break;
                case "XColumn":
                    this.s1();
                    if (this.qb != null && !this.qb.c0()) {
                        this.mi(false);
                    }
                    this.lq();
                    break;
                case HighDensityScatterSeries.$$p[14]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.qk);
                        this.qk = this.ch(this.sm);
                    }
                    break;
                case "YColumn":
                    this.s1();
                    if (this.qd != null && !this.qd.c0()) {
                        this.mi(false);
                    }
                    this.lq();
                    break;
                case HighDensityScatterSeries.$$p[6]:
                    this.s1();
                    this.mi(false);
                    this.lp();
                    break;
                case HighDensityScatterSeries.$$p[3]:
                    this.mi(false);
                    this.lp();
                    break;
                case HighDensityScatterSeries.$$p[1]:
                    this.mi(false);
                    this.lp();
                    break;
                case HighDensityScatterSeries.$$p[0]:
                case HighDensityScatterSeries.$$p[2]:
                    if (!this.p8.b1(this.tk, this.tj)) {
                        return;
                    }
                    this.sv();
                    this.mi(false);
                    this.lp();
                    break;
                case HighDensityScatterSeries.$$p[4]:
                    this.rs = Math.max(typeGetValue(d) - 1, 0);
                    this.ql = this.rs > 0;
                    this.mi(false);
                    this.lp();
                    break;
                case HighDensityScatterSeries.$$p[5]:
                    this.mi(false);
                    this.lp();
                    break;
            }
        }
        sv() {
            this.q4 = this.tk.l;
            this.q7 = this.tk.o;
            this.q6 = this.tk.n;
            this.q5 = this.tk.m;
            this.q0 = this.tj.l;
            this.q3 = this.tj.o;
            this.q2 = this.tj.n;
            this.q1 = this.tj.m;
            this.o8 = BrushUtil.g(truncate(this.q4), truncate(this.q7), truncate(this.q6), truncate(this.q5));
            this.o3 = BrushUtil.g(truncate(this.q0), truncate(this.q3), truncate(this.q2), truncate(this.q1));
        }
        qp(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        qo(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        sr(a, b) {
            this.s1();
            this.mi(false);
        }
        get rb() {
            return this.q3 - this.q7;
        }
        get ra() {
            return this.q2 - this.q6;
        }
        get q9() {
            return this.q1 - this.q5;
        }
        get q8() {
            return this.q0 - this.q4;
        }
        e9(a, b, c) {
            let d = super.e9(a, b, c);
            if (this.qd == null || this.qb == null || this.qb.bh == null || this.qd.bh == null || this.qk == null || this.qi == null || this.qk.count < 1 || this.qi.count < 1 || this.qk.count != this.qi.count || this.qb.lv == this.qb.lu || this.qd.lv == this.qd.lu || this.pz.isEmpty) {
                d = false;
            }
            return d;
        }
        get rz() {
            return this.rt;
        }
        set rz(a) {
            let b = this.rt;
            this.rt = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.rt);
        }
        mj(a) {
            super.mj(a);
            this.st(a, this.b0);
        }
        st(a, b) {
            if (this.cx(b)) {
                return;
            }
            if (this.p9 == null && !this.qr) {
                let c = new List$1(KDPointData.$, 2, this.qi.count);
                let d = this.qb;
                let e = this.qd;
                let f = new Rect(0, 0, 0, 1, 1);
                let g = new Rect(0, 0, 0, 1, 1);
                let h = new ScalerParams(1, f, g, d.cg);
                let i = new ScalerParams(1, f, g, e.cg);
                let j;
                let k;
                for (let l = 0; l < this.qi.count; l++) {
                    j = d.ei(this.qi.item(l), h);
                    k = e.ei(this.qk.item(l), i);
                    if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k)) {
                        c.add(((() => {
                            let $ret = new KDPointData();
                            $ret.a = j;
                            $ret.b = k;
                            $ret.c = l;
                            return $ret;
                        })()));
                    }
                }
                if (this.qq) {
                    this.ro = 1;
                    this.rp = truncate(logBase(c.count, 2)) + 3;
                    this.rz = truncate(((this.ro / this.rp) * 100));
                    if (this.progressiveLoadStatusChanged != null) {
                        this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rz));
                    }
                    this.p9 = KDTree2D.b(c.toArray(), 1);
                    let m = this.p9;
                    m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.so));
                    if (!this.p9.f(this.g9)) {
                        let n = this.p9;
                        n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.so));
                    }
                    this.lp();
                }
                else {
                    let o = dateNow();
                    this.p9 = new KDTree2D(0, c.toArray(), 1);
                    let p = dateNow();
                }
            }
            if (this.qq && !this.qr) {
                this.su(b);
            }
            else {
                this.sw(b);
            }
        }
        k0(a, b, c, d) {
            super.k0(a, b, c, d);
            this.s1();
            let e = false;
            if (this.qb != null && !this.qb.c0()) {
                e = true;
            }
            if (this.qd != null && !this.qd.c0()) {
                e = true;
            }
            if (e) {
                this.mi(false);
            }
            this.lq();
        }
        sq(a) {
            let b = a;
            let c = this.rr * this.rq;
            if (this.qn) {
                if (this._itemIndexes == null || this._itemIndexes.length != c) {
                    this._itemIndexes = new Array(c);
                    for (let d = 0; d < c; d++) {
                        this._itemIndexes[d] = 0;
                    }
                }
                else {
                    for (let e = 0; e < c; e++) {
                        this._itemIndexes[e] = 0;
                    }
                }
            }
        }
        sw(a) {
            let b;
            let c;
            let d = null;
            if (a.q) {
                d = this._itemIndexes;
            }
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            let f = a;
            let g = this.getEffectiveViewport1(a);
            this.qe = new ScalerParams(0, b, c, this.qa.cg, g);
            this.qf = new ScalerParams(0, b, c, this.qc.cg, g);
            this.sp(a);
            this.sq(a);
            let h = this.rr * this.rq;
            if (this.p7 == null || this.p7.length != h) {
                this.p7 = new Array(h);
                this.p4 = new Array(h);
            }
            let i = this.p7.length;
            let j = this.p7;
            let k = this.p4;
            for (let l = 0; l < i; l++) {
                j[l] = 0;
                k[l] = 0;
            }
            this.rv = truncate(Math.round(this.ft));
            this.p6 = f.by();
            let m = this.p6.length;
            let n = this.p6;
            for (let o = 0; o < m; o++) {
                n[o] = 0;
            }
            let p = this.rm;
            let q = this.rl;
            if (isNaN_(p) || isInfinity(p)) {
                p = 0;
            }
            if (isNaN_(q) || isInfinity(q)) {
                q = 50;
            }
            this.qy = Math.min(p, q);
            this.qx = Math.max(p, q);
            if (this.qy < 0) {
                this.qy = 0;
            }
            if (this.qx < 0) {
                this.qx = 0;
            }
            this.qz = this.qx - this.qy;
            if (this.qr) {
                this.ss(a);
            }
            else {
                this.s3(a);
            }
            f.b9();
            if (a.q) {
                this._itemIndexes = d;
                this.p8.ca();
            }
        }
        su(a) {
            if (this.p9 == null) {
                return;
            }
            this.sw(a);
        }
        so(a, b) {
            this.p8.b8(() => {
                if (this.ro < this.rp - 1) {
                    this.ro++;
                }
                this.rz = truncate(((this.ro / this.rp) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rz));
                }
                this.su(this.b0);
                this.lp();
                if (this.p9 != null) {
                    if (!this.p9.f(this.g9)) {
                        let c = this.p9;
                        c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(this, this.so));
                        this.rz = 100;
                        if (this.progressiveLoadStatusChanged != null) {
                            this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rz));
                        }
                    }
                }
            });
        }
        ss(a) {
            let b = arrayShallowClone(this.qi.asArray());
            this.qb.hm(boxArray$1(b), 0, b.length, this.qe);
            let c = arrayShallowClone(this.qk.asArray());
            this.ru = 0;
            let d = this.rs;
            let e = this.ql;
            let f = this.p7.length;
            this.qd.hm(boxArray$1(c), 0, c.length, this.qf);
            let g = 255 << 24 | truncate(this.q7) << 16 | truncate(this.q6) << 8 | truncate(this.q5);
            for (let h = 0; h < b.length; h++) {
                let i = truncate(b[h]);
                let j = truncate(c[h]);
                i = truncate(Math.floor(i));
                j = truncate(Math.floor(j));
                if (i < 0 || i >= this.rr || j < 0 || j >= this.rq) {
                    continue;
                }
                if (e) {
                    let k = i - d;
                    let l = i + d;
                    l = l > (this.rr - 1) ? (this.rr - 1) : l;
                    k = k < 0 ? 0 : k;
                    let m = j + d;
                    let n = j - d;
                    for (let o = k; o <= l; o++) {
                        for (let p = n; p <= m; p++) {
                            let q = (p * this.rr) + o;
                            if (q < 0 || q > f - 1) {
                                continue;
                            }
                            this.p7[q] = this.p7[q] + 1;
                            this.p4[q] = 1;
                            this.ru++;
                            if (this.qn) {
                                this._itemIndexes[q] = h + 1;
                            }
                        }
                    }
                }
                else {
                    let r = (j * this.rr) + i;
                    this.p7[r] = this.p7[r] + 1;
                    this.p4[r] = 1;
                    this.ru++;
                    if (this.qn) {
                        this._itemIndexes[r] = h + 1;
                    }
                }
            }
            this.sx();
        }
        s3(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.p9 == null) {
                return;
            }
            if (this.qs == null) {
                this.qs = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
            }
            else {
                this.qs.clear();
            }
            let e = c.left;
            let f = c.right;
            let g = c.top;
            let h = c.bottom;
            this.ri = c.top;
            this.rg = c.height;
            this.rh = c.left;
            this.rj = c.width;
            this.re = b.top;
            this.rc = b.height;
            this.rd = b.left;
            this.rf = b.width;
            let i = this.getEffectiveViewport1(a);
            this.qu = (i.left - this.rd) / this.rf;
            this.qv = (i.top - this.re) / this.rc;
            let j = (i.right - this.rd) / this.rf;
            this.qw = j - this.qu;
            let k = (i.bottom - this.re) / this.rc;
            this.qt = k - this.qv;
            if (this.qm) {
                e = (e - this.qu) / this.qw;
                f = (f - this.qu) / this.qw;
                g = (g - this.qv) / this.qt;
                h = (h - this.qv) / this.qt;
            }
            let l = this.ft / b.width * c.width;
            let m = this.ft / b.height * c.height;
            let n = Math.min(l, m);
            let o = ((() => {
                let $ret = new SearchArgs();
                $ret.c = e;
                $ret.a = f;
                $ret.d = g;
                $ret.b = h;
                $ret.e = l;
                $ret.f = m;
                $ret.g = 0x7FFFFFFF;
                return $ret;
            })());
            this.p9.t(this.qs, o, 0, 1, 0, 1);
            let p;
            this.ru = 0;
            for (let q = 0; q < this.qs.count; q++) {
                p = this.qs._inner[q];
                this.sy(p);
            }
            this.sx();
        }
        sy(a) {
            if (a.g) {
                return;
            }
            let b = a.e != null && a.e.a;
            let c = a.a == null ? 0 : a.a.length;
            let d = (a.h - c) + 1;
            if (b && d > 0) {
            }
            else {
                d = 1;
            }
            this.s0(a.b, d, b, a.e);
            if (c > 0 && !b) {
                let e;
                for (let f = 0; f < c; f++) {
                    e = a.a[f];
                    this.s0(e, d, false, a.e);
                }
            }
            if (a.e != null) {
                a.e.a = false;
            }
        }
        en(a) {
            let b = this.cd != null ? this.cd.sf : Rect.empty;
            let c = this.cd != null ? this.cd.su : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.pt(this.b0);
            let f = new ScalerParams(0, d, d, this.qb.cg, e);
            let g = new ScalerParams(0, d, d, this.qd.cg, e);
            let h = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
            let i = this.qb != null && this.qi != null && h < this.qi.count ? this.qb.ei(this.qi.item(h), f) : NaN;
            let j = this.qd != null && this.qk != null && h < this.qk.count ? this.qd.ei(this.qk.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b8 != null) {
                this.b8.au(this.cd, b, true);
            }
            return h >= 0;
        }
        s0(a, b, c, d) {
            let e = this.rx(b);
            let f = a.c;
            let g = this.rs;
            if (c) {
                let h = d.d;
                let i = d.b;
                let j = d.e;
                let k = d.c;
                if (this.qm) {
                    h = this.qu + this.qw * h;
                    i = this.qu + this.qw * i;
                    j = this.qv + this.qt * j;
                    k = this.qv + this.qt * k;
                }
                let l = truncate((this.rd + this.rf * (h - this.rh) / this.rj));
                let m = truncate((this.rd + this.rf * (i - this.rh) / this.rj));
                let n = truncate((this.re + this.rc * (j - this.ri) / this.rg));
                let o = truncate((this.re + this.rc * (k - this.ri) / this.rg));
                l = truncate(Math.floor(l));
                m = truncate(Math.floor(m));
                n = truncate(Math.floor(n));
                o = truncate(Math.floor(o));
                if (this.ql) {
                    l -= g;
                    m += g;
                    n -= g;
                    o += g;
                }
                let p = ((m - l) + 1) * ((o - n) + 1);
                let q = b / p;
                let r = q;
                for (let s = l; s <= m; s++) {
                    for (let t = n; t <= o; t++) {
                        this.sz(f, s, t, q, r);
                    }
                }
            }
            else {
                let u = a.a;
                let v = a.b;
                if (this.qm) {
                    u = this.qu + this.qw * u;
                    v = this.qv + this.qt * v;
                }
                let w = truncate((this.rd + this.rf * (u - this.rh) / this.rj));
                let x = truncate((this.re + this.rc * (v - this.ri) / this.rg));
                w = truncate(Math.floor(w));
                x = truncate(Math.floor(x));
                if (this.ql) {
                    let y = w - g;
                    let z = w + g;
                    let aa = x + g;
                    let ab = x - g;
                    let ac = ((z - y) + 1) * ((aa - ab) + 1);
                    let ad = b / ac;
                    let ae = ad;
                    for (let af = y; af <= z; af++) {
                        for (let ag = ab; ag <= aa; ag++) {
                            this.sz(f, af, ag, ad, ae);
                        }
                    }
                }
                else {
                    this.sz(f, w, x, b, 1);
                }
            }
        }
        rw(a, b) {
            return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.q7 + a * this.rb))) << 16 | truncate(Math.floor(b * (this.q6 + a * this.ra))) << 8 | truncate(Math.floor(b * (this.q5 + a * this.q9)));
        }
        rx(a) {
            return 255 << 24 | truncate(Math.floor((this.q7 + a * this.rb))) << 16 | truncate(Math.floor((this.q6 + a * this.ra))) << 8 | truncate(Math.floor((this.q5 + a * this.q9)));
        }
        rk(a) {
            return (a >> 24 & 255) / 255;
        }
        sz(a, b, c, d, e) {
            if (b < 0 || b >= this.rr || c < 0 || c >= this.rq) {
                return;
            }
            let f = (c * this.rr) + b;
            this.p7[f] = this.p7[f] + d;
            this.p4[f] = this.p4[f] + e;
            if (this.qn) {
                this._itemIndexes[f] = a + 1;
            }
            this.ru += truncate(d);
        }
        sx() {
            let a = 0;
            let b = 0;
            let c = this.qz;
            let d = this.qy;
            let e = this.qx;
            let f = this.p7.length;
            let g = this.p7;
            let h = this.p4;
            let i = this.p6;
            let j = NaN;
            let k = NaN;
            let l = 0;
            let m = 0;
            for (let n = 0; n < f; n++) {
                a = g[n];
                if (a != 0) {
                    b = h[n];
                    if (a >= e) {
                        a = 1;
                    }
                    else if (a <= d) {
                        a = 0;
                    }
                    else {
                        a = (a - d) / (c);
                    }
                    if (b > 1) {
                        b = 1;
                    }
                    if (b < 0.2) {
                        b = 0.2;
                    }
                    if (j != a || k != b) {
                        l = this.rw(a, b);
                        j = a;
                        k = b;
                    }
                    i[m] = l >> 16 & 255;
                    i[m + 1] = l >> 8 & 255;
                    i[m + 2] = l & 255;
                    i[m + 3] = l >> 24 & 255;
                }
                m += 4;
            }
        }
        sp(a) {
            let b = a;
            b.b6();
        }
        bx() {
            return new HighDensityScatterSeriesView(this);
        }
        lz(a) {
            super.lz(a);
            this.p8 = a;
        }
        ap(a) {
            if (a != null && a == this.qb && this.qi != null) {
                return new AxisRange(this.qi.minimum, this.qi.maximum);
            }
            if (a != null && a == this.qd && this.qk != null) {
                return new AxisRange(this.qk.minimum, this.qk.maximum);
            }
            return null;
        }
        m5(a, b) {
            if (this.cd != null) {
                let c = this.getEffectiveViewport1(this.b0);
                this.qm = !c.isEmpty;
            }
            this.mi(false);
        }
        m6(a, b) {
            this.mi(false);
        }
        ht(a) {
            if (!this.qn || this._itemIndexes == null || this.cd == null || this.ck == null || this._itemIndexes.length != (this.rr * this.rq)) {
                return null;
            }
            let b = this.cd.sf;
            let c = (a.x - b.left) / b.width;
            let d = (a.y - b.top) / b.height;
            let e = truncate(Math.round(this.pz.left + (this.pz.width * c)));
            let f = truncate(Math.round(this.pz.top + (this.pz.height * d)));
            let g = this.r0(e, f);
            if (g < 0 || g > this._itemIndexes.length - 1) {
                return null;
            }
            let h = this._itemIndexes[g] - 1;
            if (h < 0 || h > this.ck.count) {
                return null;
            }
            return this.ck.item(h);
        }
        r0(a, b) {
            let c = (this.rr * b) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            let d = 1;
            c = (this.rr * (b - d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b + d)) + a;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b - d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b + d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b - d)) + a + 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            c = (this.rr * (b + d)) + a - 1;
            if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
                return c;
            }
            return 0;
        }
        s2(a, b, c) {
            this.p6 = a;
            this.rr = b;
            this.rq = c;
        }
        get_e3() {
            return true;
        }
        set_e3(a) {
            super.set_e3(a);
        }
        kx(a, b) {
            super.kx(a, b);
            this.p8.b7();
            if (this.bz != null) {
                this.bz.b7();
            }
            this.lp();
        }
        mk(a, b) {
            super.mk(a, b);
            if (!this.ez) {
                this.b0.a2(b);
                return;
            }
            this.b0.a2(b);
            if (this.cx(this.bz)) {
                return;
            }
            let c = typeCast(HighDensityScatterSeriesView.$, this.bz);
            let d = new ScatterFrame();
            this.st(false, c);
            this.ez = false;
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.cx(g)) {
                return;
            }
            if (this.qg == null) {
                this.qg = new ScatterFrame();
            }
            this.st(false, f);
        }
        ku() {
            super.ku();
            this.qb = null;
            this.qd = null;
        }
    }
    HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    HighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:tj:s4', [Color.$, Defaults.ap], 'HeatMaximum:rl:s5', [1, 50], 'HeatMinimumColor:tk:s6', [Color.$, Defaults.aq], 'HeatMinimum:rm:s7', [1, 0], 'PointExtent:ry:s8', [1, 1], 'ProgressiveLoad:qq:s9', [0, true], 'UseBruteForce:qr:ta', [0, false], 'XAxis:qb:tb', [NumericXAxis.$, null], 'XMemberAsLegendLabel:sa:tc', [2, null], 'XMemberAsLegendUnit:sc:td', [2, null], 'XMemberPath:se:te', [2, null], 'YAxis:qd:tf', [NumericYAxis.$, null], 'YMemberAsLegendLabel:si:tg', [2, null], 'YMemberAsLegendUnit:sk:th', [2, null], 'YMemberPath:sm:ti', [2, null]]);
    return HighDensityScatterSeries;
})();
/**
 * @hidden
 */
export let HighDensityScatterSeriesView = /*@__PURE__*/ (() => {
    class HighDensityScatterSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.bz = null;
            this.bx = null;
            this.b5 = 0;
            this.b4 = 0;
            this.b2 = null;
            this.b3 = null;
            this.b0 = null;
            this.bz = a;
        }
        as() {
            super.as();
            if (!this.q) {
                this.bz.tk = Defaults.aq;
                this.bz.tj = Defaults.ap;
                this.bz.o3 = Defaults.al;
                this.bz.o8 = Defaults.ak;
            }
        }
        ca() {
            this.bz.s2(this.bx, this.b5, this.b4);
        }
        b6() {
            if (this.b2 == null) {
                this.b2 = this.e.g9.createElement("canvas");
                let a = this.e.g9.get2DCanvasContext(this.b2);
                this.b0 = new RenderingContext(new CanvasViewRenderer(), a);
            }
            let b;
            if (this.p) {
                b = this.bu;
            }
            else {
                b = this.e.cd.sk();
            }
            let c = truncate(Math.round(b.left));
            let d = truncate(Math.round(b.top));
            let e = truncate(Math.round(b.width));
            let f = truncate(Math.round(b.height));
            let g = this.b5;
            let h = this.b4;
            this.b5 = e;
            this.b4 = f;
            if (g != this.b5 || h != this.b4 || this.bx == null) {
                this.b2.setAttribute("width", e.toString());
                this.b2.setAttribute("height", f.toString());
                this.b3 = this.b0.g().getImageData(0, 0, e, f);
                let imageDataArray_ = this.b3.data;
                this.bx = imageDataArray_;
            }
            this.bz.s2(this.bx, this.b5, this.b4);
        }
        by() {
            return this.bx;
        }
        b9() {
            let a = truncate(Math.round(this.bu.left));
            let b = truncate(Math.round(this.bu.left));
            let c = truncate(Math.round(this.bu.width));
            let d = truncate(Math.round(this.bu.height));
            this.b0.g().putImageData(this.b3, 0, 0);
            this.aq();
        }
        b8(a) {
            if (this.e.g9 != null) {
                this.e.g9.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        a6(a, b) {
            super.a6(a, b);
            if (b) {
                if (!this.bz.el) {
                    return;
                }
                let c = new Rectangle();
                c.n = this.bu.left;
                c.o = this.bu.top;
                c.width = this.bu.width;
                c.height = this.bu.height;
                c._fill = this.bo();
                a.v(c);
                return;
            }
            if (this.b2 == null) {
                return;
            }
            let d = truncate(Math.round(this.bu.left));
            let e = truncate(Math.round(this.bu.top));
            let f = truncate(Math.round(this.bu.width));
            let g = truncate(Math.round(this.bu.height));
            this.k.n(this.b2.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
        }
        b1(a, b) {
            return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
        }
        b7() {
            if (this.bx != null) {
                for (let a = 0; a < this.bx.length; a++) {
                    this.bx[a] = 0;
                }
                this.b9();
            }
        }
        al(a) {
            super.al(a);
            if (this.bx == null) {
                this.e.a8.exportSeriesPixelsData(a, null, this.b5, this.b4);
                return;
            }
            let b = new Array(intDivide(this.bx.length, 4));
            let c;
            for (let d = 0; d < intDivide(this.bx.length, 4); d++) {
                c = d * 4;
                b[d] = this.bx[c + 3] << 24 | this.bx[c] << 16 | this.bx[c + 1] << 8 | this.bx[c + 2];
            }
            this.e.a8.exportSeriesPixelsData(a, b, this.b5, this.b4);
        }
    }
    HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
})();
