/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { TrendLineType_$type } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
export let HorizontalAnchoredCategorySeries = /*@__PURE__*/ (() => {
    class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
        constructor() {
            super(...arguments);
            this.us = null;
            this.uo = null;
            this.uu = null;
            this.uq = 0;
        }
        get ut() {
            if (this.us == null) {
                this.us = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, () => this.cn.n);
            }
            return this.us;
        }
        ku() {
            super.ku();
            this.xAxis = null;
            this.yAxis = null;
        }
        bv() {
            return 1;
        }
        bw() {
            if (this.yAxis != null && this.yAxis.cg) {
                return 4;
            }
            return 3;
        }
        bp() {
            if (this.bq == 0) {
                return 1;
            }
            else {
                return super.bp();
            }
        }
        ro() {
            return this.uo;
        }
        r9() {
            return this.uu;
        }
        px(a) {
            if (this.rp == null || this.rp.m.count == 0 || !this.hasMarkers || !this.qf()) {
                return Rect.empty;
            }
            return this.ut.d$d(this, this.rp.m, a, runOn(this, this.u6));
        }
        u6(a) {
            return this.th.c9(a);
        }
        uy(a, b, c) {
            return this.ut.d$c(this, this.r9(), a, b, c);
        }
        ah(a) {
            return this.ut.d$a(this, this.rp.f, this.sp(this.b0), this.sq(this.b0), a);
        }
        ai(a) {
            return this.ut.d$b(this, this.rp.f, this.sp(this.b0), this.sq(this.b0), a);
        }
        ev(a, b) {
            if (this.eu(a, b)) {
                return true;
            }
            if (this.qg(a, b)) {
                return true;
            }
            return false;
        }
        getOffsetValue() {
            return this.ru.r(this.ro(), this.b0.bv, this.b0.bu, this.getEffectiveViewport1(this.b0));
        }
        getCategoryWidth() {
            let a = this.getEffectiveViewport1(this.b0);
            return this.ro().getCategorySize(this.b0.bv, this.b0.bu, a);
        }
        gj(a, b, c) {
            if (this.cd == null) {
                return NaN;
            }
            let d = this.getEffectiveViewport1(this.b0);
            let e = this.ro();
            if (e == null) {
                return NaN;
            }
            let f = new ScalerParams(0, this.cd.sf, this.b0.bu, e.cg, d);
            let g = this.ru.r(e, this.cd.sf, this.b0.bu, d);
            return this.gl(this.valueColumn, a, e, f, g, runOn(this, this.sn), b, c);
        }
        hj(a, b) {
            return this.hk(a, b, this.ro(), runOn(this, this.sn), this.valueColumn);
        }
        hh(a, b) {
            return this.hi(a, b, this.ro(), runOn(this, this.sn), this.valueColumn);
        }
        f3(a, b, c, d, e) {
            if (this.valueColumn == null) {
                return Number.POSITIVE_INFINITY;
            }
            return this.f4(a, b, this.ro(), d, e, this.valueColumn.count, runOn(this, this.sn));
        }
        pm(a, b, c) {
            if (this.ro() == null || this.r9() == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            return this.po(a, b, c, this.ru.r(this.ro(), this.b0.bv, this.b0.bu, this.getEffectiveViewport1(this.b0)), this.r9(), this.ro(), null, null, null);
        }
        fetchXAxis() {
            return this.uo;
        }
        fetchYAxis() {
            return this.uu;
        }
        t4(a) {
            this.xAxis = typeCast(CategoryAxisBase.$, a);
        }
        t5(a) {
            this.yAxis = typeCast(NumericYAxis.$, a);
        }
        sj() {
            return this.uu != null && this.uu.c0();
        }
        u2(a) {
            this.uo = a;
        }
        u3(a) {
            this.uu = a;
        }
        ri(a, b) {
            return this.te(a, b, this.uo);
        }
        l4(a, b, c, d) {
            switch (b) {
                case HorizontalAnchoredCategorySeries.$$p[0]:
                    this.u2(this.xAxis);
                    if (this.th.c3) {
                        this.th.c2 = CategoryTrendLineManagerFactory.a(this.th.c2, this.uo, this.na, this, this.cn);
                    }
                    break;
                case "TrendLineType":
                    let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                    if (e != 0) {
                        this.th.c2 = CategoryTrendLineManagerFactory.a(this.th.c2, this.uo, this.na, this, this.cn);
                    }
                    break;
            }
            super.l4(a, b, c, d);
            switch (b) {
                case HorizontalAnchoredCategorySeries.$$p[0]:
                    if (c != d) {
                        this.k1(typeCast(Axis.$, c));
                        this.l9(typeCast(Axis.$, d));
                        this.u2(this.xAxis);
                        this.ry.cr.g(this.ft);
                        this.mi(false);
                        this.lp();
                    }
                    break;
                case HorizontalAnchoredCategorySeries.$$p[1]:
                    if (c != d) {
                        this.k1(typeCast(Axis.$, c));
                        this.l9(typeCast(Axis.$, d));
                        this.u3(this.yAxis);
                        if (this.cd != null) {
                            this.cd.li();
                        }
                        this.ry.cr.g(this.ft);
                        this.sj();
                        this.mi(false);
                        this.lp();
                    }
                    break;
                case "CategoryMode":
                    if (this.xAxis != null) {
                        this.xAxis.l4(true);
                    }
                    break;
            }
        }
        k0(a, b, c, d) {
            super.k0(a, b, c, d);
            if (this.uo != null && typeCast(ISortingAxis_$type, this.uo) !== null) {
                this.uo.i$i();
            }
            switch (a) {
                case 4:
                    if (this.uo != null) {
                        this.uo.c0();
                    }
                    if (this.uu != null && !this.uu.c0()) {
                        this.mi(true);
                    }
                    break;
                case 1:
                    if (this.uo != null) {
                        this.uo.c0();
                    }
                    if (this.uu != null && !this.uu.c0()) {
                        this.mi(true);
                    }
                    break;
                case 0:
                    if (this.uo != null) {
                        this.uo.c0();
                    }
                    if (this.uu != null && !this.uu.c0()) {
                        this.mi(true);
                    }
                    break;
                case 2:
                    if (this.tt != null && this.th.cr.d > 0 && this.uu != null && !this.uu.c0()) {
                        this.mi(true);
                    }
                    break;
                case 3:
                    if (d == this.tt) {
                        if (this.uo != null) {
                            this.uo.c0();
                        }
                        if (this.uu != null && !this.uu.c0()) {
                            this.mi(true);
                        }
                    }
                    break;
            }
        }
        uw(a) {
            if (typeCast(CategoryXAxis.$, a) !== null || a.cd) {
                return true;
            }
            return false;
        }
        ux(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        get ur() {
            return this.uq;
        }
        set ur(a) {
            let b = this.ur;
            if (a != b) {
                this.uq = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.ur));
            }
        }
        get useHighMarkerFidelity() {
            return this.sk;
        }
    }
    HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    HorizontalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::u4', [CategoryAxisBase.$, null], 'YAxis::u5', [NumericYAxis.$, null]]);
    return HorizontalAnchoredCategorySeries;
})();
