/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { MarkerSeries } from "./MarkerSeries";
import { Base, runOn, Number_$type, enumGetBox, Point_$type, typeCast, fromEnum, markType, markDep } from "igniteui-angular-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { AxisRange } from "./AxisRange";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { GeometryUtil } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { AssigningPolarStyleEventArgs } from "./AssigningPolarStyleEventArgs";
import { AssigningPolarMarkerStyleEventArgs } from "./AssigningPolarMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { GeometryGroup } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let PolarBase = /*@__PURE__*/ (() => {
    class PolarBase extends MarkerSeries {
        constructor() {
            super();
            this.rz = null;
            this.rl = null;
            this.rx = null;
            this.u1 = null;
            this.u0 = null;
            this.sb = null;
            this.sd = null;
            this.se = null;
            this.r3 = new PolarFrame();
            this.r5 = new PolarFrame();
            this.r1 = new PolarFrame();
            this.rw = null;
            this.sv = null;
            this.r7 = 1;
            this.si = false;
            this.sh = false;
            this.rs = null;
            this.rt = null;
            this.assigningPolarStyle = null;
            this.assigningPolarMarkerStyle = null;
            this.r6 = null;
            this.r4 = null;
            this.r0 = null;
            this.r6 = new PolarSeriesRenderManager();
            this.r8 = this.r9();
            this.r4 = new PolarFrame();
            this.r5.x = runOn(this, this.uz);
            this.r3.x = runOn(this, this.uz);
            this.r1.x = runOn(this, this.uz);
            this.sb = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(this, this.t2), runOn(this, this.t6), runOn(this, this.cv), runOn(this, this.mr), runOn(this, this.tx));
        }
        bx() {
            return new PolarBaseView(this);
        }
        lz(a) {
            super.lz(a);
            this.ry = a;
        }
        ku() {
            super.ku();
            this.ru = null;
            this.rv = null;
        }
        get_d6() {
            return true;
        }
        c1(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.ru;
            let f = new ScalerParams(1, this.cd.sf, this.pz, e.cg);
            f.c = this.getEffectiveViewport1(this.b0);
            let g = this.rv;
            let h = new ScalerParams(1, this.cd.sf, this.pz, g.cg);
            h.c = this.getEffectiveViewport1(this.b0);
            a.clear();
            this.qc.cf((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.pz.left || k > this.pz.right || l < this.pz.top || l > this.pz.bottom) {
                        return;
                    }
                    let m;
                    let n;
                    let o = this.rw.f(k, l, this.b0.bv, this.b0.bu, m, n);
                    m = o.p4;
                    n = o.p5;
                    j.b = m;
                    j.c = n;
                    j.a = i.content;
                    a.add(j);
                }
            });
            return true;
        }
        tx() {
            if (this.ce.g) {
                this.ce.t();
            }
        }
        tz() {
            this.rw.e(this.rz.w, this.sf, this.sg, this.u1, this.u0, (a, b) => Math.cos(b), (a, b) => Math.sin(b), true);
        }
        get sf() {
            return this.sd;
        }
        set sf(a) {
            if (this.sd != a) {
                let b = this.sf;
                this.sd = a;
                this.raisePropertyChanged("AngleColumn", b, this.sf);
            }
        }
        get sg() {
            return this.se;
        }
        set sg(a) {
            if (this.se != a) {
                let b = this.sg;
                this.se = a;
                this.raisePropertyChanged("RadiusColumn", b, this.sg);
            }
        }
        get uu() {
            return this.c(PolarBase.t7);
        }
        set uu(a) {
            this.h(PolarBase.t7, a);
        }
        r2() {
            let a = this.r1;
            if (this.cv()) {
                if (this.ce.g) {
                    this.ce.t();
                }
                a = this.r5;
            }
            return a;
        }
        lf() {
            super.lf();
            if (this.rv != null) {
                this.rv.h7(false);
            }
            if (this.ru != null) {
                this.ru.h7(false);
            }
        }
        k0(a, b, c, d) {
            let e = false;
            this.ry.cv.g$e(a, b, c, d);
            if (this.ru != null && !this.ru.c0()) {
                e = true;
            }
            if (this.rv != null && !this.rv.c0()) {
                e = true;
            }
            if (e) {
                this.mi(true);
            }
        }
        m5(a, b) {
            this.mi(false);
        }
        m6(a, b) {
            this.mi(false);
        }
        e9(a, b, c) {
            let d = true;
            if (!super.e9(a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.ru == null || this.rv == null || this.sf == null || this.sg == null || this.sf.count == 0 || this.sg.count == 0 || this.ck == null || this.ck.count != this.sf.count || this.ck.count != this.sg.count || this.rw == null || this.ru.bh == null || this.rv.bh == null || this.ru.lv == this.ru.lu || this.rv.lv == this.rv.lu) {
                d = false;
            }
            return d;
        }
        mj(a) {
            let b;
            let c;
            let d = this.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            if (!this.e9(c, b, this.b0)) {
                this.kx(true, this.b0);
                return;
            }
            this.u1 = b;
            this.u0 = c;
            this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
            let e = new SeriesRenderingArguments(this, c, b, a, this.es);
            let f = this.sb.g(e, this.r3, this.r1, this.r5, this.ry);
            this.r3 = f.p1;
            this.r1 = f.p2;
            this.r5 = f.p3;
        }
        uz(a) {
            let b = this.rw.h(a.x, a.y, this.u1, this.u0, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
            return b;
        }
        ap(a) {
            if (a != null && a == this.ru && this.sf != null) {
                return new AxisRange(this.sf.minimum, this.sf.maximum);
            }
            if (a != null && a == this.rv && this.sg != null) {
                return new AxisRange(this.sg.minimum, this.sg.maximum);
            }
            return null;
        }
        en(a) {
            let b = this.b0.bv;
            b = b.copy();
            let c = this.b0.bu;
            let d = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
            if (this.ru == null || this.sf == null || this.rv == null || this.sg == null) {
                return false;
            }
            if (d < 0 || d > this.sf.count - 1 || d > this.sg.count - 1) {
                return false;
            }
            let e = this.ru.getScaledAngle(this.sf.item(d));
            let f = this.rv.ns(this.sg.item(d));
            let g = 0.5 + (Math.cos(e) * f);
            let h = 0.5 + (Math.sin(e) * f);
            if (!isNaN_(g)) {
                if (g < b.left + 0.1 * b.width) {
                    g = g + 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
                if (g > b.right - 0.1 * b.width) {
                    g = g - 0.4 * b.width;
                    b.x = g - 0.5 * b.width;
                }
            }
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            if (this.b8 != null) {
                this.b8.au(this.cd, b, true);
            }
            return d >= 0;
        }
        ht(a) {
            let b = this.hd(a);
            if (this.ck != null && b >= 0 && b < this.ck.count) {
                return this.ck.item(b);
            }
            return null;
        }
        hd(a) {
            let b = truncate(Math.round(this.f5(a)));
            return b;
        }
        f5(a) {
            switch (this.r8) {
                case 1: return this.sz(a);
                case 3: return this.s0(a);
                case 2: return this.sx(a);
                case 4: return this.sy(a);
            }
            return -1;
        }
        sy(a) {
            return this.s1(a, false);
        }
        sx(a) {
            let b = this.ph(a);
            let c = b.x;
            let d = b.y;
            if (this.ck == null || this.ru == null || this.rv == null || this.sf == null || this.sg == null) {
                return -1;
            }
            if (this.ck.count > this.s3) {
                return -1;
            }
            if (!this.sm()) {
                return -1;
            }
            let e = this.sv;
            let f = 1.7976931348623157E+308;
            let g = -1;
            for (let h = 0; h < this.sf.count; h++) {
                let i = e._inner[h].x;
                let j = e._inner[h].y;
                let k = (c - i) * (c - i) + (d - j) * (d - j);
                if (k < f) {
                    f = k;
                    g = h;
                }
            }
            return g;
        }
        sm() {
            let a = this.r1;
            if (this.cv()) {
                a = this.r5;
            }
            if (a == null || a.w.count == 0) {
                return false;
            }
            this.sv = a.w;
            return true;
        }
        s1(a, b) {
            if (!this.sp) {
                return -1;
            }
            let c = { $type: Point_$type, x: 0, y: 0 };
            let d = true;
            let e = this.r1;
            if (this.cv()) {
                e = this.r5;
            }
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.ck == null || this.ck.count > this.s3) {
                return -1;
            }
            if (!this.sm()) {
                return -1;
            }
            let f = this.sv;
            let g = this.ph(a);
            let h = 1.7976931348623157E+308;
            let i = -1;
            for (let j = 0; j < f.count; j++) {
                let k = f._inner[j];
                if (j > 0) {
                    if (isNaN_(k.x) || isNaN_(k.y) || isNaN_(c.x) || isNaN_(c.y)) {
                        c = k;
                        continue;
                    }
                    if (!b || e.j.containsKey(this.ck.item(j)) || e.j.containsKey(this.ck.item(j - 1))) {
                        let l = GeometryUtil.d(g, c, k);
                        if (l < h) {
                            h = l;
                            i = j;
                        }
                    }
                }
                c = k;
            }
            if (i >= 0) {
                let m = f._inner[i];
                let n = f._inner[i - 1];
                if (!b || (e.j.containsKey(this.ck.item(i)) && e.j.containsKey(this.ck.item(i - 1)))) {
                    let o = GeometryUtil.h(g, n, m);
                    return (i - 1) + o;
                }
                else if (e.j.containsKey(this.ck.item(i))) {
                    return i;
                }
                else {
                    return i - 1;
                }
            }
            return -1;
        }
        s0(a) {
            return this.s1(a, true);
        }
        sz(a) {
            let b = null;
            let c = 1.7976931348623157E+308;
            let d = this.ph(a);
            let e = d.x;
            let f = d.y;
            if (this.ry.cw.e > this.s3) {
                return -1;
            }
            this.ry.cz((g) => {
                if (g._visibility == 0) {
                    let h = this.ry.cp(g);
                    let i = h.left + h.width / 2;
                    let j = h.top + h.height / 2;
                    let k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        }
        pm(a, b, c) {
            if (this.ru == null || this.rv == null || this.sf == null || this.sg == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.b0.bv;
            let e = this.b0.bu;
            let f = this.getEffectiveViewport();
            let g = new ScalerParams(0, d, e, this.ru.cg, f);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rv.cg, f);
                $ret.b = this.gc();
                return $ret;
            })());
            if (b) {
                let i = this.f5(a);
                if (i == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let j = truncate(Math.floor(i));
                let k = truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.ck.count - 1) {
                    k = this.ck.count - 1;
                }
                if (j > this.ck.count - 1) {
                    j = this.ck.count - 1;
                }
                if (k == j) {
                    return this.rw.h(this.sf.item(j), this.sg.item(j), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
                }
                let l = i - Math.floor(i);
                let m = this.rw.h(this.sf.item(j), this.sg.item(j), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
                let n = this.rw.h(this.sf.item(k), this.sg.item(k), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
                let o = m.x;
                let p = m.y;
                let q = n.x;
                let r = n.y;
                let s = q - o;
                let t = r - p;
                return { $type: Point_$type, x: o + s * l, y: p + t * l };
            }
            else {
                let u = this.hd(a);
                if (u == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                return this.rw.h(this.sf.item(u), this.sg.item(u), d, e, this.rx.e, this.rx.d, this.rx.g, this.rx.f, this.rx.i, this.rx.h);
            }
        }
        ag() {
            return [this.ru, this.rv];
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == PolarBase.$$p[3]) {
                return this.hx(a, b, this.te);
            }
            if (c == PolarBase.$$p[13]) {
                return this.hx(a, b, this.ts);
            }
            return super.hw(a, b);
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            if (this.ry.cv.g$b(a, b, c, d)) {
                this.mi(false);
                this.lp();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.sf);
                        c.deregisterColumn(this.sg);
                        this.sf = null;
                        this.sg = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.sf = this.ch(this.te);
                        this.sg = this.ch(this.ts);
                    }
                    if ((this.rv != null && !this.rv.c0()) || (this.ru != null && !this.ru.c0())) {
                        this.mi(false);
                    }
                    break;
                case PolarBase.$$p[0]:
                    if (this.ru != null && this.rv != null) {
                        this.rw = new PolarAxes(this.rv, this.ru);
                    }
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    if (this.ru != null && !this.ru.c0()) {
                        this.mi(false);
                    }
                    else if (c != null && d == null) {
                        this.kx(true, this.b0);
                    }
                    break;
                case PolarBase.$$p[10]:
                    if (this.ru != null && this.rv != null) {
                        this.rw = new PolarAxes(this.rv, this.ru);
                    }
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    if (this.rv != null && !this.rv.c0()) {
                        this.mi(false);
                    }
                    else if (c != null && d == null) {
                        this.kx(true, this.b0);
                    }
                    if (this.ru != null && !this.ru.c0()) {
                        this.ru.h3();
                    }
                    break;
                case PolarBase.$$p[3]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.sf);
                        this.sf = this.ch(this.te);
                    }
                    break;
                case "AngleColumn":
                    this.ry.cv.g$i();
                    if (this.ru != null && !this.ru.c0()) {
                        this.mi(false);
                    }
                    break;
                case PolarBase.$$p[13]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.sg);
                        this.sg = this.ch(this.ts);
                    }
                    break;
                case "RadiusColumn":
                    this.ry.cv.g$i();
                    if (this.rv != null && !this.rv.c0()) {
                        this.mi(false);
                    }
                    break;
                case PolarBase.$$p[14]:
                    this.mi(false);
                    this.lp();
                    break;
                case PolarBase.$$p[9]:
                    this.mi(false);
                    this.lp();
                    break;
                case "TransitionProgress":
                    this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
                    this.u1 = this.b0.bv;
                    this.u0 = this.b0.bu;
                    this.r5.v = this.su;
                    this.r5.c(this.g0, this.r3, this.r1);
                    if (this.cx(this.b0)) {
                        return;
                    }
                    if (this.g0 == 1) {
                        this.t6(this.r1, this.ry);
                    }
                    else {
                        this.t6(this.r5, this.ry);
                    }
                    if (this.cd != null) {
                        this.cd.nn(this);
                    }
                    break;
                case "TrendLineBrush":
                    this.mw();
                    break;
                case PolarBase.$$p[4]:
                    this.mi(false);
                    this.lp();
                    break;
                case "TrendLineType":
                    this.lp();
                    break;
                case PolarBase.$$p[6]:
                    this.si = this.sr();
                    this.mi(false);
                    break;
                case PolarBase.$$p[5]:
                    this.sh = this.sq();
                    this.mi(false);
                    break;
                case PolarBase.$$p[7]:
                    this.r8 = this.r9();
                    break;
            }
        }
        get r8() {
            return this.r7;
        }
        set r8(a) {
            let b = this.r7;
            this.r7 = a;
            if (b != this.r7) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.r7));
            }
        }
        r9() {
            if (this.sa != 0) {
                return this.sa;
            }
            return this.sp ? 4 : 1;
        }
        get_sp() {
            return false;
        }
        get sp() {
            return this.get_sp();
        }
        sr() {
            return this.so;
        }
        sq() {
            return this.sn;
        }
        sk(a) {
            if (typeCast(NumericRadiusAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        sj(a) {
            if (typeCast(NumericAngleAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            if (a) {
                c.cw.clear();
            }
            c.cv.g$d();
        }
        rm(a, b) {
            let c = a.top - 10;
            let d = a.bottom + 10;
            let e = a.left - 10;
            let f = a.right + 10;
            let g = ((() => {
                let $ret = new Clipper(1, e, d, f, c, false);
                $ret.i = b;
                return $ret;
            })());
            return g;
        }
        tw(a, b, c, d) {
            a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
            let e = this.ck;
            for (let f = 0; f < b; f++) {
                let g = a.w._inner[f];
                if (!isInfinity(g.x) && !isInfinity(g.y)) {
                    let h = { $type: Point_$type, x: this.sf.item(f), y: this.sg.item(f) };
                    let i = { $type: Point_$type, x: g.x, y: g.y };
                    a.g.addItem(e.item(f), ((() => {
                        let $ret = new OwnedPoint();
                        $ret.a = e.item(f);
                        $ret.b = h;
                        $ret.c = i;
                        return $ret;
                    })()));
                }
            }
        }
        t2(a, b) {
            let c = b.bv;
            let d = b.bu;
            a.j.clear();
            a.n.clear();
            let e = Math.min(this.sf != null ? this.sf.count : 0, this.sg != null ? this.sg.count : 0);
            if (e < 1) {
                return;
            }
            this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
            this.rz = a;
            this.u0 = d;
            this.u1 = c;
            b.ct.l(a.j, this.s4, c, d, this.ft);
            if (e <= this.s4) {
                this.tw(a, e, c, d);
            }
            let f = this.rm(d, a.n);
            let g = Math.min(this.ru.lv, this.ru.lu);
            let h = Math.max(this.ru.lu, this.ru.lv);
            b.cv.i = this.su;
            b.cv.h = 0;
            b.cv.k = this.rv.nm;
            b.cv.j = this.rv.nl;
            b.cv.l = (i, j) => this.rw.c(i, j, c, d, Math.cos);
            b.cv.m = (i, j) => this.rw.d(i, j, c, d, Math.sin);
            let i = new List$1(Number_$type, 0);
            for (let j = 0; j < this.sf.count; j++) {
                if (this.sf.item(j) >= g && this.sf.item(j) <= h) {
                    i.add(this.sf.item(j));
                }
            }
            let k = this.sg;
            if (i.count != this.sf.count) {
                k = new List$1(Number_$type, 0);
                for (let l = 0; l < this.sf.count; l++) {
                    if (this.sf.item(l) >= g && this.sf.item(l) <= h) {
                        k.add(this.sg.item(l));
                    }
                }
            }
            b.cv.n(a.n, this.sc, i, k, this.s5, runOn(this.ru, this.ru.getScaledAngle), runOn(this.rv, this.rv.ns), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.b = this.ft;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()), f, g, h);
        }
        get_dx() {
            return true;
        }
        rq(a, b, c) {
            return null;
        }
        rr(a, b, c) {
            let d = this.r2();
            let e = this.ry.by(this.ph(b));
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ck.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            g.e = true;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        }
        rp(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ck.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        aw(a, b, c) {
            if (this.c2 && this.ef(this.bk) && !c) {
                let d = this.rq(a, b, this.rs);
                this.rs = d;
                return d;
            }
            else {
                let e = this.rp(a, b, this.rs);
                this.rs = e;
                return e;
            }
        }
        ax(a, b, c) {
            if (this.ef(this.bk) && !c) {
                let d = this.rr(a, b, this.rt);
                this.rt = d;
                return d;
            }
            else {
                let e = this.rp(a, b, this.rt);
                e.e = true;
                this.rt = e;
                return e;
            }
        }
        st() {
            return (this.assigningPolarStyle != null && this.si) || (this.bk != 1);
        }
        ss() {
            return (this.assigningPolarMarkerStyle != null && this.sh) || (this.bk != 1);
        }
        t6(a, b) {
            let c = b.bv;
            let d = b.bu;
            let e = this.getEffectiveViewport1(b);
            let f = this.pr(b);
            this.rx = new PolarAxisInfoCache(this.ru, this.rv, this.ck);
            if (this.qf()) {
                b.ct.j(a.j, this.qh);
                if (this.ss()) {
                    this.ty(b, a);
                }
            }
            b.cm();
            let g = this.rm(d, b.cv.g$j.ak);
            b.cv.g$h(a.n, g);
            this.tv(d, c, e, f, b);
        }
        rj(a, b) {
            return this.rk(a, b);
        }
        rk(a, b) {
            if (b < a || a < 0 || a > this.sf.count || b < 0 || b > this.sf.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.ck.item(d);
            }
            return c;
        }
        ty(a, b) {
            a.b3 = true;
            this.r6.aw(this, this.ss(), runOn(this, this.rj));
            let c = this.r6.d;
            let d = c != null;
            let e = this.getEffectiveViewport1(a);
            let f = this.ck == null ? 0 : this.ck.count;
            this.ry.cf((g) => {
                if (g._visibility == 0) {
                    let h = g.ak;
                    let i = g.content;
                    if (i == null) {
                        i = new DataContext();
                        g.content = i;
                    }
                    if (d) {
                        this.t0(h, f, a.q);
                    }
                    this.r6.ac(g, i);
                }
            });
        }
        t1(a, b, c) {
            let d = this.bk != 1;
            this.r6.ay(this.r6.b, a, b, false);
            this.r6.ab(this.fr);
            let e = this.r6.av;
            let f = null;
            let g = this.ck;
            if (d && this.cd != null) {
                f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, false);
                e.b = f;
            }
            e.f = c;
            this.t4(e);
            this.r6.z(this, f, c, d, a < 0);
        }
        t0(a, b, c) {
            let d = this.bk != 1;
            this.r6.ay(this.r6.d, a, b, true);
            this.r6.aa(this.fr);
            let e = this.r6.au;
            let f = null;
            let g = this.ck;
            let h = null;
            if (d && this.cd != null) {
                f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.cd.a3.isCrossSeriesHighlight(this)) {
                    h = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.t3(e);
            this.r6.y(this, f, c, d, e.l, this.cd.a3.sumHighlightingProgress);
        }
        t4(a) {
            if (this.assigningPolarStyle != null && this.si) {
                this.assigningPolarStyle(this, a);
            }
        }
        t3(a) {
            if (this.assigningPolarMarkerStyle != null && this.sh) {
                this.assigningPolarMarkerStyle(this, a);
            }
        }
        tv(a, b, c, d, e) {
            e.cy(a, b, c, d);
        }
        mw() {
            super.mw();
            if (this.index < 0) {
                return;
            }
            this.ry.c1();
        }
        mk(a, b) {
            super.mk(a, b);
            if (!this.ez) {
                this.b0.a2(b);
                return;
            }
            this.b0.a2(b);
            if (this.cx(this.bz)) {
                return;
            }
            let c = this.bz;
            if (!this.et) {
                this.r4 = new PolarFrame();
                this.t2(this.r4, c);
            }
            this.et = false;
            this.t6(this.r4, c);
            this.ez = false;
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.cx(g)) {
                return;
            }
            if (this.r0 == null) {
                this.r0 = new PolarFrame();
            }
            this.t2(this.r0, g);
            this.t6(this.r0, g);
        }
        t5(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        ri(a, b, c) {
            this.tz();
            return this.rz.w.toArray();
        }
        sw(a) {
            let b = new List$1(Number_$type, 0);
            let c = this.ck;
            for (let d of fromEnum(this.ry.cw.c)) {
                b.add(c.indexOf(d));
            }
            return b;
        }
        uy(a) {
            return { $type: Point_$type, x: this.sf.item(a), y: this.sg.item(a) };
        }
        k7(a) {
            super.k7(a);
            this.a8.exportTrendlineData(this, a, this.ry.cv.g$j);
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ht(c);
            let e = d == null ? NaN : this.gb(d, "RadiusMemberPath");
            let f = d == null ? NaN : this.gb(d, "AngleMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.l = e;
            g.a = 11;
            g.p = this.ts != null ? this.ts : "Radius";
            g.q = this.to != null ? this.to : "R:";
            g.r = this.tq != null ? this.tq : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 10;
            h.p = this.te != null ? this.te : "Angle";
            h.q = this.ta != null ? this.ta : "A:";
            h.r = this.tc != null ? this.tc : "";
            let i = new DataLegendSeriesContext();
            i.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.b = this.av();
            return i;
        }
    }
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.t7 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    PolarBase.$$p = markDep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:ru:t8', [NumericAngleAxis.$, null], 'AngleMemberAsLegendLabel:ta:t9', [2, null], 'AngleMemberAsLegendUnit:tc:ua', [2, null], 'AngleMemberPath:te:ub', [2], 'ClipSeriesToBounds:sl:uc', [0, false], 'IsCustomPolarMarkerStyleAllowed:sn:ud', [0, false], 'IsCustomPolarStyleAllowed:so:ue', [0, false], 'ItemSearchMode:sa:uf', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:s3:ug', [1, 10000], 'MaximumMarkers:s4:uh', [1, 400], 'RadiusAxis:rv:ui', [NumericRadiusAxis.$, null], 'RadiusMemberAsLegendLabel:to:uj', [2, null], 'RadiusMemberAsLegendUnit:tq:uk', [2, null], 'RadiusMemberPath:ts:ul', [2], 'UseCartesianInterpolation:su:ut', [0, true], 'TrendLineType:sc:ur', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:s2:uq', [1, 1.5], 'TrendLinePeriod:s5:up', [1, 7], 'TrendLineZIndex:s6:us', [1, 1], 'TrendLineBrush:uv:um', [Brush.$, null], 'TrendLineDashArray:uw:un', [DoubleCollection.$], 'TrendLineDashCap:ux:uo', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return PolarBase;
})();
/**
 * @hidden
 */
export let PolarSeriesRenderManager = /*@__PURE__*/ (() => {
    class PolarSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.au = null;
            this.av = null;
        }
        c() {
            this.au = new AssigningPolarMarkerStyleEventArgs();
            return this.au;
        }
        a() {
            this.av = new AssigningPolarStyleEventArgs();
            return this.av;
        }
        aw(a, b, c) {
            this.w(a, b, c);
        }
        ax(a, b, c) {
            this.x(a, b, c);
        }
        ay(a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        }
    }
    PolarSeriesRenderManager.$t = markType(PolarSeriesRenderManager, 'PolarSeriesRenderManager', SeriesRenderManager.$);
    return PolarSeriesRenderManager;
})();
/**
 * @hidden
 */
export let PolarBaseView = /*@__PURE__*/ (() => {
    class PolarBaseView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.cu = null;
            this.ct = null;
            this.cv = null;
            this.cw = null;
            this.cu = a;
            this.cw = new HashPool$2(Base.$, Marker.$);
            this.ch(this.cw);
            this.cv = new PolarTrendLineManager();
        }
        as() {
            super.as();
            this.ct = this.cs();
            if (!this.q) {
                this.cu.s4 = 1000;
                this.b1.qd = Defaults.e;
            }
        }
        cz(a) {
            this.cw.g(a);
        }
        cs() {
            let a = new NumericMarkerManager(0, (b) => this.cw.item(b), (b) => this.cu.rx.c.item(b), runOn(this, this.c0), runOn(this, this.cr), runOn(this, this.cx));
            a.n = true;
            a.p = runOn(this.cu, this.cu.uy);
            return a;
        }
        c0(a) {
            this.cu.t5(a, this.cw);
        }
        cr() {
            return this.cu.ri(this.cw, this.bv, this.bu);
        }
        cx() {
            return this.cu.sw(this.cw);
        }
        cy(a, b, c, d) {
            if (this.cu.sl) {
                let e = new GeometryGroup();
                this.cu.rv.n0(e, a, b, c, d);
            }
            else {
            }
        }
        c1() {
            if (this.cu.uv != null) {
                this.cu.uu = this.cu.uv;
            }
            else {
                this.cu.uu = this.cu.oz;
            }
        }
        cf(a) {
            this.cw.f(a);
        }
        a5(a, b) {
            if (a.d) {
                if (this.cu.sc != 0 && !b) {
                    let c = this.cv.g$j;
                    c.ac = this.cu.s2;
                    c._stroke = this.cu.uu;
                    c.ad = this.cu.ux;
                    c.ai = this.cu.uw;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        c2() {
            return Rect.empty;
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cu.te + "}" + "</span><br/><span";
            let b = this.e.a6.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cu.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.cu.ts + "}</span></div>";
            return a;
        }
    }
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
})();
