/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { markType, typeCast, markDep, Point_$type } from "igniteui-angular-core";
import { isNaN_, truncate, isInfinity } from "igniteui-angular-core";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasHighLowValueCategory_$type } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { CollisionAvoider } from "./CollisionAvoider";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { PropertyMetadata } from "igniteui-angular-core";
import { FastFlattener } from "igniteui-angular-core";
/**
 * @hidden
 */
export let RangeCategoryBucketCalculator = /*@__PURE__*/ (() => {
    class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.j = null;
            this.l = 0;
            this.k = 0;
            this.i = null;
            this.h = null;
            this.j = a;
        }
        getBucketWithoutUnknowns(a) {
            let b = false;
            let c = this.i;
            let d = this.h;
            let e = this.l;
            let f = this.k;
            let g = Math.min(e, f);
            let h = a * this.d;
            let i = Math.min(h + this.d - 1, g - 1);
            let j = 1.7976931348623157E+308;
            let k = -1.7976931348623157E+308;
            let l = true;
            let m = 0;
            let n = 0;
            let o;
            let p;
            if (h <= i) {
                for (let q = h; q <= i; ++q) {
                    m = c[q];
                    n = d[q];
                    if (m < n) {
                        o = m;
                        p = n;
                    }
                    else {
                        p = m;
                        o = n;
                    }
                    if (!l) {
                        j = j < o ? j : o;
                        k = k > o ? k : o;
                        j = j < p ? j : p;
                        k = k > p ? k : p;
                    }
                    else {
                        j = Math.min(j, o);
                        k = Math.max(k, o);
                        k = Math.max(k, p);
                        j = Math.min(j, p);
                        l = false;
                    }
                }
            }
            if (b && n < m) {
                let r = j;
                j = k;
                k = r;
            }
            if (!l) {
                let s = new Array(3);
                s[0] = 0.5 * (h + i);
                s[1] = j;
                s[2] = k;
                return s;
            }
            let t = new Array(3);
            t[0] = NaN;
            t[1] = NaN;
            t[2] = NaN;
            return t;
        }
        getBucket(a) {
            let b = false;
            let c = this.i;
            let d = this.h;
            let e = this.l;
            let f = this.k;
            let g = Math.min(e, f);
            let h = a * this.d;
            let i = Math.min(h + this.d - 1, g - 1);
            let j = NaN;
            let k = NaN;
            let l = true;
            let m = 0;
            let n = 0;
            let o;
            let p;
            if (h <= i) {
                for (let q = h; q <= i; ++q) {
                    m = c[q];
                    n = d[q];
                    if (m < n) {
                        o = m;
                        p = n;
                    }
                    else {
                        p = m;
                        o = n;
                    }
                    if (!l) {
                        if (!isNaN_(o)) {
                            j = j < o ? j : o;
                            k = k > o ? k : o;
                        }
                        if (!isNaN_(p)) {
                            j = j < p ? j : p;
                            k = k > p ? k : p;
                        }
                    }
                    else {
                        if (!isNaN_(o)) {
                            if (isNaN_(j)) {
                                j = o;
                            }
                            else {
                                j = Math.min(j, o);
                            }
                            if (!isNaN_(k)) {
                                k = Math.max(k, o);
                            }
                        }
                        if (!isNaN_(p)) {
                            if (isNaN_(k)) {
                                k = p;
                            }
                            else {
                                k = Math.max(k, p);
                            }
                            if (!isNaN_(j)) {
                                j = Math.min(j, p);
                            }
                        }
                        if (!isNaN_(j) && !isNaN_(k)) {
                            l = false;
                        }
                    }
                }
            }
            if (n < m && b) {
                let r = j;
                j = k;
                k = r;
            }
            if (!l) {
                let s = new Array(3);
                s[0] = 0.5 * (h + i);
                s[1] = j;
                s[2] = k;
                return s;
            }
            let t = new Array(3);
            t[0] = NaN;
            t[1] = NaN;
            t[2] = NaN;
            return t;
        }
        cacheValues() {
            this.l = this.j.c0.lowColumn.count;
            this.k = this.j.c0.highColumn.count;
            this.i = this.j.c0.lowColumn.asArray();
            this.h = this.j.c0.highColumn.asArray();
        }
        unCacheValues() {
            this.i = null;
            this.h = null;
        }
    }
    RangeCategoryBucketCalculator.$t = markType(RangeCategoryBucketCalculator, 'RangeCategoryBucketCalculator', CategoryBucketCalculator.$);
    return RangeCategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let RangeCategorySeries = /*@__PURE__*/ (() => {
    class RangeCategorySeries extends CategorySeries {
        constructor() {
            super();
            this._RangeFramePreparer = null;
            this.ti = null;
            this.th = null;
            this.te = null;
            this.RangeFramePreparer = new RangeCategoryFramePreparer(1, this, this.tg, this, this, this.tg.cr);
        }
        bx() {
            return new RangeCategorySeriesView(this);
        }
        getHostReferenceValue() {
            return this.gc();
        }
        lz(a) {
            super.lz(a);
            this.tg = a;
        }
        get RangeFramePreparer() {
            return this._RangeFramePreparer;
        }
        set RangeFramePreparer(a) {
            this._RangeFramePreparer = a;
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == RangeCategorySeries.$$p[0]) {
                return this.hx(a, b, this.tm);
            }
            if (c == RangeCategorySeries.$$p[0]) {
                return this.hx(a, b, this.tm);
            }
            return super.hw(a, b);
        }
        get lowColumn() {
            return this.ti;
        }
        set lowColumn(a) {
            if (this.ti != a) {
                let b = this.ti;
                this.ti = a;
                this.raisePropertyChanged("LowColumn", b, this.ti);
            }
        }
        get highColumn() {
            return this.th;
        }
        set highColumn(a) {
            if (this.th != a) {
                let b = this.th;
                this.th = a;
                this.raisePropertyChanged("HighColumn", b, this.th);
            }
        }
        rz() {
            return 11;
        }
        s7(a, b) {
            super.s7(a, b);
            b.b3 = true;
            CategoryMarkerManager.e(this, a.m, b.cu, this.qh);
            this.s1(b, a);
        }
        tr(a, b, c, d, e, f) {
            this.tg.c1(a, b, c, d, e, f);
        }
        aq(a) {
            if (a.isEmpty && this.cd != null) {
                a = this.cd.sf;
            }
            let b = this.ro();
            if (this.lowColumn == null || this.highColumn == null) {
                return null;
            }
            let c = this.pr(this.b0);
            let d = new ScalerParams(0, a, this.cd.su, b.cg, this.getEffectiveViewport());
            let e = (b.el(c.left, d));
            let f = (b.el(c.right, d));
            if (b.cg) {
                let g = e;
                e = f;
                f = g;
            }
            let h = null;
            if (b.cm) {
                h = b;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            e = Math.max(0, Math.min(this.lowColumn.count - 1, e));
            f = Math.max(0, Math.min(this.lowColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            for (let k = truncate(e); k <= truncate(f); k++) {
                let l = k;
                if (h != null) {
                    l = h.i$b._inner[k];
                }
                let m = this.lowColumn.item(l);
                if (this.lowColumn.mayContainUnknowns) {
                    if (isInfinity(m) || isNaN_(m)) {
                        continue;
                    }
                }
                let n = this.highColumn.item(l);
                if (this.highColumn.mayContainUnknowns) {
                    if (isInfinity(n) || isNaN_(n)) {
                        continue;
                    }
                }
                i = Math.min(i, m);
                j = Math.max(j, n);
            }
            let o = new AxisRange(i, j);
            let p = this.r9();
            o = this.ao(o, p, a);
            return o;
        }
        en(a) {
            let b = new Rect(0, 0, 0, 1, 1);
            let c = this.b0 != null ? this.b0.bv : Rect.empty;
            c = c.copy();
            let d = this.b0 != null ? this.b0.bu : Rect.empty;
            let e = !c.isEmpty && !d.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
            let f = this.fetchXAxis();
            let g = this.fetchYAxis();
            let h = this.pt(this.b0);
            let i;
            if (f != null) {
                let j = new ScalerParams(0, b, b, f.cg, h);
                i = f.ei(e, j);
            }
            else {
                i = NaN;
            }
            let k = f != null ? this.RangeFramePreparer.r(typeCast(ICategoryScaler_$type, f), b, b, h) : 0;
            i += k;
            if (e >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (!isNaN_(i)) {
                    if (i < c.left + 0.1 * c.width) {
                        i = i + 0.4 * c.width;
                    }
                    if (i > c.right - 0.1 * c.width) {
                        i = i - 0.4 * c.width;
                    }
                    c.x = i - 0.5 * c.width;
                }
                if (g != null && this.highColumn != null && e < this.highColumn.count) {
                    let l = new ScalerParams(0, b, b, g.cg, h);
                    l.b = this.gc();
                    let m = g.ei(this.highColumn.item(e), l);
                    let n = g.ei(this.lowColumn.item(e), l);
                    if (!isNaN_(m) && !isNaN_(n)) {
                        let o = Math.abs(n - m);
                        if (c.height < o) {
                            c.height = o;
                            c.y = Math.min(n, m);
                        }
                        else {
                            if (n < c.top + 0.1 * c.height) {
                                n = n + 0.4 * c.height;
                            }
                            if (n > c.bottom - 0.1 * c.height) {
                                n = n - 0.4 * c.height;
                            }
                            c.y = n - 0.5 * c.height;
                        }
                    }
                }
                if (this.b8 != null) {
                    this.b8.au(this.cd, c, true);
                }
            }
            return e >= 0;
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.lowColumn);
                        c.deregisterColumn(this.highColumn);
                        this.lowColumn = null;
                        this.highColumn = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.lowColumn = this.ch(this.tp);
                        this.highColumn = this.ch(this.tm);
                    }
                    if (!this.sj()) {
                        this.ry.cr.g(this.ft);
                        this.mi(false);
                    }
                    break;
                case RangeCategorySeries.$$p[1]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.lowColumn);
                        this.lowColumn = this.ch(this.tp);
                    }
                    break;
                case "LowColumn":
                    if (!this.sj()) {
                        this.ry.cr.g(this.ft);
                        this.mi(false);
                    }
                    break;
                case RangeCategorySeries.$$p[0]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.highColumn);
                        this.highColumn = this.ch(this.tm);
                    }
                    break;
                case "HighColumn":
                    if (!this.sj()) {
                        this.ry.cr.g(this.ft);
                        this.mi(false);
                    }
                    break;
            }
        }
        ap(a) {
            if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                let b = Math.min(this.lowColumn.count, this.highColumn.count);
                return new AxisRange(0, b - 1);
            }
            if (a == this.fetchYAxis()) {
                let c = Math.min(this.lowColumn.minimum, this.highColumn.minimum);
                let d = Math.max(this.lowColumn.maximum, this.highColumn.maximum);
                return new AxisRange(Math.min(c, d), Math.max(c, d));
            }
            return null;
        }
        k0(a, b, c, d) {
            if (this.fetchXAxis() != null && typeCast(ISortingAxis_$type, this.fetchXAxis()) !== null) {
                this.fetchXAxis().i$i();
            }
            let e = this.fetchXAxis();
            switch (a) {
                case 3:
                    if (d == this.tp || d == this.tm) {
                        if (e != null) {
                            e.c0();
                        }
                        if (!this.sj()) {
                            this.mi(true);
                        }
                    }
                    break;
                case 1:
                    if (e != null) {
                        e.c0();
                    }
                    this.ry.cr.g(this.ft);
                    if (!this.sj()) {
                        this.mi(true);
                    }
                    break;
                case 0:
                    if (e != null) {
                        e.c0();
                    }
                    this.ry.cr.g(this.ft);
                    if (!this.sj()) {
                        this.mi(true);
                    }
                    break;
                case 2:
                    if (e != null) {
                        e.c0();
                    }
                    if (this.tp != null && this.tm != null && this.ry.cr.d > 0 && !this.sj()) {
                        this.mi(true);
                    }
                    break;
                case 4:
                    if (e != null) {
                        e.c0();
                    }
                    this.ry.cr.g(this.ft);
                    if (!this.sj()) {
                        this.mi(true);
                    }
                    break;
            }
        }
        e9(a, b, c) {
            let d = super.e9(a, b, c);
            if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
                d = false;
            }
            return d;
        }
        s4(a, b) {
            super.s4(a, b);
            this.RangeFramePreparer.d(a, b);
        }
        get currentCategoryMode() {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        }
        get scaler() {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        }
        get yScaler() {
            return typeCast(IScaler_$type, this.fetchYAxis());
        }
        get bucketizer() {
            return this.ry.cr;
        }
        get currentMode2Index() {
            return this.ss();
        }
        provideCollisionDetector() {
            return new CollisionAvoider();
        }
        get mayContainUnknowns() {
            return this.lowColumn == null || this.lowColumn.mayContainUnknowns || this.highColumn == null || this.highColumn.mayContainUnknowns;
        }
        mk(a, b) {
            let c = this.ez;
            super.mk(a, b);
            if (!c) {
                this.b0.a2(b);
                return;
            }
            this.b0.a2(b);
            if (this.cx(this.bz)) {
                return;
            }
            let d = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, this.bz), this.cd.cq.o, this, this.bz.cr);
            if (!this.et) {
                this.rs = new CategoryFrame(3);
                this.rs.u();
                d.d(this.rs, this.bz);
            }
            this.et = false;
            this.s7(this.rs, this.bz);
            this.ez = false;
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            let g = f;
            g.cr.g(this.ft);
            f.a1(c);
            if (this.cx(g)) {
                return;
            }
            let h = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, f), f, this, f.cr);
            if (this.te == null) {
                this.te = new CategoryFrame(3);
            }
            this.te.u();
            h.d(this.te, g);
            this.s7(this.te, g);
        }
        gc() {
            return Series.gd(this.lowColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
        }
        get useHighMarkerFidelity() {
            return this.sk;
        }
    }
    RangeCategorySeries.$t = markType(RangeCategorySeries, 'RangeCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasHighLowValueCategory_$type]);
    RangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, RangeCategorySeries, 'raisePropertyChanged', ['HighMemberPath:tm:ts', [2, null], 'LowMemberPath:tp:tt', [2, null]]);
    return RangeCategorySeries;
})();
/**
 * @hidden
 */
export let RangeCategorySeriesView = /*@__PURE__*/ (() => {
    class RangeCategorySeriesView extends CategorySeriesView {
        constructor(a) {
            super(a);
            this.c0 = null;
            this.c0 = a;
        }
        c1(a, b, c, d, e, f) {
            a.ak.clear();
            b.ak.clear();
            c.ak.clear();
            let g = FastFlattener.b(d, e, true, f, this.e.ft);
            let h = FastFlattener.b(d, e, false, f, this.e.ft);
            let i = g.count;
            let j = h.count;
            let k;
            let l;
            let m;
            let n;
            for (let o = 0; o < i; o++) {
                k = g.item(o);
                l = e._inner[k];
                m = l[0];
                n = l[1];
                a.ak.add({ $type: Point_$type, x: m, y: n });
                b.ak.add({ $type: Point_$type, x: m, y: n });
            }
            let p;
            let q;
            for (let r = 0; r < j; r++) {
                k = h.item(r);
                l = e._inner[k];
                if (f) {
                    p = l[0];
                    q = l[2];
                }
                else {
                    p = l[2];
                    q = l[3];
                }
                c.ak.add({ $type: Point_$type, x: p, y: q });
                b.ak.add({ $type: Point_$type, x: p, y: q });
            }
            a.ab = a.ak.count > 0;
            b.ab = b.ak.count > 0;
            c.ab = c.ak.count > 0;
        }
        cs() {
            return new RangeCategoryBucketCalculator(this);
        }
    }
    RangeCategorySeriesView.$t = markType(RangeCategorySeriesView, 'RangeCategorySeriesView', CategorySeriesView.$);
    return RangeCategorySeriesView;
})();
