/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { Base, enumGetBox, Number_$type, typeCast, fromEnum, Point_$type, runOn, markType, markDep, PointUtil } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { GeometryUtil } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { PathGeometry } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { boxArray$1, arrayShallowClone } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterBase = /*@__PURE__*/ (() => {
    class ScatterBase extends MarkerSeries {
        constructor() {
            super();
            this.rx = null;
            this.sb = null;
            this.sc = null;
            this.u0 = null;
            this.u1 = null;
            this.r6 = 1;
            this.ri = null;
            this.rj = null;
            this.r3 = null;
            this.r5 = null;
            this.r1 = null;
            this.sg = false;
            this.sf = false;
            this.rt = null;
            this.ru = null;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.sa = null;
            this.r4 = null;
            this.r0 = null;
            this.r7 = this.r8();
            this.sa = new ScatterSeriesRenderManager();
            this.r4 = new ScatterFrame();
            this.u1 = Rect.empty;
            this.u0 = Rect.empty;
        }
        bx() {
            return new ScatterBaseView(this);
        }
        ku() {
            super.ku();
            this.xAxis = null;
            this.yAxis = null;
        }
        lz(a) {
            super.lz(a);
            this.ry = a;
        }
        get_ec() {
            return true;
        }
        ag() {
            return [this.xAxis, this.yAxis];
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == ScatterBase.$$p[10]) {
                return this.hx(a, b, this.te);
            }
            if (c == ScatterBase.$$p[14]) {
                return this.hx(a, b, this.tm);
            }
            return null;
        }
        c1(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.xAxis;
            let f = new ScalerParams(1, this.cd.sf, this.pz, e.cg);
            f.c = this.getEffectiveViewport1(this.b0);
            let g = this.yAxis;
            let h = new ScalerParams(1, this.cd.sf, this.pz, g.cg);
            h.c = this.getEffectiveViewport1(this.b0);
            a.clear();
            this.qc.cf((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.pz.left || k > this.pz.right || l < this.pz.top || l > this.pz.bottom) {
                        return;
                    }
                    j.b = e.el(k, f);
                    j.c = g.el(l, h);
                    j.a = i.content;
                    a.add(j);
                }
            });
            return true;
        }
        bp() {
            if (this.bq == 0) {
                if (this.sy <= 2000) {
                    return 1;
                }
                else {
                    return super.bp();
                }
            }
            else {
                return super.bp();
            }
        }
        px(a) {
            if (!this.hasMarkers || !this.qf()) {
                return Rect.empty;
            }
            let b = this.qc.by(this.ph(a));
            if (b != null) {
                return this.qc.cp(b);
            }
            return Rect.empty;
        }
        ev(a, b) {
            if (this.qg(a, b)) {
                return true;
            }
            return false;
        }
        get sd() {
            return this.sb;
        }
        set sd(a) {
            if (this.sb != a) {
                let b = this.sd;
                this.sb = a;
                this.raisePropertyChanged("XColumn", b, this.sd);
            }
        }
        get se() {
            return this.sc;
        }
        set se(a) {
            if (this.sc != a) {
                let b = this.se;
                this.sc = a;
                this.raisePropertyChanged("YColumn", b, this.se);
            }
        }
        get ux() {
            return this.c(ScatterBase.ua);
        }
        set ux(a) {
            this.h(ScatterBase.ua, a);
        }
        get GetErrorBarsXAxis() {
            return this.xAxis;
        }
        get GetErrorBarsYAxis() {
            return this.yAxis;
        }
        lf() {
            super.lf();
            if (this.xAxis != null) {
                this.xAxis.h7(false);
            }
            if (this.yAxis != null) {
                this.yAxis.h7(false);
            }
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            if (this.ry.cx.g$b(a, b, c, d)) {
                this.mi(false);
                this.lp();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.sd);
                        c.deregisterColumn(this.se);
                        this.sd = null;
                        this.se = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.sd = this.ch(this.te);
                        this.se = this.ch(this.tm);
                    }
                    if ((this.yAxis != null && !this.yAxis.c0()) || (this.xAxis != null && !this.xAxis.c0())) {
                        this.mi(false);
                    }
                    break;
                case ScatterBase.$$p[7]:
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    if ((this.xAxis != null && !this.xAxis.c0()) || (d == null && c != null)) {
                        this.mi(false);
                    }
                    this.lp();
                    break;
                case ScatterBase.$$p[11]:
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    if ((this.yAxis != null && !this.yAxis.c0()) || (d == null && c != null)) {
                        this.mi(false);
                    }
                    this.lp();
                    break;
                case ScatterBase.$$p[10]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.sd);
                        this.sd = this.ch(this.te);
                    }
                    break;
                case "XColumn":
                    this.ry.cx.g$i();
                    if (this.xAxis != null && !this.xAxis.c0()) {
                        this.mi(false);
                    }
                    break;
                case ScatterBase.$$p[14]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.se);
                        this.se = this.ch(this.tm);
                    }
                    break;
                case "YColumn":
                    this.ry.cx.g$i();
                    if (this.yAxis != null && !this.yAxis.c0()) {
                        this.mi(false);
                    }
                    break;
                case ScatterBase.$$p[5]:
                    this.mi(false);
                    this.lp();
                    break;
                case ScatterBase.$$p[6]:
                    this.mi(false);
                    this.lp();
                    break;
                case "TransitionProgress":
                    this.r5.c(this.g0, this.r3, this.r1);
                    this.to();
                    try {
                        if (this.cx(this.b0)) {
                            return;
                        }
                        if ((Math.round(this.g0 * 100000) / 100000) == 1) {
                            this.t8(this.r1, this.ry);
                        }
                        else {
                            this.t8(this.r5, this.ry);
                        }
                        if (this.cd != null) {
                            this.cd.nn(this);
                        }
                    }
                    finally {
                        this.t9();
                    }
                    break;
                case "TrendLineBrush":
                    this.mw();
                    break;
                case ScatterBase.$$p[0]:
                    if (this.rz != null) {
                        this.rz.r = this;
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case "TrendLineType":
                    this.lp();
                    break;
                case ScatterBase.$$p[2]:
                    this.sg = this.so();
                    this.mi(false);
                    break;
                case ScatterBase.$$p[1]:
                    this.sf = this.sn();
                    this.mi(false);
                    break;
                case ScatterBase.$$p[3]:
                    this.r7 = this.r8();
                    break;
            }
        }
        so() {
            return this.sk;
        }
        sn() {
            return this.sj;
        }
        si(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        sh(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        t9() {
            this.u0 = Rect.empty;
            this.u1 = Rect.empty;
        }
        to() {
            let a = this.getViewInfo(this.u0, this.u1);
            this.u0 = a.p0;
            this.u1 = a.p1;
        }
        sm(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.te == a || this.tm == a) {
                return true;
            }
            return false;
        }
        k0(a, b, c, d) {
            let e = false;
            if (!this.sm(d, a)) {
                return;
            }
            this.ry.cx.g$e(a, b, c, d);
            if (this.xAxis != null && !this.xAxis.c0()) {
                e = true;
            }
            if (this.yAxis != null && !this.yAxis.c0()) {
                e = true;
            }
            if (e) {
                this.mi(true);
            }
        }
        t0(a) {
            this.t1(a, null);
        }
        t1(a, b) {
            let c = this.sd != null ? this.sd.count : 0;
            let d = this.se != null ? this.se.count : 0;
            let e = Math.min(c, d);
            if (e <= this.sy) {
                a.m.clear();
                let f = new List$1(OwnedPoint.$, 0);
                for (let g of fromEnum(a.u.values)) {
                    f.add(g);
                }
                let h = this.ck;
                f.aa((i, j) => {
                    let k = h.indexOf(i.a);
                    let l = h.indexOf(j.a);
                    if (k < l) {
                        return -1;
                    }
                    if (k > l) {
                        return 1;
                    }
                    return 0;
                });
                if (b != null) {
                    b.i = a.m;
                }
                for (let i of fromEnum(f)) {
                    if (h.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
        }
        ap(a) {
            if (a != null && a == this.xAxis && this.sd != null) {
                return new AxisRange(this.sd.minimum, this.sd.maximum);
            }
            if (a != null && a == this.yAxis && this.se != null) {
                return new AxisRange(this.se.minimum, this.se.maximum);
            }
            return null;
        }
        ht(a) {
            let b = this.hd(a);
            if (this.ck != null && b >= 0 && b < this.ck.count) {
                return this.ck.item(b);
            }
            return null;
        }
        get r7() {
            return this.r6;
        }
        set r7(a) {
            let b = this.r6;
            this.r6 = a;
            if (b != this.r6) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.r6));
            }
        }
        r8() {
            if (this.r9 != 0) {
                return this.r9;
            }
            return this.sl ? 4 : 1;
        }
        hd(a) {
            let b = truncate(Math.round(this.f5(a)));
            return b;
        }
        f5(a) {
            switch (this.r7) {
                case 1: return this.su(a);
                case 3: return this.sv(a);
                case 2: return this.ss(a);
                case 4: return this.st(a);
            }
            return -1;
        }
        st(a) {
            return this.sw(a, false);
        }
        ss(a) {
            let b = this.ph(a);
            let c = b.x;
            let d = b.y;
            if (this.ck == null || this.xAxis == null || this.yAxis == null || this.sd == null || this.se == null) {
                return -1;
            }
            if (this.ck.count > this.sx) {
                return -1;
            }
            this.tr();
            let e = this.ri;
            let f = this.rj;
            if (e == null || f == null) {
                return -1;
            }
            let g = 1.7976931348623157E+308;
            let h = -1;
            for (let i = 0; i < this.sd.count; i++) {
                let j = e[i];
                let k = f[i];
                let l = (c - j) * (c - j) + (d - k) * (d - k);
                if (l < g) {
                    g = l;
                    h = i;
                }
            }
            return h;
        }
        tr() {
            let a = this.b0.bv;
            let b = this.b0.bu;
            let c = this.getEffectiveViewport();
            if (this.rx == null) {
                return;
            }
            let d = new ScalerParams(0, a, b, this.rx.d, c);
            let e = ((() => {
                let $ret = new ScalerParams(0, a, b, this.rx.e, c);
                $ret.b = this.gc();
                return $ret;
            })());
            if (this.ri == null || this.rj == null) {
                let f = arrayShallowClone(this.sd.asArray());
                let g = arrayShallowClone(this.se.asArray());
                this.xAxis.hm(boxArray$1(f), 0, f.length, d);
                this.yAxis.hm(boxArray$1(g), 0, g.length, e);
                this.ri = f;
                this.rj = g;
            }
        }
        get_sl() {
            return false;
        }
        get sl() {
            return this.get_sl();
        }
        sw(a, b) {
            if (!this.sl) {
                return -1;
            }
            let c = { $type: Point_$type, x: 0, y: 0 };
            let d = true;
            let e = this.r2();
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.ck == null || this.ck.count > this.sx) {
                return -1;
            }
            this.tr();
            let f = this.ri;
            let g = this.rj;
            if (f == null || g == null) {
                return -1;
            }
            let h = this.ph(a);
            let i = 1.7976931348623157E+308;
            let j = -1;
            for (let k = 0; k < this.ri.length; k++) {
                let l = { $type: Point_$type, x: this.ri[k], y: this.rj[k] };
                if (k > 0) {
                    if (!b || e.j.containsKey(this.ck.item(k)) || e.j.containsKey(this.ck.item(k - 1))) {
                        let m = GeometryUtil.d(h, c, l);
                        if (m < i) {
                            i = m;
                            j = k;
                        }
                    }
                }
                c = l;
            }
            if (j >= 0) {
                let n = { $type: Point_$type, x: this.ri[j], y: this.rj[j] };
                let o = { $type: Point_$type, x: this.ri[j - 1], y: this.rj[j - 1] };
                if (!b || (e.j.containsKey(this.ck.item(j)) && e.j.containsKey(this.ck.item(j - 1)))) {
                    let p = GeometryUtil.h(h, o, n);
                    return (j - 1) + p;
                }
                else if (e.j.containsKey(this.ck.item(j))) {
                    return j;
                }
                else {
                    return j - 1;
                }
            }
            return -1;
        }
        sv(a) {
            return this.sw(a, true);
        }
        su(a) {
            let b = null;
            let c = 1.7976931348623157E+308;
            let d = this.ph(a);
            let e = d.x;
            let f = d.y;
            if (this.ry.cy.e > this.sx) {
                return -1;
            }
            this.ry.c5((g) => {
                if (g._visibility == 0) {
                    let h = this.ry.cp(g);
                    let i = h.left + h.width / 2;
                    let j = h.top + h.height / 2;
                    let k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        }
        pm(a, b, c) {
            if (this.xAxis == null || this.yAxis == null || this.sd == null || this.se == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.b0.bv;
            let e = this.b0.bu;
            let f = this.getEffectiveViewport();
            let g = new ScalerParams(0, d, e, this.xAxis.cg, f);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cg, f);
                $ret.b = this.gc();
                return $ret;
            })());
            if (b) {
                let i = this.f5(a);
                if (i == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let j = truncate(Math.floor(i));
                let k = truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.ck.count - 1) {
                    k = this.ck.count - 1;
                }
                if (j > this.ck.count - 1) {
                    j = this.ck.count - 1;
                }
                if (k == j) {
                    let l = this.xAxis.ei(this.sd.item(j), g);
                    let m = this.yAxis.ei(this.se.item(j), h);
                    return { $type: Point_$type, x: l, y: m };
                }
                let n = i - Math.floor(i);
                let o = this.xAxis.ei(this.sd.item(j), g);
                let p = this.yAxis.ei(this.se.item(j), h);
                let q = this.xAxis.ei(this.sd.item(k), g);
                let r = this.yAxis.ei(this.se.item(k), h);
                let s = q - o;
                let t = r - p;
                return { $type: Point_$type, x: o + s * n, y: p + t * n };
            }
            else {
                let u = this.hd(a);
                if (u == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let v = this.xAxis.ei(this.sd.item(u), g);
                let w = this.yAxis.ei(this.se.item(u), h);
                return { $type: Point_$type, x: v, y: w };
            }
        }
        en(a) {
            let b = this.cd != null ? this.cd.sf : Rect.empty;
            b = b.copy();
            let c = this.cd != null ? this.cd.su : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.pt(this.b0);
            let f = new ScalerParams(0, d, d, this.xAxis.cg, e);
            let g = ((() => {
                let $ret = new ScalerParams(0, d, d, this.yAxis.cg, e);
                $ret.b = this.gc();
                return $ret;
            })());
            let h = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
            let i = this.xAxis != null && this.sd != null && h < this.sd.count ? this.xAxis.ei(this.sd.item(h), f) : NaN;
            let j = this.yAxis != null && this.se != null && h < this.se.count ? this.yAxis.ei(this.se.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.b8 != null) {
                this.b8.au(this.cd, b, true);
            }
            return h >= 0;
        }
        m5(a, b) {
            this.mi(false);
        }
        m6(a, b) {
            this.mi(false);
        }
        r2() {
            let a = this.r1;
            if (this.cv()) {
                if (this.ce.g) {
                    this.ce.t();
                }
                a = this.r5;
            }
            return a;
        }
        tp(a, b, c, d, e) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            let f = this.getEffectiveViewport1(a);
            let g = this.ck;
            let h;
            let i;
            let j = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rx.d, f);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let k = ((() => {
                let $ret = new ScalerParams(0, d, e, this.rx.e, f);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.gc();
                return $ret;
            })());
            let l = false;
            let m = 0;
            if (this.cd != null) {
                if (this.cd.e3()) {
                    let n = this.cd.ku(d, j);
                    l = n.c;
                    m = n.d;
                }
            }
            for (let o = 0; o < c; o++) {
                h = this.sd.item(o);
                i = this.se.item(o);
                let p = { $type: Point_$type, x: this.rx.a.ei(h, j), y: this.rx.b.ei(i, k) };
                if (l) {
                    if (p.x < e.left || p.x > e.right) {
                        if (p.x + m >= e.left && p.x + m <= e.right) {
                            p = { $type: Point_$type, x: p.x + m, y: i };
                        }
                    }
                }
                if (!isInfinity(p.x) && !isInfinity(p.y)) {
                    let q = g.item(o);
                    if (!b.g.containsKey(q)) {
                        let r = { $type: Point_$type, x: h, y: i };
                        let s = { $type: Point_$type, x: p.x, y: p.y };
                        b.g.addItem(q, ((() => {
                            let $ret = new OwnedPoint();
                            $ret.a = q;
                            $ret.b = r;
                            $ret.c = s;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        tx(a, b) {
            this.ri = null;
            this.rj = null;
            a.j.clear();
            a.n.clear();
            a.h.clear();
            a.l.clear();
            a.i.clear();
            a.k.clear();
            let c = Math.min(this.sd != null ? this.sd.count : 0, this.se != null ? this.se.count : 0);
            let d = b.bv;
            let e = b.bu;
            let f = this.getEffectiveViewport1(b);
            let g = new ScalerParams(0, d, e, this.xAxis.cg, f);
            g.c = this.getEffectiveViewport1(b);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cg, f);
                $ret.b = this.gc();
                return $ret;
            })());
            h.c = this.getEffectiveViewport1(b);
            if (c < 1) {
                return;
            }
            this.rx = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.cg;
                $ret.e = this.yAxis.cg;
                $ret.c = this.ck;
                return $ret;
            })());
            let i = b;
            if (c <= this.sy) {
                this.tp(i, a, c, d, e);
            }
            if (this.qf()) {
                b.cv.l(a.j, this.sy, d, e, this.ft);
            }
            let j = ((() => {
                let $ret = new Clipper(0, e, false);
                $ret.i = a.n;
                return $ret;
            })());
            let k = this.pr(b);
            let l = this.xAxis.el(k.left, g);
            let m = this.xAxis.el(k.right, g);
            b.cx.h(a.n, this.trendLineType, this.sd, this.se, this.trendLinePeriod, (n) => this.xAxis.ei(n, g), (n) => this.yAxis.ei(n, h), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.b = this.ft;
                $ret.f = e;
                $ret.g = d;
                return $ret;
            })()), j, l, m);
            this.tv(a, b);
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            c.c4(a);
        }
        get_dx() {
            return true;
        }
        rr(a, b, c) {
            return null;
        }
        rs(a, b, c) {
            let d = this.r2();
            let e = this.ry.by(this.ph(b));
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.ck.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.b = this;
            g.h = f;
            g.g = f;
            g.d = false;
            g.e = true;
            if (c != null && c.h == g.h && c.g == g.g) {
                return c;
            }
            return g;
        }
        p1(a, b) {
            if (this.qd != 1 && this.qd != 13) {
                let c = this.qc.cq();
                let d = (c.width / 2) + (this.qi / 2);
                let e = (c.height / 2) + (this.qi / 2);
                let f = d;
                let g = d;
                let h = e;
                let i = e;
                if (a == 2 || a == 4) {
                    f = 0;
                }
                if (a == 2 || a == 3) {
                    g = 0;
                }
                if (b == 2 || b == 3) {
                    h = 0;
                }
                if (b == 2 || b == 4) {
                    i = 0;
                }
                return new Thickness(1, f, h, g, i);
            }
            return new Thickness(1, 0, 0, 0, 0);
        }
        rq(a, b, c) {
            let d = new HighlightingInfo();
            d.b = this;
            d.h = 0;
            d.g = this.ck.count - 1;
            d.d = true;
            if (c != null && c.h == d.h && c.g == d.g) {
                return c;
            }
            return d;
        }
        aw(a, b, c) {
            if (this.c2 && this.ef(this.bk) && !c) {
                let d = this.rr(a, b, this.rt);
                this.rt = d;
                return d;
            }
            else {
                let e = this.rq(a, b, this.rt);
                this.rt = e;
                return e;
            }
        }
        ax(a, b, c) {
            if (this.ef(this.bk) && !c) {
                let d = this.rs(a, b, this.ru);
                this.ru = d;
                return d;
            }
            else {
                let e = this.rq(a, b, this.ru);
                e.e = true;
                this.ru = e;
                return e;
            }
        }
        sq() {
            return (this.assigningScatterStyle != null && this.sg) || (this.bk != 1);
        }
        sp() {
            return (this.assigningScatterMarkerStyle != null && this.sf) || (this.bk != 1);
        }
        t8(a, b) {
            let c = b.bu;
            this.rx = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.cg;
                $ret.e = this.yAxis.cg;
                return $ret;
            })());
            if (this.qf()) {
                b.cv.j(a.j, this.qh);
                if (this.sp()) {
                    this.tq(b, a);
                }
            }
            b.cm();
            let d = ((() => {
                let $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
                $ret.i = b.cx.g$j.ak;
                return $ret;
            })());
            b.cx.g$h(a.n, d);
            this.t5(a, b);
        }
        rl(a, b) {
            return this.rm(a, b);
        }
        rm(a, b) {
            if (b < a || a < 0 || a > this.sd.count || b < 0 || b > this.sd.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.ck.item(d);
            }
            return c;
        }
        tq(a, b) {
            a.b3 = true;
            this.sa.aw(this, this.sp(), runOn(this, this.rl));
            let c = this.sa.d;
            let d = c != null;
            let e = this.getEffectiveViewport1(a);
            let f = this.ck == null ? 0 : this.ck.count;
            this.ry.cf((g) => {
                if (g._visibility == 0) {
                    let h = g.ak;
                    let i = g.content;
                    if (i == null) {
                        i = new DataContext();
                        g.content = i;
                    }
                    if (d) {
                        this.ts(h, f, a.q);
                    }
                    this.sa.ac(g, i);
                }
            });
        }
        tt(a, b, c) {
            let d = this.bk != 1;
            this.sa.ay(this.sa.b, a, b, false);
            this.sa.ab(this.fr);
            let e = this.sa.av;
            let f = null;
            let g = this.ck;
            if (d && this.cd != null) {
                f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, false);
                e.b = f;
            }
            e.f = c;
            this.t3(e);
            this.sa.z(this, f, c, d, a < 0);
        }
        ts(a, b, c) {
            let d = this.bk != 1;
            this.sa.ay(this.sa.d, a, b, true);
            this.sa.aa(this.fr);
            let e = this.sa.au;
            let f = null;
            let g = this.ck;
            let h = null;
            if (d && this.cd != null) {
                f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                if (this.cd.a3.isCrossSeriesHighlight(this)) {
                    h = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
                }
                e.b = f;
            }
            e.f = c;
            this.t2(e);
            this.sa.y(this, f, c, d, e.m, this.cd.a3.totalHighlightingProgress);
        }
        t3(a) {
            if (this.assigningScatterStyle != null && this.sg) {
                this.assigningScatterStyle(this, a);
            }
        }
        t2(a) {
            if (this.assigningScatterMarkerStyle != null && this.sf) {
                this.assigningScatterMarkerStyle(this, a);
            }
        }
        tv(a, b) {
            let c = new ErrorBarsHelper(this, b);
            if (this.rz == null) {
                return;
            }
            let d = this.rz.u;
            let e = this.rz.v;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            for (let j of fromEnum(a.j.keys)) {
                let k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            let l = this.ty(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            let m = this.tw(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            let n = this.tu(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            let o = this.tz(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            let p = this.tw(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    let q = new OwnedPoint();
                    q.c = c.l(d, this.rx.a, k.c, f);
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            let r = this.ty(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            let s = this.tw(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            let t = this.tu(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            let u = this.tz(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            let v = this.tw(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    let w = new OwnedPoint();
                    w.c = c.m(e, this.rx.b, k.c, g);
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        ty(a, b, c, d, e, f) {
            if (f) {
                let g;
                let h, i;
                i = this.rx.a;
                if (this.rz.s == 0) {
                    g = a.c.x;
                    h = this.rx.a;
                }
                else {
                    g = a.c.y;
                    h = this.rx.b;
                }
                let j = b.f(g, c, h, i, d, e);
                d = j.p4;
                e = j.p5;
            }
            else {
                let k;
                let l, m;
                m = this.rx.b;
                if (this.rz.t == 0) {
                    k = a.c.x;
                    l = this.rx.a;
                }
                else {
                    k = a.c.y;
                    l = this.rx.b;
                }
                let n = b.f(k, c, l, m, d, e);
                d = n.p4;
                e = n.p5;
            }
            return {
                p3: d,
                p4: e
            };
        }
        tw(a, b, c, d, e, f) {
            if (f) {
                let g = b.j(a.c.x, c, this.rx.a, d, e);
                d = g.p3;
                e = g.p4;
            }
            else {
                let h = b.j(a.c.y, c, this.rx.b, d, e);
                d = h.p3;
                e = h.p4;
            }
            return {
                p3: d,
                p4: e
            };
        }
        tu(a, b, c, d, e, f, g) {
            let h = c.getItemColumn();
            let i = this.ck.indexOf(d);
            if (h != null && i < h.count) {
                let j = h.item(i);
                if (g) {
                    let k = b.h(a.c.x, j, this.rx.a, e, f);
                    e = k.p3;
                    f = k.p4;
                }
                else {
                    let l = b.h(a.c.y, j, this.rx.b, e, f);
                    e = l.p3;
                    f = l.p4;
                }
            }
            else {
                e = NaN;
                f = NaN;
            }
            return {
                p4: e,
                p5: f
            };
        }
        tz(a, b, c, d, e, f) {
            let g = a.i(b, c);
            c = g.p1;
            if (f) {
                let h = a.k(c, b, this.rx.a, d, e);
                d = h.p3;
                e = h.p4;
            }
            else {
                let i = a.k(c, b, this.rx.b, d, e);
                d = i.p3;
                e = i.p4;
            }
            return {
                p2: c,
                p3: d,
                p4: e
            };
        }
        t5(a, b) {
            if (!b.o() || this.rz == null) {
                b.c6();
                return;
            }
            this.t6(a, b);
            this.t7(a, b);
        }
        t6(a, b) {
            b.c2();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.rz.u;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.i.containsKey(f)) {
                    let g = a.i.item(f)[0];
                    let h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.h.item(f).c;
                        if (this.rz.o == 1 || this.rz.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.rz.o == 1 || this.rz.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
            b.c7(d);
        }
        t7(a, b) {
            b.c3();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.rz.v;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.k.containsKey(f)) {
                    let g = a.k.item(f)[0];
                    let h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.l.item(f).c;
                        if (this.rz.p == 1 || this.rz.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.rz.p == 1 || this.rz.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        e9(a, b, c) {
            let d = true;
            if (!super.e9(a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.sd == null || this.se == null || this.sd.count == 0 || this.se.count == 0 || this.ck == null || this.ck.count != this.sd.count || this.ck.count != this.se.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.lv == this.xAxis.lu || this.yAxis.lv == this.yAxis.lu) {
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            if (!this.u0.isEmpty && !this.u1.isEmpty) {
                a = this.u0;
                b = this.u1;
                return {
                    p0: a,
                    p1: b
                };
            }
            a = this.b0.bu;
            b = this.b0.bv;
            return {
                p0: a,
                p1: b
            };
        }
        mj(a) {
            this.to();
            try {
                if (this.cx(this.b0)) {
                    return;
                }
                if (this.ck != null && this.ck.count > this.sy) {
                    a = false;
                }
                if (this.eo(a) && !this.es) {
                    let b = this.r3;
                    if (this.cv()) {
                        if (this.ce.g) {
                            this.ce.t();
                        }
                        this.r3 = this.r5;
                        this.r5 = b;
                    }
                    else {
                        this.r3 = this.r1;
                        this.r1 = b;
                    }
                    this.tx(this.r1, this.ry);
                    this.mr();
                }
                else {
                    if (!this.es) {
                        this.tx(this.r1, this.ry);
                    }
                    this.t8(this.r1, this.ry);
                }
            }
            finally {
                this.t9();
            }
        }
        mw() {
            super.mw();
            if (this.index < 0) {
                return;
            }
            this.ry.da();
        }
        mk(a, b) {
            super.mk(a, b);
            if (!this.ez) {
                this.b0.a2(b);
                return;
            }
            this.b0.a2(b);
            if (this.cx(this.bz)) {
                return;
            }
            let c = typeCast(ScatterBaseView.$, this.bz);
            if (!this.et) {
                this.r4 = new ScatterFrame();
                this.tx(this.r4, c);
            }
            this.et = false;
            this.t8(this.r4, c);
            this.ez = false;
        }
        mh(a, b, c, d, e) {
            super.mh(a, b, c, d, e);
            let f = this.a6.a$h.item(d);
            let g = f;
            f.a1(c);
            if (this.cx(g)) {
                return;
            }
            if (this.r0 == null) {
                this.r0 = new ScatterFrame();
            }
            this.tx(this.r0, g);
            this.t8(this.r0, g);
        }
        t4(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        rk(a, b, c, d, e) {
            if (c == null || c.length != this.rx.c.count) {
                c = new Array(this.rx.c.count);
                for (let f = 0; f < this.rx.c.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = this.getEffectiveViewport1(a);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.xAxis.cg, g);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.cg, g);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.gc();
                return $ret;
            })());
            let j = this.pr(a);
            let k = this.rx.a.el(j.left, h);
            let l = this.rx.a.el(j.right, h);
            let m = this.rx.b.el(j.bottom, i);
            let n = this.rx.b.el(j.top, i);
            if (this.rx.d) {
                let o = k;
                k = l;
                l = o;
            }
            if (this.rx.e) {
                let p = m;
                m = n;
                n = p;
            }
            let q = this.rx;
            let r = q.a;
            let s = q.b;
            let t;
            let u;
            let v = this.sd;
            let w = this.se;
            let x = false;
            let y = 0;
            let z = 0;
            if (this.cd != null) {
                if (this.cd.e3()) {
                    let aa = this.cd.ku(d, h);
                    x = aa.c;
                    y = aa.d;
                    z = r.el(0 + y, h);
                    let ab = r.el(0, h);
                    z -= ab;
                }
            }
            for (let ac = 0; ac < this.rx.c.count; ac++) {
                t = v.item(ac);
                u = w.item(ac);
                if (x) {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.ei(t, h);
                        c[ac].y = s.ei(u, i);
                    }
                    else {
                        if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                            c[ac].x = r.ei(t, h) + y;
                            c[ac].y = s.ei(u, i);
                        }
                        else {
                            c[ac].x = NaN;
                            c[ac].y = NaN;
                        }
                    }
                }
                else {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.ei(t, h);
                        c[ac].y = s.ei(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            return c;
        }
        sr(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.ck;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
            }
            return b;
        }
        k7(a) {
            super.k7(a);
            this.a8.exportTrendlineData(this, a, this.ry.cx.g$j);
        }
        gc() {
            return Series.gd(this.se, null);
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ht(c);
            let e = d == null ? NaN : this.gb(d, "XMemberPath");
            let f = d == null ? NaN : this.gb(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.l = e;
            g.a = 13;
            g.p = this.te != null ? this.te : "X:";
            g.q = this.ta != null ? this.ta : "X:";
            g.r = this.tc != null ? this.tc : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.p = this.tm != null ? this.tm : "Y:";
            h.q = this.ti != null ? this.ti : "Y:";
            h.r = this.tk != null ? this.tk : "";
            let i = new DataLegendSeriesContext();
            i.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.b = this.av();
            return i;
        }
    }
    ScatterBase.$t = markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.ua = DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    ScatterBase.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:rz:ub', [ScatterErrorBarSettings.$, null], 'IsCustomScatterMarkerStyleAllowed:sj:uc', [0, false], 'IsCustomScatterStyleAllowed:sk:ud', [0, false], 'ItemSearchMode:r9:ue', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sx:uf', [1, 10000], 'MarkerCollisionAvoidance:rp:ug', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:sy:uh', [1, 400], 'XAxis::up', [NumericXAxis.$, null], 'XMemberAsLegendLabel:ta:uq', [2, null], 'XMemberAsLegendUnit:tc:ur', [2, null], 'XMemberPath:te:us', [2, null], 'YAxis::ut', [NumericYAxis.$, null], 'YMemberAsLegendLabel:ti:uu', [2, null], 'YMemberAsLegendUnit:tk:uv', [2, null], 'YMemberPath:tm:uw', [2, null], 'TrendLineType::un', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::um', [1, 1.5], 'TrendLinePeriod::ul', [1, 7], 'TrendLineBrush::ui', [Brush.$, null], 'TrendLineZIndex:sz:uo', [1, 1001], 'TrendLineDashArray:uy:uj', [DoubleCollection.$], 'TrendLineDashCap:uz:uk', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
})();
/**
 * @hidden
 */
export let ScatterSeriesRenderManager = /*@__PURE__*/ (() => {
    class ScatterSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.au = null;
            this.av = null;
        }
        c() {
            this.au = new AssigningScatterMarkerStyleEventArgs();
            return this.au;
        }
        a() {
            this.av = new AssigningScatterStyleEventArgs();
            return this.av;
        }
        aw(a, b, c) {
            this.w(a, b, c);
        }
        ax(a, b, c) {
            this.x(a, b, c);
        }
        ay(a, b, c, d) {
            if (b == -1) {
                a.c = false;
                a.o = 0;
                a.n = c - 1;
            }
            else {
                if (d) {
                    a.o = b;
                    a.n = b;
                }
                else {
                    a.c = false;
                    a.o = b;
                    a.n = b;
                }
            }
        }
    }
    ScatterSeriesRenderManager.$t = markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
    return ScatterSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ScatterBaseView = /*@__PURE__*/ (() => {
    class ScatterBaseView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.cv = null;
            this.ct = null;
            this.cw = null;
            this.c1 = null;
            this.dc = null;
            this.dd = null;
            this.cx = null;
            this.db = null;
            this.cy = null;
            this.cw = a;
            this.cy = new HashPool$2(Base.$, Marker.$);
            this.ch(this.cy);
            this.cx = new ScatterTrendLineManager();
        }
        as() {
            super.as();
            this.cv = this.cu();
            this.dc = new Path();
            this.dd = new Path();
            if (!this.q) {
                this.cw.sy = 2000;
            }
        }
        de(a) {
            if (this.db == null) {
                this.db = new DataTemplateMeasureInfo();
                this.db.context = this.k.g();
            }
            this.db.width = a.width;
            this.db.height = a.height;
            this.db.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.db);
            }
            return new Size(1, this.db.width, this.db.height);
        }
        cu() {
            let a = new NumericMarkerManager(1, (b) => this.cy.item(b), (b) => this.cw.rx.c.item(b), runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz), () => this.cw.rp);
            a.q = runOn(this, this.de);
            return a;
        }
        c9(a) {
            this.cw.t4(a, this.cy);
        }
        c0() {
            return this.b4;
        }
        cs() {
            return this.ct;
        }
        cr() {
            this.ct = this.cw.rk(this, this.cy, this.ct, this.bv, this.bu);
            return this.ct;
        }
        cz() {
            this.c1 = this.cw.sr(this.cy, this.c1);
            return this.c1;
        }
        c2() {
        }
        c7(a) {
        }
        c3() {
        }
        c8(a) {
        }
        da() {
            if (this.cw.trendLineBrush != null) {
                this.cw.ux = this.cw.trendLineBrush;
            }
            else {
                this.cw.ux = this.cw.oz;
            }
        }
        cf(a) {
            this.cy.f(a);
        }
        c5(a) {
            this.cy.g(a);
        }
        c6() {
        }
        a5(a, b) {
            super.a5(a, b);
            if (a.d) {
                if (this.cw.trendLineType != 0 && !b) {
                    let c = this.cx.g$j;
                    c.ac = this.cw.trendLineThickness;
                    c._stroke = this.cw.ux;
                    c.ai = this.cw.uy;
                    c.ad = this.cw.uz;
                    a.u(c);
                }
            }
        }
        c4(a) {
            if (a) {
                this.c6();
                this.cy.clear();
            }
            this.cx.g$d();
            this.aq();
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a6.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.cw.title + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cw.te + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cw.tm + "}</span></div>";
            return a;
        }
    }
    ScatterBaseView.$t = markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
})();
