/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core";
import { IEnumerable_$type, runOn, delegateCombine, delegateRemove, typeCast, Point_$type, markType, markDep } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Triangulator } from "igniteui-angular-core";
import { TriangulationStatusEventArgs } from "igniteui-angular-core";
import { FastItemsSource } from "igniteui-angular-core";
import { SeriesViewer } from "./SeriesViewer";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterTriangulationSeries = /*@__PURE__*/ (() => {
    class ScatterTriangulationSeries extends Series {
        constructor() {
            super(...arguments);
            this.qb = null;
            this.qc = null;
            this.qk = false;
            this.p7 = null;
            this.triangulationStatusChanged = null;
            this.qn = null;
            this.p8 = null;
            this.p9 = null;
            this.qa = null;
        }
        ku() {
            super.ku();
            this.p4 = null;
            this.p5 = null;
        }
        hw(a, b) {
            let c = this.jq(b);
            if (c == ScatterTriangulationSeries.$$p[8]) {
                return this.hx(a, b, this.q6);
            }
            if (c == ScatterTriangulationSeries.$$p[12]) {
                return this.hx(a, b, this.re);
            }
            return super.hw(a, b);
        }
        get qh() {
            return this.qb;
        }
        set qh(a) {
            let b = this.qh != a;
            if (b) {
                let c = this.qh;
                this.qb = a;
                this.raisePropertyChanged("XColumn", c, this.qh);
            }
        }
        get qi() {
            return this.qc;
        }
        set qi(a) {
            let b = this.qi != a;
            if (b) {
                let c = this.qi;
                this.qc = a;
                this.raisePropertyChanged("YColumn", c, this.qi);
            }
        }
        mj(a) {
            let b = this.ck != null && this.qj == null && this.qn == null && this.qh != null && this.qi != null && this.qh.count >= 3 && this.qi.count >= 3 && !this.qk;
            if (b) {
                this.ri();
                this.qk = true;
            }
        }
        ri() {
            this.p7 = new Triangulator(this.ck.count, this.qh, this.qi);
            let a = this.p7;
            a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.rj));
            this.p7.y();
        }
        rg() {
            if (this.p7 == null) {
                return;
            }
            this.p7.r();
            let a = this.p7;
            a.triangulationStatusChanged = delegateRemove(a.triangulationStatusChanged, runOn(this, this.rj));
            this.p7 = null;
        }
        rj(a, b) {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(b.currentStatus));
            }
            if (b.currentStatus >= 100) {
                if (this.p7 == null) {
                    return;
                }
                let c = this.p7;
                c.triangulationStatusChanged = delegateRemove(c.triangulationStatusChanged, runOn(this, this.rj));
                this.qn = this.p7.n();
                this.p7 = null;
                let d = ((() => {
                    let $ret = new FastItemsSource();
                    $ret.e = this.qn;
                    return $ret;
                })());
                this.qe = this.qd(d, "v1");
                this.qf = this.qd(d, "v2");
                this.qg = this.qd(d, "v3");
                this.mi(false);
            }
        }
        qd(a, b) {
            if (b == null) {
                return a.registerColumnInt(null, null, false);
            }
            let c = null;
            let d = SeriesViewer.cc(b, this.coercionMethods);
            c = d.a;
            return a.registerColumnInt(b, c, this.expectFunctions);
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.qh);
                        e.deregisterColumn(this.qi);
                        this.qh = null;
                        this.qi = null;
                    }
                    this.rh();
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.qh = this.ch(this.q6);
                        this.qi = this.ch(this.re);
                    }
                    this.mi(false);
                    break;
                case ScatterTriangulationSeries.$$p[8]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.qh);
                        this.qh = this.ch(this.q6);
                    }
                    this.rh();
                    this.mi(false);
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[12]:
                    if (this.ck != null) {
                        this.ck.deregisterColumn(this.qi);
                        this.qi = this.ch(this.re);
                    }
                    this.rh();
                    this.mi(false);
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[5]:
                    if (c != null) {
                        (typeCast(Axis.$, c)).bz(this);
                    }
                    if (d != null) {
                        (typeCast(Axis.$, d)).cs(this);
                    }
                    if ((this.p4 != null && !this.p4.c0()) || (d == null && c != null)) {
                        this.mi(false);
                    }
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[9]:
                    if (c != null) {
                        (typeCast(Axis.$, c)).bz(this);
                    }
                    if (d != null) {
                        (typeCast(Axis.$, d)).cs(this);
                    }
                    if ((this.p5 != null && !this.p5.c0()) || (d == null && c != null)) {
                        this.mi(false);
                    }
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[1]:
                    if (this.trianglesSource != null) {
                        this.rg();
                        this.qj = ((() => {
                            let $ret = new FastItemsSource();
                            $ret.e = this.trianglesSource;
                            return $ret;
                        })());
                    }
                    else {
                        this.qj = null;
                    }
                    break;
                case ScatterTriangulationSeries.$$p[0]:
                    let g = typeCast(IFastItemsSource_$type, c);
                    if (g != null) {
                        g.deregisterColumn(this.qe);
                        g.deregisterColumn(this.qf);
                        g.deregisterColumn(this.qg);
                        this.qe = null;
                        this.qf = null;
                        this.qg = null;
                    }
                    let h = typeCast(IFastItemsSource_$type, d);
                    if (h != null) {
                        this.qe = this.qd(h, this.qu);
                        this.qf = this.qd(h, this.qw);
                        this.qg = this.qd(h, this.qy);
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[2]:
                    if (this.qj != null) {
                        this.qj.deregisterColumn(this.qe);
                        this.qe = this.qd(this.qj, this.qu);
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[3]:
                    if (this.qj != null) {
                        this.qj.deregisterColumn(this.qf);
                        this.qf = this.qd(this.qj, this.qw);
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case ScatterTriangulationSeries.$$p[4]:
                    if (this.qj != null) {
                        this.qj.deregisterColumn(this.qg);
                        this.qg = this.qd(this.qj, this.qy);
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case "XColumn":
                    if (this.p4 != null) {
                        this.p4.c0();
                    }
                    break;
                case "YColumn":
                    if (this.p5 != null) {
                        this.p5.c0();
                    }
                    break;
            }
        }
        qm(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        ql(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        e9(a, b, c) {
            return super.e9(a, b, c) && this.ck != null && this.p4 != null && this.p5 != null && this.p4.bh != null && this.p5.bh != null && a.width > 0 && a.height > 0 && this.qe != null && this.qe.count > 0 && this.qf != null && this.qf.count > 0 && this.qg != null && this.qg.count > 0 && this.qh != null && this.qh.count > 0 && this.qi != null && this.qi.count > 0;
        }
        rh() {
            if (this.trianglesSource == null) {
                this.qn = null;
                this.qe = null;
                this.qf = null;
                this.qg = null;
                this.qk = false;
            }
        }
        lf() {
            super.lf();
            if (this.p4 != null) {
                this.p4.h6();
            }
            if (this.p5 != null) {
                this.p5.h6();
            }
        }
        k0(a, b, c, d) {
            super.k0(a, b, c, d);
            this.rh();
            this.mi(false);
        }
        ap(a) {
            if (a != null && a == this.p4 && this.qh != null) {
                return new AxisRange(this.qh.minimum, this.qh.maximum);
            }
            if (a != null && a == this.p5 && this.qi != null) {
                return new AxisRange(this.qi.minimum, this.qi.maximum);
            }
            return null;
        }
        m6(a, b) {
            this.mi(false);
        }
        m5(a, b) {
            this.mi(false);
        }
        get qe() {
            return this.p8;
        }
        set qe(a) {
            let b = this.qe != a;
            if (b) {
                let c = this.qe;
                this.p8 = a;
                this.raisePropertyChanged("TriangleVertexColumn1", c, this.qe);
            }
        }
        get qf() {
            return this.p9;
        }
        set qf(a) {
            let b = this.qf != a;
            if (b) {
                let c = this.qf;
                this.p9 = a;
                this.raisePropertyChanged("TriangleVertexColumn2", c, this.qf);
            }
        }
        get qg() {
            return this.qa;
        }
        set qg(a) {
            let b = this.qg != a;
            if (b) {
                let c = this.qg;
                this.qa = a;
                this.raisePropertyChanged("TriangleVertexColumn3", c, this.qg);
            }
        }
        get_ed() {
            return true;
        }
        get_d2() {
            return true;
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.ht(c);
            let e = d == null ? NaN : this.gb(d, "XMemberPath");
            let f = d == null ? NaN : this.gb(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.l = e;
            g.a = 13;
            g.p = this.q6 != null ? this.q6 : "X";
            ;
            g.q = this.q2 != null ? this.q2 : "X:";
            g.r = this.q4 != null ? this.q4 : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.p = this.re != null ? this.re : "Y";
            ;
            h.q = this.ra != null ? this.ra : "Y:";
            h.r = this.rc != null ? this.rc : "";
            let i = new DataLegendSeriesContext();
            i.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.b = this.av();
            return i;
        }
    }
    ScatterTriangulationSeries.$t = markType(ScatterTriangulationSeries, 'ScatterTriangulationSeries', Series.$);
    ScatterTriangulationSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterTriangulationSeries, 'raisePropertyChanged', ['FastTrianglesSource:qj:rk', [IFastItemsSource_$type, null], 'TrianglesSource::rl', [IEnumerable_$type, null], 'TriangleVertexMemberPath1:qu:rm', [2, null], 'TriangleVertexMemberPath2:qw:rn', [2, null], 'TriangleVertexMemberPath3:qy:ro', [2, null], 'XAxis:p4:rp', [NumericXAxis.$, null], 'XMemberAsLegendLabel:q2:rq', [2, null], 'XMemberAsLegendUnit:q4:rr', [2, null], 'XMemberPath:q6:rs', [2, null], 'YAxis:p5:rt', [NumericYAxis.$, null], 'YMemberAsLegendLabel:ra:ru', [2, null], 'YMemberAsLegendUnit:rc:rv', [2, null], 'YMemberPath:re:rw', [2, null]]);
    return ScatterTriangulationSeries;
})();
