/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Point_$type, typeCast, Delegate_$type, markType, markDep } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { AxisAnnotationFrame } from "./AxisAnnotationFrame";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { SeriesView } from "./SeriesView";
import { NotImplementedException } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { stringFormat } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ValueOverlay = /*@__PURE__*/ (() => {
    class ValueOverlay extends Series {
        constructor() {
            super();
            this.ql = 0;
            this.qm = 0;
            this.qi = 0;
            this.p5 = null;
            this.qb = null;
            this.qa = null;
            this.ab = ValueOverlay.$;
        }
        gj(a, b, c) {
            return this.qn;
        }
        qj(a, b) {
            let c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
            let d = Math.acos((a.x - b.x) / c);
            if ((a.y - b.y) < 0) {
                d = (2 * Math.PI) - d;
            }
            return d;
        }
        pm(a, b, c) {
            if (this.p4 == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.qk();
            let e = NaN;
            let f = NaN;
            let g = NaN;
            let h = { $type: Point_$type, x: 0.5, y: 0.5 };
            let i = NaN;
            switch (this.p4.a1) {
                case 2:
                    i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                    g = d;
                    e = h.x + Math.cos(g) * i;
                    f = h.y + Math.sin(g) * i;
                    f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
                    e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
                    break;
                case 0:
                    e = d;
                    f = a.y;
                    f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
                    break;
                case 1:
                    f = d;
                    e = a.x;
                    e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
                    break;
                case 3:
                    g = this.qj(a, h);
                    i = d;
                    e = h.x + Math.cos(g) * i;
                    f = h.y + Math.sin(g) * i;
                    f = this.b0.bu.top + this.b0.bu.height * (f - this.b0.bv.top) / this.b0.bv.height;
                    e = this.b0.bu.left + this.b0.bu.width * (e - this.b0.bv.left) / this.b0.bv.width;
                    break;
            }
            return { $type: Point_$type, x: e, y: f };
        }
        hd(a) {
            throw new NotImplementedException(0);
        }
        ht(a) {
            return this;
        }
        en(a) {
            return false;
        }
        ap(a) {
            let b = typeCast(NumericAxisBase.$, a);
            let c = this.qn;
            if (isNaN_(c) || isInfinity(c)) {
                return null;
            }
            return new AxisRange(c, c);
        }
        mj(a) {
            this.kx(true, this.b0);
            if (!this.p9()) {
                if (this.p5 != null) {
                    this.q6(NaN, this.cv());
                }
                return;
            }
            if (this.eo(a)) {
                if (this.cv()) {
                    if (this.ce.g) {
                        this.ce.t();
                    }
                    let b = this.ql;
                    this.ql = this.qm;
                    this.qm = b;
                }
                else {
                    this.ql = this.qi;
                }
                this.qi = this.qk();
                this.mr();
            }
            else {
                this.qi = this.qk();
                this.q5(this.qi, this.p7);
            }
        }
        qk() {
            let a, b;
            let c = this.getViewInfo(b, a);
            b = c.p0;
            a = c.p1;
            let d = this.getEffectiveViewport1(this.b0);
            let e = new ScalerParams(0, a, b, this.p4.cg, d);
            return this.p4.ei(this.qn, e);
        }
        q5(a, b) {
            if (this.p4 == null) {
                return;
            }
            let c = typeCast(CategoryAxisBase.$, this.p4);
            if (c != null && !c.cd) {
                if (this.qn > c.lf - 1) {
                    return;
                }
                if (c.categoryMode != 0) {
                    let d = this.getEffectiveViewport1(b);
                    let e = 0.5 * c.getCategorySize(b.bv, b.bu, d);
                    let f = false;
                    if (c.co && !c.cg) {
                        f = true;
                    }
                    if (typeCast(CategoryXAxis.$, c) !== null && c.cg) {
                        f = true;
                    }
                    if (f) {
                        e = -e;
                    }
                    a += e;
                }
            }
            let g = typeCast(NumericAxisBase.$, this.p4);
            if (g != null) {
                if (this.qn < g.lv || this.qn > g.lu) {
                    return;
                }
                if (g.lh && this.qn < 0) {
                    return;
                }
            }
            let h;
            switch (this.p4.a1) {
                case 2:
                case 3:
                    h = this.p4.j4(a, b.bv, b.bu, this.getEffectiveViewport1(b), this.pr(b));
                    break;
                default:
                    h = this.p4.j4(a, b.bv, b.bu);
                    break;
            }
            if (h != null) {
                b.by(h);
            }
            if (!b.q) {
                this.q6(a, this.cv());
            }
        }
        e9(a, b, c) {
            let d = true;
            d = super.e9(a, b, c);
            if (!c.o() || b.isEmpty || a.isEmpty || this.p4 == null || this.p4.bh == null) {
                d = false;
            }
            return d;
        }
        m6(a, b) {
            this.mi(false);
        }
        m5(a, b) {
            this.mi(false);
        }
        k0(a, b, c, d) {
            throw new NotImplementedException(0);
        }
        l4(a, b, c, d) {
            super.l4(a, b, c, d);
            switch (b) {
                case ValueOverlay.$$p[11]:
                    if (c != null) {
                        c.bz(this);
                    }
                    if (d != null) {
                        d.cs(this);
                    }
                    this.mi(false);
                    this.lp();
                    break;
                case "TransitionProgress":
                    this.qm = this.ql + this.g0 * (this.qi - this.ql);
                    if (this.cx(this.b0)) {
                        return;
                    }
                    if (this.g0 == 1) {
                        this.q5(this.qi, this.p7);
                    }
                    else {
                        this.q5(this.qm, this.p7);
                    }
                    if (this.cd != null) {
                        this.cd.nn(this);
                    }
                    break;
                case ValueOverlay.$$p[13]:
                    let e = typeCast(NumericAxisBase.$, this.p4);
                    if (e != null) {
                        e.c0();
                    }
                    this.mi(true);
                    this.lq();
                    break;
                case ValueOverlay.$$p[12]:
                case ValueOverlay.$$p[10]:
                case ValueOverlay.$$p[1]:
                case ValueOverlay.$$p[0]:
                case ValueOverlay.$$p[3]:
                case ValueOverlay.$$p[4]:
                case ValueOverlay.$$p[9]:
                case ValueOverlay.$$p[5]:
                case ValueOverlay.$$p[6]:
                case ValueOverlay.$$p[7]:
                case ValueOverlay.$$p[8]:
                    this.mi(true);
                    break;
            }
        }
        lf() {
            super.lf();
            if (this.p4 != null) {
                this.p4.h7(false);
            }
        }
        kx(a, b) {
            super.kx(a, b);
            let c = b;
            c.bx();
        }
        p9() {
            if (this.p4 == null || this.p4.bh == null || isNaN_(this.qn) || this._visibility != 0) {
                return false;
            }
            let a = typeCast(CategoryAxisBase.$, this.p4);
            if (a != null && a.lf == 0) {
                return false;
            }
            return true;
        }
        preferredCategoryMode(a) {
            return 0;
        }
        get categoryAxis() {
            return typeCast(CategoryAxisBase.$, this.p4);
        }
        bx() {
            return new ValueOverlayView(this);
        }
        lz(a) {
            super.lz(a);
            this.p7 = typeCast(ValueOverlayView.$, a);
        }
        mk(a, b) {
            super.mk(a, b);
            if (!this.ez) {
                this.b0.a2(b);
                return;
            }
            this.b0.a2(b);
            if (this.cx(this.bz) || !this.p9()) {
                return;
            }
            let c = this.getEffectiveViewport1(this.b0);
            let d = this.p4.ei(this.qn, new ScalerParams(0, this.bz.bv, a, this.p4.cg, c));
            this.q5(d, typeCast(ValueOverlayView.$, this.bz));
            this.ez = false;
        }
        getOffsetValue() {
            return 0;
        }
        getCategoryWidth() {
            return 0;
        }
        get ro() {
            return new Thickness(1, this.qe, this.qg, this.qf, this.qd);
        }
        ag() {
            return [this.p4];
        }
        q6(a, b) {
            if (isNaN_(a)) {
                if (this.p5 != null) {
                    AxisAnnotationFrameManager.b(this.p5);
                    AxisAnnotationFrameManager.d(this, this.p5, true, this.qa, this.qb, b, this.qo, this.qo, this.p6, this.p6);
                }
                return;
            }
            let c = false;
            if (this.qa == null) {
                c = true;
                this.qb = new List$1(Axis.$, 0);
                this.qa = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
            }
            this.p5 = new AxisAnnotationFrame();
            let d = this.oz;
            if (d == null) {
                d = this.o3;
            }
            let e = this.p4.co;
            AxisAnnotationFrameManager.c(this.p5, { $type: Point_$type, x: a, y: a }, this, this.cd, this.getEffectiveViewport(), d, this.rl, this.qc, this.rn, this.rm, this.ro, this.qh, this.rl, this.qc, this.rn, this.rm, this.ro, this.qh, !e && this.p8, e && this.p8);
            AxisAnnotationFrameManager.d(this, this.p5, c, this.qa, this.qb, b, this.qo, this.qo, this.p6, this.p6);
        }
        get_isValueOverlay() {
            return true;
        }
        q1(a) {
            if (this.p4 != null) {
                return this.p4.gc(a);
            }
            return null;
        }
        get q3() {
            let a = this.q1(this.qn);
            return a != null ? a : stringFormat("{0:0.##}", this.qn);
        }
    }
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:qc:q7', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:rl:q8', [Brush.$, null], 'AxisAnnotationFormatLabel:p6:q9', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:qo:ra', [1, -1], 'AxisAnnotationOutline:rm:rb', [Brush.$, null], 'AxisAnnotationPaddingBottom:qd:rc', [1, NaN], 'AxisAnnotationPaddingLeft:qe:rd', [1, NaN], 'AxisAnnotationPaddingRight:qf:re', [1, NaN], 'AxisAnnotationPaddingTop:qg:rf', [1, NaN], 'AxisAnnotationStrokeThickness:qh:rg', [1, NaN], 'AxisAnnotationTextColor:rn:rh', [Brush.$, null], 'Axis:p4:ri', [Axis.$, null], 'IsAxisAnnotationEnabled:p8:rj', [0, false], 'Value:qn:rk', [1, 0]]);
    return ValueOverlay;
})();
/**
 * @hidden
 */
export let ValueOverlayView = /*@__PURE__*/ (() => {
    class ValueOverlayView extends SeriesView {
        constructor(a) {
            super(a);
            this.bz = null;
            this.bz = new Path();
        }
        bb() {
            super.bb();
            this.bz._stroke = this.e.oz;
            this.bz.ac = this.e.fu;
            this.bz.ai = this.e.pc;
            this.bz.ad = this.e.pd;
        }
        bc() {
            super.bc();
            let a = this.bo();
            this.bz._stroke = a;
            this.bz.ac = this.e.fu + 3;
            this.bz._stroke = a;
            this.bz.ac = this.e.fu + 3;
        }
        by(a) {
            this.bz.ak = a;
            this.aq();
        }
        bx() {
            this.bz.ak = null;
            this.aq();
        }
        a6(a, b) {
            super.a6(a, b);
            if (a.d) {
                a.s(this.bz);
            }
        }
        al(a) {
            super.al(a);
            this.e.a8.exportPathData(a, this.bz, "ValueOverlayPath", []);
        }
    }
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
})();
