/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Defaults } from "./Defaults";
import { TranslateTransform } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
var CrosshairLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.xAxisAnnotationFormatLabel = null;
        _this.yAxisAnnotationFormatLabel = null;
        _this.ri = null;
        _this.rh = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.hm / 1000;
        _this.p6 = a;
        _this.p5 = b;
        _this.p7 = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.get_db = function () {
        return true;
    };
    CrosshairLayer.prototype.get_c9 = function () {
        return true;
    };
    CrosshairLayer.prototype.bx = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.ra = a;
    };
    CrosshairLayer.prototype.rc = function () {
        return this.xAxisAnnotationFormatLabel != null;
    };
    CrosshairLayer.prototype.rd = function () {
        return this.yAxisAnnotationFormatLabel != null;
    };
    Object.defineProperty(CrosshairLayer.prototype, "tv", {
        get: function () {
            return new Thickness(1, this.rl, this.rn, this.rm, this.rk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CrosshairLayer.prototype, "tw", {
        get: function () {
            return new Thickness(1, this.rr, this.rt, this.rs, this.rq);
        },
        enumerable: false,
        configurable: true
    });
    CrosshairLayer.prototype.qp = function (a, b) {
        if (this.rb == null || this.rb == a) {
            if (!this.as.c) {
                this.mi(b);
            }
        }
    };
    CrosshairLayer.prototype.qr = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.qr.call(this, a, b);
        var c = a;
        var d = this.rg;
        var e = this.rf;
        c.af.clear();
        c.ag.clear();
        c.ae.clear();
        c.ah.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.qc(this.rb)) {
            this.ss(this.rb, c, d, e);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.cd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (this.qc(f)) {
                        this.ss(f, c, d, e);
                    }
                    if (f.isStacked) {
                        f.la(function (g) {
                            if (_this.qc(g)) {
                                _this.ss(g, c, d, e);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CrosshairLayer.prototype.qc = function (a) {
        if (!_super.prototype.qc.call(this, a)) {
            return false;
        }
        if (this.r1 != null) {
            if (a.du) {
                var b = a.jp();
                if (!Base.equalsStatic(this.r1, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.r1, a.name)) {
                    return false;
                }
            }
        }
        var c = this.qk(a);
        if (!c.c) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.ls = function () {
        _super.prototype.ls.call(this);
        if (!this.as.c && !this.cv()) {
            return;
        }
        if (this.cv()) {
            this.st(this.p7, false);
        }
        else {
            this.st(this.p5, false);
        }
    };
    CrosshairLayer.prototype.ss = function (a, b, c, d) {
        var e = this.qk(a);
        if (!e.c) {
            return;
        }
        var f = e.d;
        f = a.pm(f, c, d);
        var g = this.oz;
        if (g == null) {
            g = this.o3;
        }
        if (g == null) {
            g = a.oz;
            if (g != null) {
                g = this.ra.cb(g);
            }
        }
        var h = g;
        var i = g;
        if (this.tn != null) {
            h = this.tn;
        }
        if (this.to != null) {
            i = this.to;
        }
        b.ae.add(h);
        b.ah.add(i);
        b.af.add(f.y);
        b.ag.add(f.x);
        if (this.re && !isNaN_(f.y)) {
            AxisAnnotationFrameManager.c(b, f, a, this.cd, this.getEffectiveViewport(), g, this.tp, this.rj, this.tr, this.tq, this.tv, this.ro, this.ts, this.rp, this.tu, this.tt, this.tw, this.ru, this.ty == 0, this.tx == 0);
        }
    };
    CrosshairLayer.prototype.st = function (a, b) {
        var c = false;
        if (this.rh == null) {
            c = true;
            this.ri = new List$1(Axis.$, 0);
            this.rh = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.rh, this.ri, b, this.rv, this.rw, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    };
    CrosshairLayer.prototype.sr = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.ah._inner[c];
            f._fill = d.ah._inner[c];
        }
        else {
            f._stroke = d.ae._inner[c];
            f._fill = d.ae._inner[c];
        }
        f.ac = this.fu;
        f.ai = this.pc;
        f.ad = this.pd;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.qu = function (a, b) {
        _super.prototype.qu.call(this, a, b);
        var c = this.ra.b5;
        var d = a;
        var e = d.af.count;
        var f = 0;
        var g = b.bu.left;
        var h = b.bu.right;
        var i = b.bu.top;
        var j = b.bu.bottom;
        var k = this.ty == 0;
        var l = this.tx == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.af._inner[m]);
            var o = Math.floor(d.ag._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.sr(c, f, m, d, true);
                p = q.c;
                f = q.d;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.ak = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.sr(c, f, m, d, false);
                p = u.c;
                f = u.d;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.ak = v;
            }
        }
        c.count = f;
        if (this.cv()) {
            this.st(this.p7, true);
        }
        else {
            this.st(this.p5, false);
        }
    };
    CrosshairLayer.prototype.em = function () {
        return true;
    };
    CrosshairLayer.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (d == null) {
                    if (this.rh != null && this.rh.count > 0) {
                        var e = void 0;
                        if (this.cv()) {
                            e = this.p7;
                        }
                        else {
                            e = this.p5;
                        }
                        AxisAnnotationFrameManager.b(e);
                        AxisAnnotationFrameManager.d(this, e, true, this.rh, this.ri, true, this.rv, this.rw, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
                    }
                }
                break;
            case CrosshairLayer.$$p[1]:
                this.mi(true);
                break;
            case CrosshairLayer.$$p[8]:
                this.mi(true);
                break;
            case CrosshairLayer.$$p[4]:
            case CrosshairLayer.$$p[5]:
                this.mi(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[9]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[18]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[26]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[27]:
            case CrosshairLayer.$$p[28]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[7]:
            case CrosshairLayer.$$p[6]:
                this.mi(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:tn:su', [Brush.$, null], 'HorizontalLineVisibility:tx:sv', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:re:sw', [0, false], 'SkipUnknownValues:rf:sx', [0, true], 'TargetSeriesName:r1:sy', [2, null], 'TargetSeries:rb:sz', [Series.$, null], 'UseInterpolation:rg:s0', [0, true], 'VerticalLineStroke:to:s1', [Brush.$, null], 'VerticalLineVisibility:ty:s2', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackgroundCornerRadius:rj:s3', [1, DeviceUtils.g(3)], 'XAxisAnnotationBackground:tp:s4', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:rv:s5', [1, -1], 'XAxisAnnotationOutline:tq:s6', [Brush.$, null], 'XAxisAnnotationPaddingBottom:rk:s7', [1, NaN], 'XAxisAnnotationPaddingLeft:rl:s8', [1, NaN], 'XAxisAnnotationPaddingRight:rm:s9', [1, NaN], 'XAxisAnnotationPaddingTop:rn:ta', [1, NaN], 'XAxisAnnotationStrokeThickness:ro:tb', [1, NaN], 'XAxisAnnotationTextColor:tr:tc', [Brush.$, null], 'YAxisAnnotationBackgroundCornerRadius:rp:td', [1, DeviceUtils.g(3)], 'YAxisAnnotationBackground:ts:te', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:rw:tf', [1, -1], 'YAxisAnnotationOutline:tt:tg', [Brush.$, null], 'YAxisAnnotationPaddingBottom:rq:th', [1, NaN], 'YAxisAnnotationPaddingLeft:rr:ti', [1, NaN], 'YAxisAnnotationPaddingRight:rs:tj', [1, NaN], 'YAxisAnnotationPaddingTop:rt:tk', [1, NaN], 'YAxisAnnotationStrokeThickness:ru:tl', [1, NaN], 'YAxisAnnotationTextColor:tu:tm', [Brush.$, null]]);
    return CrosshairLayer;
}(AnnotationLayer));
export { CrosshairLayer };
/**
 * @hidden
 */
var CrosshairLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b5 = null;
        _this.b6 = null;
        _this.b4 = a;
        _this.b6 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.as = function () {
        var _this = this;
        _super.prototype.as.call(this);
        this.b5 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.cc);
            $ret.activate = runOn(_this, _this.b7);
            $ret.disactivate = runOn(_this, _this.b9);
            $ret.destroy = runOn(_this, _this.b8);
            return $ret;
        })());
        this.b4.gz = Defaults.j;
    };
    CrosshairLayerView.prototype.cc = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b6.add(a);
        return a;
    };
    CrosshairLayerView.prototype.b7 = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.b9 = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.b8 = function (a) {
        this.b6.remove(a);
    };
    CrosshairLayerView.prototype.ca = function (a, b, c, d) {
        if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.ak = e;
        }
    };
    CrosshairLayerView.prototype.cb = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    CrosshairLayerView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b6.count; c++) {
                var d = this.b6._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        for (var b = 0; b < this.b6.count; b++) {
            this.e.a8.exportPathData(a, this.b6._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));
export { CrosshairLayerView };
