/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { Defaults } from "./Defaults";
import { KDTree2D } from "./KDTree2D";
import { Point_$type, typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, markDep, toNullable } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-angular-core";
import { boxArray$1, arrayShallowClone } from "igniteui-angular-core";
import { dateNow } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { CanvasViewRenderer } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
/**
 * @hidden
 */
var HighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighDensityScatterSeries, _super);
    function HighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.qh = null;
        _this.qj = null;
        _this.rs = 0;
        _this.ql = false;
        _this.q7 = Defaults.aq.o;
        _this.q6 = Defaults.aq.n;
        _this.q5 = Defaults.aq.m;
        _this.q4 = Defaults.aq.l;
        _this.q3 = Defaults.ap.o;
        _this.q2 = Defaults.ap.n;
        _this.q1 = Defaults.ap.m;
        _this.q0 = Defaults.ap.l;
        _this.p9 = null;
        _this.qe = null;
        _this.qf = null;
        _this.qa = null;
        _this.qc = null;
        _this.qn = false;
        _this.rt = 0;
        _this.rv = 0;
        _this.rp = 0;
        _this.ro = 0;
        _this.progressiveLoadStatusChanged = null;
        _this.qs = null;
        _this.qy = 0;
        _this.qx = 0;
        _this.qz = 0;
        _this.re = 0;
        _this.rc = 0;
        _this.rd = 0;
        _this.rf = 0;
        _this.rh = 0;
        _this.rj = 0;
        _this.ri = 0;
        _this.rg = 0;
        _this.qu = 0;
        _this.qv = 0;
        _this.qw = 0;
        _this.qt = 0;
        _this.rr = 0;
        _this.rq = 0;
        _this.p6 = null;
        _this.ru = 0;
        _this.qm = false;
        _this._itemIndexes = null;
        _this.p7 = null;
        _this.p4 = null;
        _this.qg = null;
        _this.ab = HighDensityScatterSeries.$;
        _this.el = false;
        return _this;
    }
    HighDensityScatterSeries.prototype.get_d5 = function () {
        return true;
    };
    HighDensityScatterSeries.prototype.gu = function () {
        if (!isNaN_(this.gt)) {
            return _super.prototype.gu.call(this);
        }
        return Defaults.q;
    };
    HighDensityScatterSeries.prototype.get_ec = function () {
        return true;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "qi", {
        get: function () {
            return this.qh;
        },
        set: function (a) {
            if (this.qh != a) {
                var b = this.qi;
                this.qh = a;
                this.raisePropertyChanged("XColumn", b, this.qi);
            }
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.ht(c);
        var e = d == null ? NaN : this.gb(d, "XMemberPath");
        var f = d == null ? NaN : this.gb(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.l = e;
        g.a = 13;
        g.p = this.se != null ? this.se : "X";
        g.q = this.sa != null ? this.sa : "X:";
        g.r = this.sc != null ? this.sc : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.p = this.sm != null ? this.sm : "Y";
        h.q = this.si != null ? this.si : "Y:";
        g.r = this.sk != null ? this.sk : "";
        var i = new DataLegendSeriesContext();
        i.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.b = this.av();
        return i;
    };
    HighDensityScatterSeries.prototype.hw = function (a, b) {
        var c = this.jq(b);
        if (c == HighDensityScatterSeries.$$p[10]) {
            return this.hx(a, b, this.se);
        }
        if (c == HighDensityScatterSeries.$$p[14]) {
            return this.hx(a, b, this.sm);
        }
        return _super.prototype.hw.call(this, a, b);
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "qk", {
        get: function () {
            return this.qj;
        },
        set: function (a) {
            if (this.qj != a) {
                var b = this.qk;
                this.qj = a;
                this.raisePropertyChanged("YColumn", b, this.qk);
            }
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.s1 = function () {
        if (this.p9 == null) {
            return;
        }
        this.p9.s();
        var a = this.p9;
        a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.so));
        this.p9 = null;
    };
    HighDensityScatterSeries.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (this.cd != null) {
                    var e = this.getEffectiveViewport1(this.b0);
                    this.qm = !e.isEmpty;
                }
                break;
            case "FastItemsSource":
                this.s1();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.qi);
                    c.deregisterColumn(this.qk);
                    this.qi = null;
                    this.qk = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.qi = this.ch(this.se);
                    this.qk = this.ch(this.sm);
                }
                if ((this.qd != null && !this.qd.c0()) || (this.qb != null && !this.qb.c0())) {
                    this.mi(false);
                }
                this.lq();
                break;
            case HighDensityScatterSeries.$$p[7]:
                var f = this.qa;
                this.qa = this.qb;
                this.s1();
                if (f != null) {
                    f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.sr));
                }
                if (this.qa != null) {
                    var g = this.qa;
                    g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.sr));
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                if ((this.qb != null && !this.qb.c0()) || (d == null && c != null)) {
                    this.mi(false);
                }
                break;
            case HighDensityScatterSeries.$$p[11]:
                var h = this.qc;
                this.qc = this.qd;
                this.s1();
                if (h != null) {
                    h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.sr));
                }
                if (this.qc != null) {
                    var i = this.qc;
                    i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.sr));
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                if ((this.qd != null && !this.qd.c0()) || (d == null && c != null)) {
                    this.mi(false);
                }
                break;
            case "MouseOverEnabled":
                this.qn = this.el;
                this.mi(false);
                break;
            case HighDensityScatterSeries.$$p[10]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.qi);
                    this.qi = this.ch(this.se);
                }
                break;
            case "XColumn":
                this.s1();
                if (this.qb != null && !this.qb.c0()) {
                    this.mi(false);
                }
                this.lq();
                break;
            case HighDensityScatterSeries.$$p[14]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.qk);
                    this.qk = this.ch(this.sm);
                }
                break;
            case "YColumn":
                this.s1();
                if (this.qd != null && !this.qd.c0()) {
                    this.mi(false);
                }
                this.lq();
                break;
            case HighDensityScatterSeries.$$p[6]:
                this.s1();
                this.mi(false);
                this.lp();
                break;
            case HighDensityScatterSeries.$$p[3]:
                this.mi(false);
                this.lp();
                break;
            case HighDensityScatterSeries.$$p[1]:
                this.mi(false);
                this.lp();
                break;
            case HighDensityScatterSeries.$$p[0]:
            case HighDensityScatterSeries.$$p[2]:
                if (!this.p8.b1(this.tk, this.tj)) {
                    return;
                }
                this.sv();
                this.mi(false);
                this.lp();
                break;
            case HighDensityScatterSeries.$$p[4]:
                this.rs = Math.max(typeGetValue(d) - 1, 0);
                this.ql = this.rs > 0;
                this.mi(false);
                this.lp();
                break;
            case HighDensityScatterSeries.$$p[5]:
                this.mi(false);
                this.lp();
                break;
        }
    };
    HighDensityScatterSeries.prototype.sv = function () {
        this.q4 = this.tk.l;
        this.q7 = this.tk.o;
        this.q6 = this.tk.n;
        this.q5 = this.tk.m;
        this.q0 = this.tj.l;
        this.q3 = this.tj.o;
        this.q2 = this.tj.n;
        this.q1 = this.tj.m;
        this.o8 = BrushUtil.g(truncate(this.q4), truncate(this.q7), truncate(this.q6), truncate(this.q5));
        this.o3 = BrushUtil.g(truncate(this.q0), truncate(this.q3), truncate(this.q2), truncate(this.q1));
    };
    HighDensityScatterSeries.prototype.qp = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.qo = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.sr = function (a, b) {
        this.s1();
        this.mi(false);
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "rb", {
        get: function () {
            return this.q3 - this.q7;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "ra", {
        get: function () {
            return this.q2 - this.q6;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "q9", {
        get: function () {
            return this.q1 - this.q5;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "q8", {
        get: function () {
            return this.q0 - this.q4;
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.e9 = function (a, b, c) {
        var d = _super.prototype.e9.call(this, a, b, c);
        if (this.qd == null || this.qb == null || this.qb.bh == null || this.qd.bh == null || this.qk == null || this.qi == null || this.qk.count < 1 || this.qi.count < 1 || this.qk.count != this.qi.count || this.qb.lv == this.qb.lu || this.qd.lv == this.qd.lu || this.pz.isEmpty) {
            d = false;
        }
        return d;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "rz", {
        get: function () {
            return this.rt;
        },
        set: function (a) {
            var b = this.rt;
            this.rt = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.rt);
        },
        enumerable: false,
        configurable: true
    });
    HighDensityScatterSeries.prototype.mj = function (a) {
        _super.prototype.mj.call(this, a);
        this.st(a, this.b0);
    };
    HighDensityScatterSeries.prototype.st = function (a, b) {
        if (this.cx(b)) {
            return;
        }
        if (this.p9 == null && !this.qr) {
            var c = new List$1(KDPointData.$, 2, this.qi.count);
            var d = this.qb;
            var e = this.qd;
            var f = new Rect(0, 0, 0, 1, 1);
            var g = new Rect(0, 0, 0, 1, 1);
            var h = new ScalerParams(1, f, g, d.cg);
            var i = new ScalerParams(1, f, g, e.cg);
            var j_1;
            var k_1;
            var _loop_1 = function (l) {
                j_1 = d.ei(this_1.qi.item(l), h);
                k_1 = e.ei(this_1.qk.item(l), i);
                if (!isNaN_(j_1) && !isNaN_(k_1) && !isInfinity(j_1) && !isInfinity(k_1)) {
                    c.add(((function () {
                        var $ret = new KDPointData();
                        $ret.a = j_1;
                        $ret.b = k_1;
                        $ret.c = l;
                        return $ret;
                    })()));
                }
            };
            var this_1 = this;
            for (var l = 0; l < this.qi.count; l++) {
                _loop_1(l);
            }
            if (this.qq) {
                this.ro = 1;
                this.rp = truncate(logBase(c.count, 2)) + 3;
                this.rz = truncate(((this.ro / this.rp) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.rz));
                }
                this.p9 = KDTree2D.b(c.toArray(), 1);
                var m = this.p9;
                m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.so));
                if (!this.p9.f(this.g9)) {
                    var n = this.p9;
                    n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.so));
                }
                this.lp();
            }
            else {
                var o = dateNow();
                this.p9 = new KDTree2D(0, c.toArray(), 1);
                var p = dateNow();
            }
        }
        if (this.qq && !this.qr) {
            this.su(b);
        }
        else {
            this.sw(b);
        }
    };
    HighDensityScatterSeries.prototype.k0 = function (a, b, c, d) {
        _super.prototype.k0.call(this, a, b, c, d);
        this.s1();
        var e = false;
        if (this.qb != null && !this.qb.c0()) {
            e = true;
        }
        if (this.qd != null && !this.qd.c0()) {
            e = true;
        }
        if (e) {
            this.mi(false);
        }
        this.lq();
    };
    HighDensityScatterSeries.prototype.sq = function (a) {
        var b = a;
        var c = this.rr * this.rq;
        if (this.qn) {
            if (this._itemIndexes == null || this._itemIndexes.length != c) {
                this._itemIndexes = new Array(c);
                for (var d = 0; d < c; d++) {
                    this._itemIndexes[d] = 0;
                }
            }
            else {
                for (var e = 0; e < c; e++) {
                    this._itemIndexes[e] = 0;
                }
            }
        }
    };
    HighDensityScatterSeries.prototype.sw = function (a) {
        var b;
        var c;
        var d = null;
        if (a.q) {
            d = this._itemIndexes;
        }
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        var f = a;
        var g = this.getEffectiveViewport1(a);
        this.qe = new ScalerParams(0, b, c, this.qa.cg, g);
        this.qf = new ScalerParams(0, b, c, this.qc.cg, g);
        this.sp(a);
        this.sq(a);
        var h = this.rr * this.rq;
        if (this.p7 == null || this.p7.length != h) {
            this.p7 = new Array(h);
            this.p4 = new Array(h);
        }
        var i = this.p7.length;
        var j = this.p7;
        var k = this.p4;
        for (var l = 0; l < i; l++) {
            j[l] = 0;
            k[l] = 0;
        }
        this.rv = truncate(Math.round(this.ft));
        this.p6 = f.by();
        var m = this.p6.length;
        var n = this.p6;
        for (var o = 0; o < m; o++) {
            n[o] = 0;
        }
        var p = this.rm;
        var q = this.rl;
        if (isNaN_(p) || isInfinity(p)) {
            p = 0;
        }
        if (isNaN_(q) || isInfinity(q)) {
            q = 50;
        }
        this.qy = Math.min(p, q);
        this.qx = Math.max(p, q);
        if (this.qy < 0) {
            this.qy = 0;
        }
        if (this.qx < 0) {
            this.qx = 0;
        }
        this.qz = this.qx - this.qy;
        if (this.qr) {
            this.ss(a);
        }
        else {
            this.s3(a);
        }
        f.b9();
        if (a.q) {
            this._itemIndexes = d;
            this.p8.ca();
        }
    };
    HighDensityScatterSeries.prototype.su = function (a) {
        if (this.p9 == null) {
            return;
        }
        this.sw(a);
    };
    HighDensityScatterSeries.prototype.so = function (a, b) {
        var _this = this;
        this.p8.b8(function () {
            if (_this.ro < _this.rp - 1) {
                _this.ro++;
            }
            _this.rz = truncate(((_this.ro / _this.rp) * 100));
            if (_this.progressiveLoadStatusChanged != null) {
                _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.rz));
            }
            _this.su(_this.b0);
            _this.lp();
            if (_this.p9 != null) {
                if (!_this.p9.f(_this.g9)) {
                    var c = _this.p9;
                    c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(_this, _this.so));
                    _this.rz = 100;
                    if (_this.progressiveLoadStatusChanged != null) {
                        _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.rz));
                    }
                }
            }
        });
    };
    HighDensityScatterSeries.prototype.ss = function (a) {
        var b = arrayShallowClone(this.qi.asArray());
        this.qb.hm(boxArray$1(b), 0, b.length, this.qe);
        var c = arrayShallowClone(this.qk.asArray());
        this.ru = 0;
        var d = this.rs;
        var e = this.ql;
        var f = this.p7.length;
        this.qd.hm(boxArray$1(c), 0, c.length, this.qf);
        var g = 255 << 24 | truncate(this.q7) << 16 | truncate(this.q6) << 8 | truncate(this.q5);
        for (var h = 0; h < b.length; h++) {
            var i = truncate(b[h]);
            var j = truncate(c[h]);
            i = truncate(Math.floor(i));
            j = truncate(Math.floor(j));
            if (i < 0 || i >= this.rr || j < 0 || j >= this.rq) {
                continue;
            }
            if (e) {
                var k = i - d;
                var l = i + d;
                l = l > (this.rr - 1) ? (this.rr - 1) : l;
                k = k < 0 ? 0 : k;
                var m = j + d;
                var n = j - d;
                for (var o = k; o <= l; o++) {
                    for (var p = n; p <= m; p++) {
                        var q = (p * this.rr) + o;
                        if (q < 0 || q > f - 1) {
                            continue;
                        }
                        this.p7[q] = this.p7[q] + 1;
                        this.p4[q] = 1;
                        this.ru++;
                        if (this.qn) {
                            this._itemIndexes[q] = h + 1;
                        }
                    }
                }
            }
            else {
                var r = (j * this.rr) + i;
                this.p7[r] = this.p7[r] + 1;
                this.p4[r] = 1;
                this.ru++;
                if (this.qn) {
                    this._itemIndexes[r] = h + 1;
                }
            }
        }
        this.sx();
    };
    HighDensityScatterSeries.prototype.s3 = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.p9 == null) {
            return;
        }
        if (this.qs == null) {
            this.qs = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
        }
        else {
            this.qs.clear();
        }
        var e = c.left;
        var f = c.right;
        var g = c.top;
        var h = c.bottom;
        this.ri = c.top;
        this.rg = c.height;
        this.rh = c.left;
        this.rj = c.width;
        this.re = b.top;
        this.rc = b.height;
        this.rd = b.left;
        this.rf = b.width;
        var i = this.getEffectiveViewport1(a);
        this.qu = (i.left - this.rd) / this.rf;
        this.qv = (i.top - this.re) / this.rc;
        var j = (i.right - this.rd) / this.rf;
        this.qw = j - this.qu;
        var k = (i.bottom - this.re) / this.rc;
        this.qt = k - this.qv;
        if (this.qm) {
            e = (e - this.qu) / this.qw;
            f = (f - this.qu) / this.qw;
            g = (g - this.qv) / this.qt;
            h = (h - this.qv) / this.qt;
        }
        var l = this.ft / b.width * c.width;
        var m = this.ft / b.height * c.height;
        var n = Math.min(l, m);
        var o = ((function () {
            var $ret = new SearchArgs();
            $ret.c = e;
            $ret.a = f;
            $ret.d = g;
            $ret.b = h;
            $ret.e = l;
            $ret.f = m;
            $ret.g = 0x7FFFFFFF;
            return $ret;
        })());
        this.p9.t(this.qs, o, 0, 1, 0, 1);
        var p;
        this.ru = 0;
        for (var q = 0; q < this.qs.count; q++) {
            p = this.qs._inner[q];
            this.sy(p);
        }
        this.sx();
    };
    HighDensityScatterSeries.prototype.sy = function (a) {
        if (a.g) {
            return;
        }
        var b = a.e != null && a.e.a;
        var c = a.a == null ? 0 : a.a.length;
        var d = (a.h - c) + 1;
        if (b && d > 0) {
        }
        else {
            d = 1;
        }
        this.s0(a.b, d, b, a.e);
        if (c > 0 && !b) {
            var e = void 0;
            for (var f = 0; f < c; f++) {
                e = a.a[f];
                this.s0(e, d, false, a.e);
            }
        }
        if (a.e != null) {
            a.e.a = false;
        }
    };
    HighDensityScatterSeries.prototype.en = function (a) {
        var b = this.cd != null ? this.cd.sf : Rect.empty;
        var c = this.cd != null ? this.cd.su : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.pt(this.b0);
        var f = new ScalerParams(0, d, d, this.qb.cg, e);
        var g = new ScalerParams(0, d, d, this.qd.cg, e);
        var h = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
        var i = this.qb != null && this.qi != null && h < this.qi.count ? this.qb.ei(this.qi.item(h), f) : NaN;
        var j = this.qd != null && this.qk != null && h < this.qk.count ? this.qd.ei(this.qk.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.b8 != null) {
            this.b8.au(this.cd, b, true);
        }
        return h >= 0;
    };
    HighDensityScatterSeries.prototype.s0 = function (a, b, c, d) {
        var e = this.rx(b);
        var f = a.c;
        var g = this.rs;
        if (c) {
            var h = d.d;
            var i = d.b;
            var j = d.e;
            var k = d.c;
            if (this.qm) {
                h = this.qu + this.qw * h;
                i = this.qu + this.qw * i;
                j = this.qv + this.qt * j;
                k = this.qv + this.qt * k;
            }
            var l = truncate((this.rd + this.rf * (h - this.rh) / this.rj));
            var m = truncate((this.rd + this.rf * (i - this.rh) / this.rj));
            var n = truncate((this.re + this.rc * (j - this.ri) / this.rg));
            var o = truncate((this.re + this.rc * (k - this.ri) / this.rg));
            l = truncate(Math.floor(l));
            m = truncate(Math.floor(m));
            n = truncate(Math.floor(n));
            o = truncate(Math.floor(o));
            if (this.ql) {
                l -= g;
                m += g;
                n -= g;
                o += g;
            }
            var p = ((m - l) + 1) * ((o - n) + 1);
            var q = b / p;
            var r = q;
            for (var s = l; s <= m; s++) {
                for (var t = n; t <= o; t++) {
                    this.sz(f, s, t, q, r);
                }
            }
        }
        else {
            var u = a.a;
            var v = a.b;
            if (this.qm) {
                u = this.qu + this.qw * u;
                v = this.qv + this.qt * v;
            }
            var w = truncate((this.rd + this.rf * (u - this.rh) / this.rj));
            var x = truncate((this.re + this.rc * (v - this.ri) / this.rg));
            w = truncate(Math.floor(w));
            x = truncate(Math.floor(x));
            if (this.ql) {
                var y = w - g;
                var z = w + g;
                var aa = x + g;
                var ab = x - g;
                var ac = ((z - y) + 1) * ((aa - ab) + 1);
                var ad = b / ac;
                var ae = ad;
                for (var af = y; af <= z; af++) {
                    for (var ag = ab; ag <= aa; ag++) {
                        this.sz(f, af, ag, ad, ae);
                    }
                }
            }
            else {
                this.sz(f, w, x, b, 1);
            }
        }
    };
    HighDensityScatterSeries.prototype.rw = function (a, b) {
        return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.q7 + a * this.rb))) << 16 | truncate(Math.floor(b * (this.q6 + a * this.ra))) << 8 | truncate(Math.floor(b * (this.q5 + a * this.q9)));
    };
    HighDensityScatterSeries.prototype.rx = function (a) {
        return 255 << 24 | truncate(Math.floor((this.q7 + a * this.rb))) << 16 | truncate(Math.floor((this.q6 + a * this.ra))) << 8 | truncate(Math.floor((this.q5 + a * this.q9)));
    };
    HighDensityScatterSeries.prototype.rk = function (a) {
        return (a >> 24 & 255) / 255;
    };
    HighDensityScatterSeries.prototype.sz = function (a, b, c, d, e) {
        if (b < 0 || b >= this.rr || c < 0 || c >= this.rq) {
            return;
        }
        var f = (c * this.rr) + b;
        this.p7[f] = this.p7[f] + d;
        this.p4[f] = this.p4[f] + e;
        if (this.qn) {
            this._itemIndexes[f] = a + 1;
        }
        this.ru += truncate(d);
    };
    HighDensityScatterSeries.prototype.sx = function () {
        var a = 0;
        var b = 0;
        var c = this.qz;
        var d = this.qy;
        var e = this.qx;
        var f = this.p7.length;
        var g = this.p7;
        var h = this.p4;
        var i = this.p6;
        var j = NaN;
        var k = NaN;
        var l = 0;
        var m = 0;
        for (var n = 0; n < f; n++) {
            a = g[n];
            if (a != 0) {
                b = h[n];
                if (a >= e) {
                    a = 1;
                }
                else if (a <= d) {
                    a = 0;
                }
                else {
                    a = (a - d) / (c);
                }
                if (b > 1) {
                    b = 1;
                }
                if (b < 0.2) {
                    b = 0.2;
                }
                if (j != a || k != b) {
                    l = this.rw(a, b);
                    j = a;
                    k = b;
                }
                i[m] = l >> 16 & 255;
                i[m + 1] = l >> 8 & 255;
                i[m + 2] = l & 255;
                i[m + 3] = l >> 24 & 255;
            }
            m += 4;
        }
    };
    HighDensityScatterSeries.prototype.sp = function (a) {
        var b = a;
        b.b6();
    };
    HighDensityScatterSeries.prototype.bx = function () {
        return new HighDensityScatterSeriesView(this);
    };
    HighDensityScatterSeries.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.p8 = a;
    };
    HighDensityScatterSeries.prototype.ap = function (a) {
        if (a != null && a == this.qb && this.qi != null) {
            return new AxisRange(this.qi.minimum, this.qi.maximum);
        }
        if (a != null && a == this.qd && this.qk != null) {
            return new AxisRange(this.qk.minimum, this.qk.maximum);
        }
        return null;
    };
    HighDensityScatterSeries.prototype.m5 = function (a, b) {
        if (this.cd != null) {
            var c = this.getEffectiveViewport1(this.b0);
            this.qm = !c.isEmpty;
        }
        this.mi(false);
    };
    HighDensityScatterSeries.prototype.m6 = function (a, b) {
        this.mi(false);
    };
    HighDensityScatterSeries.prototype.ht = function (a) {
        if (!this.qn || this._itemIndexes == null || this.cd == null || this.ck == null || this._itemIndexes.length != (this.rr * this.rq)) {
            return null;
        }
        var b = this.cd.sf;
        var c = (a.x - b.left) / b.width;
        var d = (a.y - b.top) / b.height;
        var e = truncate(Math.round(this.pz.left + (this.pz.width * c)));
        var f = truncate(Math.round(this.pz.top + (this.pz.height * d)));
        var g = this.r0(e, f);
        if (g < 0 || g > this._itemIndexes.length - 1) {
            return null;
        }
        var h = this._itemIndexes[g] - 1;
        if (h < 0 || h > this.ck.count) {
            return null;
        }
        return this.ck.item(h);
    };
    HighDensityScatterSeries.prototype.r0 = function (a, b) {
        var c = (this.rr * b) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        var d = 1;
        c = (this.rr * (b - d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b + d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b - d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b + d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b - d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.rr * (b + d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        return 0;
    };
    HighDensityScatterSeries.prototype.s2 = function (a, b, c) {
        this.p6 = a;
        this.rr = b;
        this.rq = c;
    };
    HighDensityScatterSeries.prototype.get_e3 = function () {
        return true;
    };
    HighDensityScatterSeries.prototype.set_e3 = function (a) {
        _super.prototype.set_e3.call(this, a);
    };
    HighDensityScatterSeries.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        this.p8.b7();
        if (this.bz != null) {
            this.bz.b7();
        }
        this.lp();
    };
    HighDensityScatterSeries.prototype.mk = function (a, b) {
        _super.prototype.mk.call(this, a, b);
        if (!this.ez) {
            this.b0.a2(b);
            return;
        }
        this.b0.a2(b);
        if (this.cx(this.bz)) {
            return;
        }
        var c = typeCast(HighDensityScatterSeriesView.$, this.bz);
        var d = new ScatterFrame();
        this.st(false, c);
        this.ez = false;
    };
    HighDensityScatterSeries.prototype.mh = function (a, b, c, d, e) {
        _super.prototype.mh.call(this, a, b, c, d, e);
        var f = this.a6.a$h.item(d);
        var g = f;
        f.a1(c);
        if (this.cx(g)) {
            return;
        }
        if (this.qg == null) {
            this.qg = new ScatterFrame();
        }
        this.st(false, f);
    };
    HighDensityScatterSeries.prototype.ku = function () {
        _super.prototype.ku.call(this);
        this.qb = null;
        this.qd = null;
    };
    HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    HighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:tj:s4', [Color.$, Defaults.ap], 'HeatMaximum:rl:s5', [1, 50], 'HeatMinimumColor:tk:s6', [Color.$, Defaults.aq], 'HeatMinimum:rm:s7', [1, 0], 'PointExtent:ry:s8', [1, 1], 'ProgressiveLoad:qq:s9', [0, true], 'UseBruteForce:qr:ta', [0, false], 'XAxis:qb:tb', [NumericXAxis.$, null], 'XMemberAsLegendLabel:sa:tc', [2, null], 'XMemberAsLegendUnit:sc:td', [2, null], 'XMemberPath:se:te', [2, null], 'YAxis:qd:tf', [NumericYAxis.$, null], 'YMemberAsLegendLabel:si:tg', [2, null], 'YMemberAsLegendUnit:sk:th', [2, null], 'YMemberPath:sm:ti', [2, null]]);
    return HighDensityScatterSeries;
}(Series));
export { HighDensityScatterSeries };
/**
 * @hidden
 */
var HighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighDensityScatterSeriesView, _super);
    function HighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bz = null;
        _this.bx = null;
        _this.b5 = 0;
        _this.b4 = 0;
        _this.b2 = null;
        _this.b3 = null;
        _this.b0 = null;
        _this.bz = a;
        return _this;
    }
    HighDensityScatterSeriesView.prototype.as = function () {
        _super.prototype.as.call(this);
        if (!this.q) {
            this.bz.tk = Defaults.aq;
            this.bz.tj = Defaults.ap;
            this.bz.o3 = Defaults.al;
            this.bz.o8 = Defaults.ak;
        }
    };
    HighDensityScatterSeriesView.prototype.ca = function () {
        this.bz.s2(this.bx, this.b5, this.b4);
    };
    HighDensityScatterSeriesView.prototype.b6 = function () {
        if (this.b2 == null) {
            this.b2 = this.e.g9.createElement("canvas");
            var a = this.e.g9.get2DCanvasContext(this.b2);
            this.b0 = new RenderingContext(new CanvasViewRenderer(), a);
        }
        var b;
        if (this.p) {
            b = this.bu;
        }
        else {
            b = this.e.cd.sk();
        }
        var c = truncate(Math.round(b.left));
        var d = truncate(Math.round(b.top));
        var e = truncate(Math.round(b.width));
        var f = truncate(Math.round(b.height));
        var g = this.b5;
        var h = this.b4;
        this.b5 = e;
        this.b4 = f;
        if (g != this.b5 || h != this.b4 || this.bx == null) {
            this.b2.setAttribute("width", e.toString());
            this.b2.setAttribute("height", f.toString());
            this.b3 = this.b0.g().getImageData(0, 0, e, f);
            var imageDataArray_ = this.b3.data;
            this.bx = imageDataArray_;
        }
        this.bz.s2(this.bx, this.b5, this.b4);
    };
    HighDensityScatterSeriesView.prototype.by = function () {
        return this.bx;
    };
    HighDensityScatterSeriesView.prototype.b9 = function () {
        var a = truncate(Math.round(this.bu.left));
        var b = truncate(Math.round(this.bu.left));
        var c = truncate(Math.round(this.bu.width));
        var d = truncate(Math.round(this.bu.height));
        this.b0.g().putImageData(this.b3, 0, 0);
        this.aq();
    };
    HighDensityScatterSeriesView.prototype.b8 = function (a) {
        if (this.e.g9 != null) {
            this.e.g9.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    HighDensityScatterSeriesView.prototype.a6 = function (a, b) {
        _super.prototype.a6.call(this, a, b);
        if (b) {
            if (!this.bz.el) {
                return;
            }
            var c = new Rectangle();
            c.n = this.bu.left;
            c.o = this.bu.top;
            c.width = this.bu.width;
            c.height = this.bu.height;
            c._fill = this.bo();
            a.v(c);
            return;
        }
        if (this.b2 == null) {
            return;
        }
        var d = truncate(Math.round(this.bu.left));
        var e = truncate(Math.round(this.bu.top));
        var f = truncate(Math.round(this.bu.width));
        var g = truncate(Math.round(this.bu.height));
        this.k.n(this.b2.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
    };
    HighDensityScatterSeriesView.prototype.b1 = function (a, b) {
        return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
    };
    HighDensityScatterSeriesView.prototype.b7 = function () {
        if (this.bx != null) {
            for (var a = 0; a < this.bx.length; a++) {
                this.bx[a] = 0;
            }
            this.b9();
        }
    };
    HighDensityScatterSeriesView.prototype.al = function (a) {
        _super.prototype.al.call(this, a);
        if (this.bx == null) {
            this.e.a8.exportSeriesPixelsData(a, null, this.b5, this.b4);
            return;
        }
        var b = new Array(intDivide(this.bx.length, 4));
        var c;
        for (var d = 0; d < intDivide(this.bx.length, 4); d++) {
            c = d * 4;
            b[d] = this.bx[c + 3] << 24 | this.bx[c] << 16 | this.bx[c + 1] << 8 | this.bx[c + 2];
        }
        this.e.a8.exportSeriesPixelsData(a, b, this.b5, this.b4);
    };
    HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
}(SeriesView));
export { HighDensityScatterSeriesView };
