/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, runOn, EnumUtil, typeCast, fromEnum, markDep } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate, intDivide, isNaN_ } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-angular-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { PropertyMetadata } from "igniteui-angular-core";
import { round10N } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cr.ft;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bv;
        var c = this.a.bu;
        var d = this.a.cr.rl;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cr.ck == null || this.a.cr.ck.count == 0) {
            this.b = 0;
            return;
        }
        var e = Math.floor(d.mw(c, b));
        var f = Math.ceil(d.mv(c, b));
        if (d.cg) {
            f = Math.ceil(d.mw(c, b));
            e = Math.floor(d.mv(c, b));
        }
        if (f < e) {
            f = d.le + f;
        }
        var g = this.a.cr.rs;
        var h = g != null ? g.nm : 0.75;
        var i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        var j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.rz = null;
        _this.r0 = null;
        _this.r2 = false;
        _this.r1 = false;
        _this.rq = null;
        _this.rr = null;
        _this.assigningRadialStyle = null;
        _this.assigningRadialMarkerStyle = null;
        _this.rx = new RadialFrame(3);
        _this.ry = new RadialFrame(3);
        _this.rv = new RadialFrame(3);
        _this.rt = null;
        _this.rz = new RadialSeriesRenderManager();
        _this.r0 = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(_this, _this.sn), runOn(_this, _this.sq), runOn(_this, _this.cv), runOn(_this, _this.mr), runOn(_this, _this.sm), function (a) { return _this.ru.cs.e(_this.ft); });
        return _this;
    }
    RadialBase.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.ru = a;
    };
    RadialBase.prototype.sm = function () {
        if (this.ce.g) {
            this.ce.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.rl;
        },
        enumerable: false,
        configurable: true
    });
    RadialBase.prototype.ar = function () {
        return this.rl;
    };
    RadialBase.prototype.ri = function (a, b) {
        return null;
    };
    RadialBase.prototype.c1 = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.rl;
        var f = new ScalerParams(1, this.cd.sf, this.pz, e.cg);
        f.c = this.getEffectiveViewport1(this.b0);
        var g = this.rs;
        var h = new ScalerParams(1, this.cd.sf, this.pz, g.cg);
        h.c = this.getEffectiveViewport1(this.b0);
        a.clear();
        this.qc.cf(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.pz.left || k > _this.pz.right || l < _this.pz.top || l > _this.pz.bottom) {
                    return;
                }
                var m = void 0;
                var n = void 0;
                var o = _this.rt.g(k, l, _this.b0.bv, _this.b0.bu, m, n);
                m = o.p4;
                n = o.p5;
                j.b = m;
                j.c = n;
                if (b) {
                    if (c) {
                        j.d = _this.sh(j.c, d);
                    }
                    else {
                        var p = _this.go(i);
                        if (!isNaN_(p)) {
                            j.d = _this.sh(p, d);
                        }
                        else {
                            j.d = _this.sh(j.c, d);
                        }
                    }
                }
                else {
                    j.d = e.gc(i.ak);
                }
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    RadialBase.prototype.sh = function (a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    };
    RadialBase.prototype.get_ea = function () {
        return true;
    };
    RadialBase.prototype.get_dx = function () {
        return true;
    };
    RadialBase.prototype.rn = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ck.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    RadialBase.prototype.ro = function (a, b, c) {
        var d = this.ru.cs.c;
        var e = this.ru.cs.d;
        var f = this.ru.cs.b;
        var g = this.rw();
        var h = this.ck.count;
        var i = this.rl;
        var j = -1;
        var k = -1;
        var l = this.hd(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.h == j && c.g == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.b = this;
        m.h = j;
        m.g = k;
        return m;
    };
    RadialBase.prototype.rp = function (a, b, c) {
        var d = this.ru.cs.c;
        var e = this.ru.cs.d;
        var f = this.ru.cs.b;
        var g = this.rw();
        var h = this.ck.count;
        var i = this.rl;
        var j = -1;
        var k = -1;
        var l = this.hd(b);
        j = truncate(Math.floor((intDivide(l, f)))) * f;
        k = j + (f - 1);
        if (c != null && c.h == j && c.g == k) {
            return c;
        }
        var m = new HighlightingInfo();
        m.e = true;
        m.b = this;
        m.h = j;
        m.g = k;
        return m;
    };
    RadialBase.prototype.aw = function (a, b, c) {
        if (this.c2 && this.ef(this.bk) && !c) {
            var d = this.ro(a, b, this.rq);
            this.rq = d;
            return d;
        }
        else {
            var e = this.rn(a, b, this.rq);
            this.rq = e;
            return e;
        }
    };
    RadialBase.prototype.ax = function (a, b, c) {
        if (this.ef(this.bk) && !c) {
            var d = this.rp(a, b, this.rr);
            this.rr = d;
            return d;
        }
        else {
            var e = this.rn(a, b, this.rr);
            e.e = true;
            this.rr = e;
            return e;
        }
    };
    RadialBase.prototype.sb = function () {
        return (this.assigningRadialStyle != null && this.r2) || (this.bk != 1);
    };
    RadialBase.prototype.sa = function () {
        return (this.assigningRadialMarkerStyle != null && this.r1) || (this.bk != 1);
    };
    RadialBase.prototype.sp = function (a) {
        if (this.assigningRadialStyle != null && this.r2) {
            this.assigningRadialStyle(this, a);
        }
    };
    RadialBase.prototype.so = function (a) {
        if (this.assigningRadialMarkerStyle != null && this.r1) {
            this.assigningRadialMarkerStyle(this, a);
        }
    };
    RadialBase.prototype.sd = function (a) {
        return a.cs.b;
    };
    RadialBase.prototype.se = function (a) {
        return a.cs.c;
    };
    RadialBase.prototype.ag = function () {
        return [this.rl, this.rs];
    };
    RadialBase.prototype.m6 = function (a, b) {
        this.ru.cs.e(this.ft);
        this.mi(false);
    };
    RadialBase.prototype.m5 = function (a, b) {
        this.ru.cs.e(this.ft);
        this.mi(false);
    };
    RadialBase.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.rl != null) {
                        this.rl.bz(this);
                    }
                    if (this.rs != null) {
                        this.rs.bz(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.rl != null) {
                        this.rl.cs(this);
                    }
                    if (this.rs != null) {
                        this.rs.cs(this);
                    }
                }
                this.ru.cs.e(this.ft);
                this.mi(false);
                break;
            case RadialBase.$$p[0]:
                if (this.rl != null && this.rs != null) {
                    this.rt = new RadialAxes(this.rs, this.rl);
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                this.ru.cs.e(this.ft);
                this.mi(false);
                break;
            case RadialBase.$$p[4]:
                if (this.rl != null && this.rs != null) {
                    this.rt = new RadialAxes(this.rs, this.rl);
                }
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                this.ru.cs.e(this.ft);
                if (this.rs == null || !this.rs.c0()) {
                    this.mi(false);
                }
                break;
            case "SyncLink":
                if (this.b8 != null && this.cd != null) {
                    this.ru.cs.e(this.ft);
                    this.mi(false);
                }
                break;
            case "TransitionProgress":
                this.ry.c(this.g0, this.rx, this.rv);
                if (this.cx(this.b0)) {
                    return;
                }
                if (this.g0 == 1) {
                    this.sq(this.rv, this.ru);
                }
                else {
                    this.sq(this.ry, this.ru);
                }
                if (this.cd != null) {
                    this.cd.nn(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.mi(false);
                this.lp();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.ru.cs.e(this.ft);
                }
                break;
            case RadialBase.$$p[3]:
                this.r2 = this.r9();
                this.mi(false);
                break;
            case RadialBase.$$p[2]:
                this.r1 = this.r8();
                this.mi(false);
                break;
        }
    };
    RadialBase.prototype.r9 = function () {
        return this.r7;
    };
    RadialBase.prototype.r8 = function () {
        return this.r6;
    };
    RadialBase.prototype.r4 = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.r3 = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.ht = function (a) {
        var b = this.hd(a);
        return b >= 0 && this.ck != null && b < this.ck.count ? this.ck.item(b) : null;
    };
    RadialBase.prototype.sc = function (a) {
        var b = this.b0.bv;
        var c = this.b0.bu;
        if (this.rl != null && !b.isEmpty && !c.isEmpty && this.rt != null) {
            var d = this.rt.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    };
    RadialBase.prototype.f5 = function (a) {
        var b = this.b0.bv;
        var c = this.b0.bu;
        var d = -1;
        if (this.rl != null && !b.isEmpty && !c.isEmpty && this.rt != null) {
            var e = this.rt.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            var f = this.rl.getUnscaledAngle(e);
            if (this.rl.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    };
    RadialBase.prototype.hd = function (a) {
        var b = truncate(Math.round(this.f5(a)));
        if (this.ck != null && b == this.ck.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.en = function (a) {
        return false;
    };
    RadialBase.prototype.rw = function () {
        var a = this.rv;
        if (this.cv()) {
            if (this.ce.g) {
                this.ce.t();
            }
            a = this.ry;
        }
        return a;
    };
    RadialBase.prototype.lf = function () {
        _super.prototype.lf.call(this);
        if (this.rl != null) {
            this.rl.h7(false);
        }
        if (this.rs != null) {
            this.rs.h7(false);
        }
    };
    RadialBase.prototype.e9 = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.e9.call(this, a, b, c) || !c.o() || b.isEmpty || a.isEmpty || this.rl == null || this.rl.itemsSource == null || this.rs == null || this.rt == null || this.ck == null || this.rl.bh == null || this.rs.bh == null || this.rs.lv == this.rs.lu) {
            e.cs.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.mj = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.e9(c, b, this.b0)) {
            this.kx(true, this.b0);
            return;
        }
        var e = new SeriesRenderingArguments(this, c, b, a, this.es);
        var f = this.r0.g(e, this.rx, this.rv, this.ry, this.ru);
        this.rx = f.p1;
        this.rv = f.p2;
        this.ry = f.p3;
    };
    RadialBase.prototype.sf = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.cd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(RadialBase.$, b);
                if (c != null && c.rl == this.rl && c.preferredCategoryMode(c.rl) == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:rl:sr', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:r5:ss', [0, false], 'IsCustomRadialMarkerStyleAllowed:r6:st', [0, false], 'IsCustomRadialStyleAllowed:r7:su', [0, false], 'ValueAxis:rs:sv', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.cr = null;
        _this.ct = null;
        _this.cu = 0;
        _this.cv = null;
        _this.cr = a;
        _this.ct = new Pool$1(Marker.$);
        _this.ci(_this.ct);
        return _this;
    }
    RadialBaseView.prototype.cf = function (a) {
        this.ct.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
