/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { Base, enumGetBox, Number_$type, typeCast, fromEnum, Point_$type, runOn, markType, markDep, PointUtil } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { GeometryUtil } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { PathGeometry } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { boxArray$1, arrayShallowClone } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var ScatterBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterBase, _super);
    function ScatterBase() {
        var _this = _super.call(this) || this;
        _this.rx = null;
        _this.sb = null;
        _this.sc = null;
        _this.u0 = null;
        _this.u1 = null;
        _this.r6 = 1;
        _this.ri = null;
        _this.rj = null;
        _this.r3 = null;
        _this.r5 = null;
        _this.r1 = null;
        _this.sg = false;
        _this.sf = false;
        _this.rt = null;
        _this.ru = null;
        _this.assigningScatterStyle = null;
        _this.assigningScatterMarkerStyle = null;
        _this.sa = null;
        _this.r4 = null;
        _this.r0 = null;
        _this.r7 = _this.r8();
        _this.sa = new ScatterSeriesRenderManager();
        _this.r4 = new ScatterFrame();
        _this.u1 = Rect.empty;
        _this.u0 = Rect.empty;
        return _this;
    }
    ScatterBase.prototype.bx = function () {
        return new ScatterBaseView(this);
    };
    ScatterBase.prototype.ku = function () {
        _super.prototype.ku.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    ScatterBase.prototype.lz = function (a) {
        _super.prototype.lz.call(this, a);
        this.ry = a;
    };
    ScatterBase.prototype.get_ec = function () {
        return true;
    };
    ScatterBase.prototype.ag = function () {
        return [this.xAxis, this.yAxis];
    };
    ScatterBase.prototype.hw = function (a, b) {
        var c = this.jq(b);
        if (c == ScatterBase.$$p[10]) {
            return this.hx(a, b, this.te);
        }
        if (c == ScatterBase.$$p[14]) {
            return this.hx(a, b, this.tm);
        }
        return null;
    };
    ScatterBase.prototype.c1 = function (a, b, c, d) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var e = this.xAxis;
        var f = new ScalerParams(1, this.cd.sf, this.pz, e.cg);
        f.c = this.getEffectiveViewport1(this.b0);
        var g = this.yAxis;
        var h = new ScalerParams(1, this.cd.sf, this.pz, g.cg);
        h.c = this.getEffectiveViewport1(this.b0);
        a.clear();
        this.qc.cf(function (i) {
            if (i._visibility == 0) {
                var j = new SeriesPointOfInterest();
                var k = i.n;
                var l = i.o;
                if (k < _this.pz.left || k > _this.pz.right || l < _this.pz.top || l > _this.pz.bottom) {
                    return;
                }
                j.b = e.el(k, f);
                j.c = g.el(l, h);
                j.a = i.content;
                a.add(j);
            }
        });
        return true;
    };
    ScatterBase.prototype.bp = function () {
        if (this.bq == 0) {
            if (this.sy <= 2000) {
                return 1;
            }
            else {
                return _super.prototype.bp.call(this);
            }
        }
        else {
            return _super.prototype.bp.call(this);
        }
    };
    ScatterBase.prototype.px = function (a) {
        if (!this.hasMarkers || !this.qf()) {
            return Rect.empty;
        }
        var b = this.qc.by(this.ph(a));
        if (b != null) {
            return this.qc.cp(b);
        }
        return Rect.empty;
    };
    ScatterBase.prototype.ev = function (a, b) {
        if (this.qg(a, b)) {
            return true;
        }
        return false;
    };
    Object.defineProperty(ScatterBase.prototype, "sd", {
        get: function () {
            return this.sb;
        },
        set: function (a) {
            if (this.sb != a) {
                var b = this.sd;
                this.sb = a;
                this.raisePropertyChanged("XColumn", b, this.sd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "se", {
        get: function () {
            return this.sc;
        },
        set: function (a) {
            if (this.sc != a) {
                var b = this.se;
                this.sc = a;
                this.raisePropertyChanged("YColumn", b, this.se);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "ux", {
        get: function () {
            return this.c(ScatterBase.ua);
        },
        set: function (a) {
            this.h(ScatterBase.ua, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.xAxis;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.yAxis;
        },
        enumerable: false,
        configurable: true
    });
    ScatterBase.prototype.lf = function () {
        _super.prototype.lf.call(this);
        if (this.xAxis != null) {
            this.xAxis.h7(false);
        }
        if (this.yAxis != null) {
            this.yAxis.h7(false);
        }
    };
    ScatterBase.prototype.l4 = function (a, b, c, d) {
        _super.prototype.l4.call(this, a, b, c, d);
        if (this.ry.cx.g$b(a, b, c, d)) {
            this.mi(false);
            this.lp();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.sd);
                    c.deregisterColumn(this.se);
                    this.sd = null;
                    this.se = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.sd = this.ch(this.te);
                    this.se = this.ch(this.tm);
                }
                if ((this.yAxis != null && !this.yAxis.c0()) || (this.xAxis != null && !this.xAxis.c0())) {
                    this.mi(false);
                }
                break;
            case ScatterBase.$$p[7]:
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                if ((this.xAxis != null && !this.xAxis.c0()) || (d == null && c != null)) {
                    this.mi(false);
                }
                this.lp();
                break;
            case ScatterBase.$$p[11]:
                if (c != null) {
                    c.bz(this);
                }
                if (d != null) {
                    d.cs(this);
                }
                if ((this.yAxis != null && !this.yAxis.c0()) || (d == null && c != null)) {
                    this.mi(false);
                }
                this.lp();
                break;
            case ScatterBase.$$p[10]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.sd);
                    this.sd = this.ch(this.te);
                }
                break;
            case "XColumn":
                this.ry.cx.g$i();
                if (this.xAxis != null && !this.xAxis.c0()) {
                    this.mi(false);
                }
                break;
            case ScatterBase.$$p[14]:
                if (this.ck != null) {
                    this.ck.deregisterColumn(this.se);
                    this.se = this.ch(this.tm);
                }
                break;
            case "YColumn":
                this.ry.cx.g$i();
                if (this.yAxis != null && !this.yAxis.c0()) {
                    this.mi(false);
                }
                break;
            case ScatterBase.$$p[5]:
                this.mi(false);
                this.lp();
                break;
            case ScatterBase.$$p[6]:
                this.mi(false);
                this.lp();
                break;
            case "TransitionProgress":
                this.r5.c(this.g0, this.r3, this.r1);
                this.to();
                try {
                    if (this.cx(this.b0)) {
                        return;
                    }
                    if ((Math.round(this.g0 * 100000) / 100000) == 1) {
                        this.t8(this.r1, this.ry);
                    }
                    else {
                        this.t8(this.r5, this.ry);
                    }
                    if (this.cd != null) {
                        this.cd.nn(this);
                    }
                }
                finally {
                    this.t9();
                }
                break;
            case "TrendLineBrush":
                this.mw();
                break;
            case ScatterBase.$$p[0]:
                if (this.rz != null) {
                    this.rz.r = this;
                }
                this.mi(false);
                this.lp();
                break;
            case "TrendLineType":
                this.lp();
                break;
            case ScatterBase.$$p[2]:
                this.sg = this.so();
                this.mi(false);
                break;
            case ScatterBase.$$p[1]:
                this.sf = this.sn();
                this.mi(false);
                break;
            case ScatterBase.$$p[3]:
                this.r7 = this.r8();
                break;
        }
    };
    ScatterBase.prototype.so = function () {
        return this.sk;
    };
    ScatterBase.prototype.sn = function () {
        return this.sj;
    };
    ScatterBase.prototype.si = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.sh = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.t9 = function () {
        this.u0 = Rect.empty;
        this.u1 = Rect.empty;
    };
    ScatterBase.prototype.to = function () {
        var a = this.getViewInfo(this.u0, this.u1);
        this.u0 = a.p0;
        this.u1 = a.p1;
    };
    ScatterBase.prototype.sm = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.te == a || this.tm == a) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.k0 = function (a, b, c, d) {
        var e = false;
        if (!this.sm(d, a)) {
            return;
        }
        this.ry.cx.g$e(a, b, c, d);
        if (this.xAxis != null && !this.xAxis.c0()) {
            e = true;
        }
        if (this.yAxis != null && !this.yAxis.c0()) {
            e = true;
        }
        if (e) {
            this.mi(true);
        }
    };
    ScatterBase.prototype.t0 = function (a) {
        this.t1(a, null);
    };
    ScatterBase.prototype.t1 = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = this.sd != null ? this.sd.count : 0;
        var d = this.se != null ? this.se.count : 0;
        var e = Math.min(c, d);
        if (e <= this.sy) {
            a.m.clear();
            var f = new List$1(OwnedPoint.$, 0);
            try {
                for (var _c = __values(fromEnum(a.u.values)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var g = _d.value;
                    f.add(g);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var h_1 = this.ck;
            f.aa(function (i, j) {
                var k = h_1.indexOf(i.a);
                var l = h_1.indexOf(j.a);
                if (k < l) {
                    return -1;
                }
                if (k > l) {
                    return 1;
                }
                return 0;
            });
            if (b != null) {
                b.i = a.m;
            }
            try {
                for (var _e = __values(fromEnum(f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var i = _f.value;
                    if (h_1.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
    };
    ScatterBase.prototype.ap = function (a) {
        if (a != null && a == this.xAxis && this.sd != null) {
            return new AxisRange(this.sd.minimum, this.sd.maximum);
        }
        if (a != null && a == this.yAxis && this.se != null) {
            return new AxisRange(this.se.minimum, this.se.maximum);
        }
        return null;
    };
    ScatterBase.prototype.ht = function (a) {
        var b = this.hd(a);
        if (this.ck != null && b >= 0 && b < this.ck.count) {
            return this.ck.item(b);
        }
        return null;
    };
    Object.defineProperty(ScatterBase.prototype, "r7", {
        get: function () {
            return this.r6;
        },
        set: function (a) {
            var b = this.r6;
            this.r6 = a;
            if (b != this.r6) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.r6));
            }
        },
        enumerable: false,
        configurable: true
    });
    ScatterBase.prototype.r8 = function () {
        if (this.r9 != 0) {
            return this.r9;
        }
        return this.sl ? 4 : 1;
    };
    ScatterBase.prototype.hd = function (a) {
        var b = truncate(Math.round(this.f5(a)));
        return b;
    };
    ScatterBase.prototype.f5 = function (a) {
        switch (this.r7) {
            case 1: return this.su(a);
            case 3: return this.sv(a);
            case 2: return this.ss(a);
            case 4: return this.st(a);
        }
        return -1;
    };
    ScatterBase.prototype.st = function (a) {
        return this.sw(a, false);
    };
    ScatterBase.prototype.ss = function (a) {
        var b = this.ph(a);
        var c = b.x;
        var d = b.y;
        if (this.ck == null || this.xAxis == null || this.yAxis == null || this.sd == null || this.se == null) {
            return -1;
        }
        if (this.ck.count > this.sx) {
            return -1;
        }
        this.tr();
        var e = this.ri;
        var f = this.rj;
        if (e == null || f == null) {
            return -1;
        }
        var g = 1.7976931348623157E+308;
        var h = -1;
        for (var i = 0; i < this.sd.count; i++) {
            var j = e[i];
            var k = f[i];
            var l = (c - j) * (c - j) + (d - k) * (d - k);
            if (l < g) {
                g = l;
                h = i;
            }
        }
        return h;
    };
    ScatterBase.prototype.tr = function () {
        var _this = this;
        var a = this.b0.bv;
        var b = this.b0.bu;
        var c = this.getEffectiveViewport();
        if (this.rx == null) {
            return;
        }
        var d = new ScalerParams(0, a, b, this.rx.d, c);
        var e = ((function () {
            var $ret = new ScalerParams(0, a, b, _this.rx.e, c);
            $ret.b = _this.gc();
            return $ret;
        })());
        if (this.ri == null || this.rj == null) {
            var f = arrayShallowClone(this.sd.asArray());
            var g = arrayShallowClone(this.se.asArray());
            this.xAxis.hm(boxArray$1(f), 0, f.length, d);
            this.yAxis.hm(boxArray$1(g), 0, g.length, e);
            this.ri = f;
            this.rj = g;
        }
    };
    ScatterBase.prototype.get_sl = function () {
        return false;
    };
    Object.defineProperty(ScatterBase.prototype, "sl", {
        get: function () {
            return this.get_sl();
        },
        enumerable: false,
        configurable: true
    });
    ScatterBase.prototype.sw = function (a, b) {
        if (!this.sl) {
            return -1;
        }
        var c = { $type: Point_$type, x: 0, y: 0 };
        var d = true;
        var e = this.r2();
        if (e == null) {
            return -1;
        }
        if (e.m == null) {
            return -1;
        }
        if (this.ck == null || this.ck.count > this.sx) {
            return -1;
        }
        this.tr();
        var f = this.ri;
        var g = this.rj;
        if (f == null || g == null) {
            return -1;
        }
        var h = this.ph(a);
        var i = 1.7976931348623157E+308;
        var j = -1;
        for (var k = 0; k < this.ri.length; k++) {
            var l = { $type: Point_$type, x: this.ri[k], y: this.rj[k] };
            if (k > 0) {
                if (!b || e.j.containsKey(this.ck.item(k)) || e.j.containsKey(this.ck.item(k - 1))) {
                    var m = GeometryUtil.d(h, c, l);
                    if (m < i) {
                        i = m;
                        j = k;
                    }
                }
            }
            c = l;
        }
        if (j >= 0) {
            var n = { $type: Point_$type, x: this.ri[j], y: this.rj[j] };
            var o = { $type: Point_$type, x: this.ri[j - 1], y: this.rj[j - 1] };
            if (!b || (e.j.containsKey(this.ck.item(j)) && e.j.containsKey(this.ck.item(j - 1)))) {
                var p = GeometryUtil.h(h, o, n);
                return (j - 1) + p;
            }
            else if (e.j.containsKey(this.ck.item(j))) {
                return j;
            }
            else {
                return j - 1;
            }
        }
        return -1;
    };
    ScatterBase.prototype.sv = function (a) {
        return this.sw(a, true);
    };
    ScatterBase.prototype.su = function (a) {
        var _this = this;
        var b = null;
        var c = 1.7976931348623157E+308;
        var d = this.ph(a);
        var e = d.x;
        var f = d.y;
        if (this.ry.cy.e > this.sx) {
            return -1;
        }
        this.ry.c5(function (g) {
            if (g._visibility == 0) {
                var h = _this.ry.cp(g);
                var i = h.left + h.width / 2;
                var j = h.top + h.height / 2;
                var k = (e - i) * (e - i) + (f - j) * (f - j);
                if (k < c) {
                    c = k;
                    b = g;
                }
            }
        });
        if (b != null) {
            return b.ak;
        }
        return -1;
    };
    ScatterBase.prototype.pm = function (a, b, c) {
        var _this = this;
        if (this.xAxis == null || this.yAxis == null || this.sd == null || this.se == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.b0.bv;
        var e = this.b0.bu;
        var f = this.getEffectiveViewport();
        var g = new ScalerParams(0, d, e, this.xAxis.cg, f);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.cg, f);
            $ret.b = _this.gc();
            return $ret;
        })());
        if (b) {
            var i = this.f5(a);
            if (i == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            var j = truncate(Math.floor(i));
            var k = truncate(Math.ceil(i));
            if (j < 0) {
                j = 0;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > this.ck.count - 1) {
                k = this.ck.count - 1;
            }
            if (j > this.ck.count - 1) {
                j = this.ck.count - 1;
            }
            if (k == j) {
                var l = this.xAxis.ei(this.sd.item(j), g);
                var m = this.yAxis.ei(this.se.item(j), h);
                return { $type: Point_$type, x: l, y: m };
            }
            var n = i - Math.floor(i);
            var o = this.xAxis.ei(this.sd.item(j), g);
            var p = this.yAxis.ei(this.se.item(j), h);
            var q = this.xAxis.ei(this.sd.item(k), g);
            var r = this.yAxis.ei(this.se.item(k), h);
            var s = q - o;
            var t = r - p;
            return { $type: Point_$type, x: o + s * n, y: p + t * n };
        }
        else {
            var u = this.hd(a);
            if (u == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            var v = this.xAxis.ei(this.sd.item(u), g);
            var w = this.yAxis.ei(this.se.item(u), h);
            return { $type: Point_$type, x: v, y: w };
        }
    };
    ScatterBase.prototype.en = function (a) {
        var _this = this;
        var b = this.cd != null ? this.cd.sf : Rect.empty;
        b = b.copy();
        var c = this.cd != null ? this.cd.su : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.pt(this.b0);
        var f = new ScalerParams(0, d, d, this.xAxis.cg, e);
        var g = ((function () {
            var $ret = new ScalerParams(0, d, d, _this.yAxis.cg, e);
            $ret.b = _this.gc();
            return $ret;
        })());
        var h = !b.isEmpty && !c.isEmpty && this.ck != null ? this.ck.indexOf(a) : -1;
        var i = this.xAxis != null && this.sd != null && h < this.sd.count ? this.xAxis.ei(this.sd.item(h), f) : NaN;
        var j = this.yAxis != null && this.se != null && h < this.se.count ? this.yAxis.ei(this.se.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.b8 != null) {
            this.b8.au(this.cd, b, true);
        }
        return h >= 0;
    };
    ScatterBase.prototype.m5 = function (a, b) {
        this.mi(false);
    };
    ScatterBase.prototype.m6 = function (a, b) {
        this.mi(false);
    };
    ScatterBase.prototype.r2 = function () {
        var a = this.r1;
        if (this.cv()) {
            if (this.ce.g) {
                this.ce.t();
            }
            a = this.r5;
        }
        return a;
    };
    ScatterBase.prototype.tp = function (a, b, c, d, e) {
        var _this = this;
        b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        var f = this.getEffectiveViewport1(a);
        var g = this.ck;
        var h;
        var i;
        var j = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.rx.d, f);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var k = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.rx.e, f);
            $ret.c = _this.getEffectiveViewport1(a);
            $ret.b = _this.gc();
            return $ret;
        })());
        var l = false;
        var m = 0;
        if (this.cd != null) {
            if (this.cd.e3()) {
                var n = this.cd.ku(d, j);
                l = n.c;
                m = n.d;
            }
        }
        var _loop_1 = function (o) {
            h = this_1.sd.item(o);
            i = this_1.se.item(o);
            var p = { $type: Point_$type, x: this_1.rx.a.ei(h, j), y: this_1.rx.b.ei(i, k) };
            if (l) {
                if (p.x < e.left || p.x > e.right) {
                    if (p.x + m >= e.left && p.x + m <= e.right) {
                        p = { $type: Point_$type, x: p.x + m, y: i };
                    }
                }
            }
            if (!isInfinity(p.x) && !isInfinity(p.y)) {
                var q_1 = g.item(o);
                if (!b.g.containsKey(q_1)) {
                    var r_1 = { $type: Point_$type, x: h, y: i };
                    var s_1 = { $type: Point_$type, x: p.x, y: p.y };
                    b.g.addItem(q_1, ((function () {
                        var $ret = new OwnedPoint();
                        $ret.a = q_1;
                        $ret.b = r_1;
                        $ret.c = s_1;
                        return $ret;
                    })()));
                }
            }
        };
        var this_1 = this;
        for (var o = 0; o < c; o++) {
            _loop_1(o);
        }
    };
    ScatterBase.prototype.tx = function (a, b) {
        var _this = this;
        this.ri = null;
        this.rj = null;
        a.j.clear();
        a.n.clear();
        a.h.clear();
        a.l.clear();
        a.i.clear();
        a.k.clear();
        var c = Math.min(this.sd != null ? this.sd.count : 0, this.se != null ? this.se.count : 0);
        var d = b.bv;
        var e = b.bu;
        var f = this.getEffectiveViewport1(b);
        var g = new ScalerParams(0, d, e, this.xAxis.cg, f);
        g.c = this.getEffectiveViewport1(b);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.cg, f);
            $ret.b = _this.gc();
            return $ret;
        })());
        h.c = this.getEffectiveViewport1(b);
        if (c < 1) {
            return;
        }
        this.rx = ((function () {
            var $ret = new ScatterAxisInfoCache();
            $ret.a = _this.xAxis;
            $ret.b = _this.yAxis;
            $ret.d = _this.xAxis.cg;
            $ret.e = _this.yAxis.cg;
            $ret.c = _this.ck;
            return $ret;
        })());
        var i = b;
        if (c <= this.sy) {
            this.tp(i, a, c, d, e);
        }
        if (this.qf()) {
            b.cv.l(a.j, this.sy, d, e, this.ft);
        }
        var j = ((function () {
            var $ret = new Clipper(0, e, false);
            $ret.i = a.n;
            return $ret;
        })());
        var k = this.pr(b);
        var l = this.xAxis.el(k.left, g);
        var m = this.xAxis.el(k.right, g);
        b.cx.h(a.n, this.trendLineType, this.sd, this.se, this.trendLinePeriod, function (n) { return _this.xAxis.ei(n, g); }, function (n) { return _this.yAxis.ei(n, h); }, ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.ft;
            $ret.f = e;
            $ret.g = d;
            return $ret;
        })()), j, l, m);
        this.tv(a, b);
    };
    ScatterBase.prototype.kx = function (a, b) {
        _super.prototype.kx.call(this, a, b);
        var c = b;
        c.c4(a);
    };
    ScatterBase.prototype.get_dx = function () {
        return true;
    };
    ScatterBase.prototype.rr = function (a, b, c) {
        return null;
    };
    ScatterBase.prototype.rs = function (a, b, c) {
        var d = this.r2();
        var e = this.ry.by(this.ph(b));
        var f = -1;
        if (e == null) {
            if (a != null) {
                f = this.ck.indexOf(a);
            }
            else {
                return null;
            }
        }
        else {
            f = e.ak;
        }
        if (f == -1) {
            return null;
        }
        var g = new HighlightingInfo();
        g.b = this;
        g.h = f;
        g.g = f;
        g.d = false;
        g.e = true;
        if (c != null && c.h == g.h && c.g == g.g) {
            return c;
        }
        return g;
    };
    ScatterBase.prototype.p1 = function (a, b) {
        if (this.qd != 1 && this.qd != 13) {
            var c = this.qc.cq();
            var d = (c.width / 2) + (this.qi / 2);
            var e = (c.height / 2) + (this.qi / 2);
            var f = d;
            var g = d;
            var h = e;
            var i = e;
            if (a == 2 || a == 4) {
                f = 0;
            }
            if (a == 2 || a == 3) {
                g = 0;
            }
            if (b == 2 || b == 3) {
                h = 0;
            }
            if (b == 2 || b == 4) {
                i = 0;
            }
            return new Thickness(1, f, h, g, i);
        }
        return new Thickness(1, 0, 0, 0, 0);
    };
    ScatterBase.prototype.rq = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.ck.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    };
    ScatterBase.prototype.aw = function (a, b, c) {
        if (this.c2 && this.ef(this.bk) && !c) {
            var d = this.rr(a, b, this.rt);
            this.rt = d;
            return d;
        }
        else {
            var e = this.rq(a, b, this.rt);
            this.rt = e;
            return e;
        }
    };
    ScatterBase.prototype.ax = function (a, b, c) {
        if (this.ef(this.bk) && !c) {
            var d = this.rs(a, b, this.ru);
            this.ru = d;
            return d;
        }
        else {
            var e = this.rq(a, b, this.ru);
            e.e = true;
            this.ru = e;
            return e;
        }
    };
    ScatterBase.prototype.sq = function () {
        return (this.assigningScatterStyle != null && this.sg) || (this.bk != 1);
    };
    ScatterBase.prototype.sp = function () {
        return (this.assigningScatterMarkerStyle != null && this.sf) || (this.bk != 1);
    };
    ScatterBase.prototype.t8 = function (a, b) {
        var _this = this;
        var c = b.bu;
        this.rx = ((function () {
            var $ret = new ScatterAxisInfoCache();
            $ret.a = _this.xAxis;
            $ret.b = _this.yAxis;
            $ret.d = _this.xAxis.cg;
            $ret.e = _this.yAxis.cg;
            return $ret;
        })());
        if (this.qf()) {
            b.cv.j(a.j, this.qh);
            if (this.sp()) {
                this.tq(b, a);
            }
        }
        b.cm();
        var d = ((function () {
            var $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
            $ret.i = b.cx.g$j.ak;
            return $ret;
        })());
        b.cx.g$h(a.n, d);
        this.t5(a, b);
    };
    ScatterBase.prototype.rl = function (a, b) {
        return this.rm(a, b);
    };
    ScatterBase.prototype.rm = function (a, b) {
        if (b < a || a < 0 || a > this.sd.count || b < 0 || b > this.sd.count) {
            return null;
        }
        var c = new Array((b - a) + 1);
        for (var d = a; d <= b; d++) {
            var e = d;
            c[d - a] = this.ck.item(d);
        }
        return c;
    };
    ScatterBase.prototype.tq = function (a, b) {
        var _this = this;
        a.b3 = true;
        this.sa.aw(this, this.sp(), runOn(this, this.rl));
        var c = this.sa.d;
        var d = c != null;
        var e = this.getEffectiveViewport1(a);
        var f = this.ck == null ? 0 : this.ck.count;
        this.ry.cf(function (g) {
            if (g._visibility == 0) {
                var h = g.ak;
                var i = g.content;
                if (i == null) {
                    i = new DataContext();
                    g.content = i;
                }
                if (d) {
                    _this.ts(h, f, a.q);
                }
                _this.sa.ac(g, i);
            }
        });
    };
    ScatterBase.prototype.tt = function (a, b, c) {
        var d = this.bk != 1;
        this.sa.ay(this.sa.b, a, b, false);
        this.sa.ab(this.fr);
        var e = this.sa.av;
        var f = null;
        var g = this.ck;
        if (d && this.cd != null) {
            f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, false);
            e.b = f;
        }
        e.f = c;
        this.t3(e);
        this.sa.z(this, f, c, d, a < 0);
    };
    ScatterBase.prototype.ts = function (a, b, c) {
        var d = this.bk != 1;
        this.sa.ay(this.sa.d, a, b, true);
        this.sa.aa(this.fr);
        var e = this.sa.au;
        var f = null;
        var g = this.ck;
        var h = null;
        if (d && this.cd != null) {
            f = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
            if (this.cd.a3.isCrossSeriesHighlight(this)) {
                h = this.cd.a3.getHighlightingInfo(this, g, e.o, e.n, true);
            }
            e.b = f;
        }
        e.f = c;
        this.t2(e);
        this.sa.y(this, f, c, d, e.m, this.cd.a3.totalHighlightingProgress);
    };
    ScatterBase.prototype.t3 = function (a) {
        if (this.assigningScatterStyle != null && this.sg) {
            this.assigningScatterStyle(this, a);
        }
    };
    ScatterBase.prototype.t2 = function (a) {
        if (this.assigningScatterMarkerStyle != null && this.sf) {
            this.assigningScatterMarkerStyle(this, a);
        }
    };
    ScatterBase.prototype.tv = function (a, b) {
        var e_3, _a;
        var c = new ErrorBarsHelper(this, b);
        if (this.rz == null) {
            return;
        }
        var d = this.rz.u;
        var e = this.rz.v;
        var f = 0;
        var g = 0;
        var h = 0;
        var i = 0;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var j = _c.value;
                var k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            var l = this.ty(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            var m = this.tw(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            var n = this.tu(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            var o = this.tz(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            var p = this.tw(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    var q = new OwnedPoint();
                    q.c = c.l(d, this.rx.a, k.c, f);
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            var r = this.ty(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            var s = this.tw(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            var t = this.tu(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            var u = this.tz(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            var v = this.tw(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    var w = new OwnedPoint();
                    w.c = c.m(e, this.rx.b, k.c, g);
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    ScatterBase.prototype.ty = function (a, b, c, d, e, f) {
        if (f) {
            var g = void 0;
            var h = void 0, i = void 0;
            i = this.rx.a;
            if (this.rz.s == 0) {
                g = a.c.x;
                h = this.rx.a;
            }
            else {
                g = a.c.y;
                h = this.rx.b;
            }
            var j = b.f(g, c, h, i, d, e);
            d = j.p4;
            e = j.p5;
        }
        else {
            var k = void 0;
            var l = void 0, m = void 0;
            m = this.rx.b;
            if (this.rz.t == 0) {
                k = a.c.x;
                l = this.rx.a;
            }
            else {
                k = a.c.y;
                l = this.rx.b;
            }
            var n = b.f(k, c, l, m, d, e);
            d = n.p4;
            e = n.p5;
        }
        return {
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.tw = function (a, b, c, d, e, f) {
        if (f) {
            var g = b.j(a.c.x, c, this.rx.a, d, e);
            d = g.p3;
            e = g.p4;
        }
        else {
            var h = b.j(a.c.y, c, this.rx.b, d, e);
            d = h.p3;
            e = h.p4;
        }
        return {
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.tu = function (a, b, c, d, e, f, g) {
        var h = c.getItemColumn();
        var i = this.ck.indexOf(d);
        if (h != null && i < h.count) {
            var j = h.item(i);
            if (g) {
                var k = b.h(a.c.x, j, this.rx.a, e, f);
                e = k.p3;
                f = k.p4;
            }
            else {
                var l = b.h(a.c.y, j, this.rx.b, e, f);
                e = l.p3;
                f = l.p4;
            }
        }
        else {
            e = NaN;
            f = NaN;
        }
        return {
            p4: e,
            p5: f
        };
    };
    ScatterBase.prototype.tz = function (a, b, c, d, e, f) {
        var g = a.i(b, c);
        c = g.p1;
        if (f) {
            var h = a.k(c, b, this.rx.a, d, e);
            d = h.p3;
            e = h.p4;
        }
        else {
            var i = a.k(c, b, this.rx.b, d, e);
            d = i.p3;
            e = i.p4;
        }
        return {
            p2: c,
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.t5 = function (a, b) {
        if (!b.o() || this.rz == null) {
            b.c6();
            return;
        }
        this.t6(a, b);
        this.t7(a, b);
    };
    ScatterBase.prototype.t6 = function (a, b) {
        var e_4, _a;
        b.c2();
        var c = new ErrorBarsHelper(this, b);
        var d = new PathGeometry();
        var e = this.rz.u;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (e != null && a.i.containsKey(f)) {
                    var g = a.i.item(f)[0];
                    var h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        var i = a.h.item(f).c;
                        if (this.rz.o == 1 || this.rz.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.rz.o == 1 || this.rz.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        b.c7(d);
    };
    ScatterBase.prototype.t7 = function (a, b) {
        var e_5, _a;
        b.c3();
        var c = new ErrorBarsHelper(this, b);
        var d = new PathGeometry();
        var e = this.rz.v;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (e != null && a.k.containsKey(f)) {
                    var g = a.k.item(f)[0];
                    var h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        var i = a.l.item(f).c;
                        if (this.rz.p == 1 || this.rz.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.rz.p == 1 || this.rz.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterBase.prototype.e9 = function (a, b, c) {
        var d = true;
        if (!_super.prototype.e9.call(this, a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.sd == null || this.se == null || this.sd.count == 0 || this.se.count == 0 || this.ck == null || this.ck.count != this.sd.count || this.ck.count != this.se.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.lv == this.xAxis.lu || this.yAxis.lv == this.yAxis.lu) {
            d = false;
        }
        return d;
    };
    ScatterBase.prototype.getViewInfo = function (a, b) {
        if (!this.u0.isEmpty && !this.u1.isEmpty) {
            a = this.u0;
            b = this.u1;
            return {
                p0: a,
                p1: b
            };
        }
        a = this.b0.bu;
        b = this.b0.bv;
        return {
            p0: a,
            p1: b
        };
    };
    ScatterBase.prototype.mj = function (a) {
        this.to();
        try {
            if (this.cx(this.b0)) {
                return;
            }
            if (this.ck != null && this.ck.count > this.sy) {
                a = false;
            }
            if (this.eo(a) && !this.es) {
                var b = this.r3;
                if (this.cv()) {
                    if (this.ce.g) {
                        this.ce.t();
                    }
                    this.r3 = this.r5;
                    this.r5 = b;
                }
                else {
                    this.r3 = this.r1;
                    this.r1 = b;
                }
                this.tx(this.r1, this.ry);
                this.mr();
            }
            else {
                if (!this.es) {
                    this.tx(this.r1, this.ry);
                }
                this.t8(this.r1, this.ry);
            }
        }
        finally {
            this.t9();
        }
    };
    ScatterBase.prototype.mw = function () {
        _super.prototype.mw.call(this);
        if (this.index < 0) {
            return;
        }
        this.ry.da();
    };
    ScatterBase.prototype.mk = function (a, b) {
        _super.prototype.mk.call(this, a, b);
        if (!this.ez) {
            this.b0.a2(b);
            return;
        }
        this.b0.a2(b);
        if (this.cx(this.bz)) {
            return;
        }
        var c = typeCast(ScatterBaseView.$, this.bz);
        if (!this.et) {
            this.r4 = new ScatterFrame();
            this.tx(this.r4, c);
        }
        this.et = false;
        this.t8(this.r4, c);
        this.ez = false;
    };
    ScatterBase.prototype.mh = function (a, b, c, d, e) {
        _super.prototype.mh.call(this, a, b, c, d, e);
        var f = this.a6.a$h.item(d);
        var g = f;
        f.a1(c);
        if (this.cx(g)) {
            return;
        }
        if (this.r0 == null) {
            this.r0 = new ScatterFrame();
        }
        this.tx(this.r0, g);
        this.t8(this.r0, g);
    };
    ScatterBase.prototype.t4 = function (a, b) {
        var e_6, _a, e_7, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.h(e);
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
    };
    ScatterBase.prototype.rk = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.rx.c.count) {
            c = new Array(this.rx.c.count);
            for (var f = 0; f < this.rx.c.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = this.getEffectiveViewport1(a);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.xAxis.cg, g);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.cg, g);
            $ret.c = _this.getEffectiveViewport1(a);
            $ret.b = _this.gc();
            return $ret;
        })());
        var j = this.pr(a);
        var k = this.rx.a.el(j.left, h);
        var l = this.rx.a.el(j.right, h);
        var m = this.rx.b.el(j.bottom, i);
        var n = this.rx.b.el(j.top, i);
        if (this.rx.d) {
            var o = k;
            k = l;
            l = o;
        }
        if (this.rx.e) {
            var p = m;
            m = n;
            n = p;
        }
        var q = this.rx;
        var r = q.a;
        var s = q.b;
        var t;
        var u;
        var v = this.sd;
        var w = this.se;
        var x = false;
        var y = 0;
        var z = 0;
        if (this.cd != null) {
            if (this.cd.e3()) {
                var aa = this.cd.ku(d, h);
                x = aa.c;
                y = aa.d;
                z = r.el(0 + y, h);
                var ab = r.el(0, h);
                z -= ab;
            }
        }
        for (var ac = 0; ac < this.rx.c.count; ac++) {
            t = v.item(ac);
            u = w.item(ac);
            if (x) {
                if (t >= k && t <= l && u >= m && u <= n) {
                    c[ac].x = r.ei(t, h);
                    c[ac].y = s.ei(u, i);
                }
                else {
                    if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                        c[ac].x = r.ei(t, h) + y;
                        c[ac].y = s.ei(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            else {
                if (t >= k && t <= l && u >= m && u <= n) {
                    c[ac].x = r.ei(t, h);
                    c[ac].y = s.ei(u, i);
                }
                else {
                    c[ac].x = NaN;
                    c[ac].y = NaN;
                }
            }
        }
        return c;
    };
    ScatterBase.prototype.sr = function (a, b) {
        var e_8, _a;
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        var c = 0;
        var d = this.ck;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b.add(d.indexOf(e));
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        return b;
    };
    ScatterBase.prototype.k7 = function (a) {
        _super.prototype.k7.call(this, a);
        this.a8.exportTrendlineData(this, a, this.ry.cx.g$j);
    };
    ScatterBase.prototype.gc = function () {
        return Series.gd(this.se, null);
    };
    ScatterBase.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = { $type: Point_$type, x: a, y: b };
        var d = this.ht(c);
        var e = d == null ? NaN : this.gb(d, "XMemberPath");
        var f = d == null ? NaN : this.gb(d, "YMemberPath");
        var g = new DataLegendSeriesValueInfo();
        g.l = e;
        g.a = 13;
        g.p = this.te != null ? this.te : "X:";
        g.q = this.ta != null ? this.ta : "X:";
        g.r = this.tc != null ? this.tc : "";
        var h = new DataLegendSeriesValueInfo();
        h.l = f;
        h.a = 14;
        h.p = this.tm != null ? this.tm : "Y:";
        h.q = this.ti != null ? this.ti : "Y:";
        h.r = this.tk != null ? this.tk : "";
        var i = new DataLegendSeriesContext();
        i.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(g);
            $ret.add(h);
            return $ret;
        })());
        i.b = this.av();
        return i;
    };
    ScatterBase.$t = markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.ua = DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    ScatterBase.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:rz:ub', [ScatterErrorBarSettings.$, null], 'IsCustomScatterMarkerStyleAllowed:sj:uc', [0, false], 'IsCustomScatterStyleAllowed:sk:ud', [0, false], 'ItemSearchMode:r9:ue', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:sx:uf', [1, 10000], 'MarkerCollisionAvoidance:rp:ug', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:sy:uh', [1, 400], 'XAxis::up', [NumericXAxis.$, null], 'XMemberAsLegendLabel:ta:uq', [2, null], 'XMemberAsLegendUnit:tc:ur', [2, null], 'XMemberPath:te:us', [2, null], 'YAxis::ut', [NumericYAxis.$, null], 'YMemberAsLegendLabel:ti:uu', [2, null], 'YMemberAsLegendUnit:tk:uv', [2, null], 'YMemberPath:tm:uw', [2, null], 'TrendLineType::un', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::um', [1, 1.5], 'TrendLinePeriod::ul', [1, 7], 'TrendLineBrush::ui', [Brush.$, null], 'TrendLineZIndex:sz:uo', [1, 1001], 'TrendLineDashArray:uy:uj', [DoubleCollection.$], 'TrendLineDashCap:uz:uk', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
}(MarkerSeries));
export { ScatterBase };
/**
 * @hidden
 */
var ScatterSeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSeriesRenderManager, _super);
    function ScatterSeriesRenderManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.au = null;
        _this.av = null;
        return _this;
    }
    ScatterSeriesRenderManager.prototype.c = function () {
        this.au = new AssigningScatterMarkerStyleEventArgs();
        return this.au;
    };
    ScatterSeriesRenderManager.prototype.a = function () {
        this.av = new AssigningScatterStyleEventArgs();
        return this.av;
    };
    ScatterSeriesRenderManager.prototype.aw = function (a, b, c) {
        this.w(a, b, c);
    };
    ScatterSeriesRenderManager.prototype.ax = function (a, b, c) {
        this.x(a, b, c);
    };
    ScatterSeriesRenderManager.prototype.ay = function (a, b, c, d) {
        if (b == -1) {
            a.c = false;
            a.o = 0;
            a.n = c - 1;
        }
        else {
            if (d) {
                a.o = b;
                a.n = b;
            }
            else {
                a.c = false;
                a.o = b;
                a.n = b;
            }
        }
    };
    ScatterSeriesRenderManager.$t = markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
    return ScatterSeriesRenderManager;
}(SeriesRenderManager));
export { ScatterSeriesRenderManager };
/**
 * @hidden
 */
var ScatterBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterBaseView, _super);
    function ScatterBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cv = null;
        _this.ct = null;
        _this.cw = null;
        _this.c1 = null;
        _this.dc = null;
        _this.dd = null;
        _this.cx = null;
        _this.db = null;
        _this.cy = null;
        _this.cw = a;
        _this.cy = new HashPool$2(Base.$, Marker.$);
        _this.ch(_this.cy);
        _this.cx = new ScatterTrendLineManager();
        return _this;
    }
    ScatterBaseView.prototype.as = function () {
        _super.prototype.as.call(this);
        this.cv = this.cu();
        this.dc = new Path();
        this.dd = new Path();
        if (!this.q) {
            this.cw.sy = 2000;
        }
    };
    ScatterBaseView.prototype.de = function (a) {
        if (this.db == null) {
            this.db = new DataTemplateMeasureInfo();
            this.db.context = this.k.g();
        }
        this.db.width = a.width;
        this.db.height = a.height;
        this.db.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.db);
        }
        return new Size(1, this.db.width, this.db.height);
    };
    ScatterBaseView.prototype.cu = function () {
        var _this = this;
        var a = new NumericMarkerManager(1, function (b) { return _this.cy.item(b); }, function (b) { return _this.cw.rx.c.item(b); }, runOn(this, this.c9), runOn(this, this.cr), runOn(this, this.cz), function () { return _this.cw.rp; });
        a.q = runOn(this, this.de);
        return a;
    };
    ScatterBaseView.prototype.c9 = function (a) {
        this.cw.t4(a, this.cy);
    };
    ScatterBaseView.prototype.c0 = function () {
        return this.b4;
    };
    ScatterBaseView.prototype.cs = function () {
        return this.ct;
    };
    ScatterBaseView.prototype.cr = function () {
        this.ct = this.cw.rk(this, this.cy, this.ct, this.bv, this.bu);
        return this.ct;
    };
    ScatterBaseView.prototype.cz = function () {
        this.c1 = this.cw.sr(this.cy, this.c1);
        return this.c1;
    };
    ScatterBaseView.prototype.c2 = function () {
    };
    ScatterBaseView.prototype.c7 = function (a) {
    };
    ScatterBaseView.prototype.c3 = function () {
    };
    ScatterBaseView.prototype.c8 = function (a) {
    };
    ScatterBaseView.prototype.da = function () {
        if (this.cw.trendLineBrush != null) {
            this.cw.ux = this.cw.trendLineBrush;
        }
        else {
            this.cw.ux = this.cw.oz;
        }
    };
    ScatterBaseView.prototype.cf = function (a) {
        this.cy.f(a);
    };
    ScatterBaseView.prototype.c5 = function (a) {
        this.cy.g(a);
    };
    ScatterBaseView.prototype.c6 = function () {
    };
    ScatterBaseView.prototype.a5 = function (a, b) {
        _super.prototype.a5.call(this, a, b);
        if (a.d) {
            if (this.cw.trendLineType != 0 && !b) {
                var c = this.cx.g$j;
                c.ac = this.cw.trendLineThickness;
                c._stroke = this.cw.ux;
                c.ai = this.cw.uy;
                c.ad = this.cw.uz;
                a.u(c);
            }
        }
    };
    ScatterBaseView.prototype.c4 = function (a) {
        if (a) {
            this.c6();
            this.cy.clear();
        }
        this.cx.g$d();
        this.aq();
    };
    ScatterBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a6.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cw.title + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cw.te + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cw.tm + "}</span></div>";
        return a;
    };
    ScatterBaseView.$t = markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
}(MarkerSeriesView));
export { ScatterBaseView };
