import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private tl;
    get tm(): IAnchoredCategorySeriesInteractionManager;
    th: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    i0(): string;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    tp: boolean;
    constructor();
    t1: string;
    hw(a: any, b: string): any;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private tn;
    tx: string;
    tz: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ul(): Brush;
    set ul(a: Brush);
    static readonly t8: DependencyProperty;
    trendLineThickness: number;
    un: PenLineCap;
    um: DoubleCollection;
    trendLinePeriod: number;
    tr: number;
    en(a: any): boolean;
    protected te(a: number, b: number, c: Axis): any[];
    protected l4(a: any, b: string, c: any, d: any): void;
    ap(a: Axis): AxisRange;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected so(): number;
    tq(a: CategorySeriesView): number;
    t6(a: PointCollection, b: number, c: CategorySeriesView): void;
    tf(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    tg(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    kx(a: boolean, b: SeriesView): void;
    s4(a: CategoryFrame, b: CategorySeriesView): void;
    s7(a: CategoryFrame, b: CategorySeriesView): void;
    ti: CategoryFrame;
    mh(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    t3(a: CategoryFrame, b: CategorySeriesView): void;
    protected mw(): void;
    hz(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected tt: string;
    abstract t4(a: Axis): void;
    abstract t5(a: Axis): void;
    protected k7(a: any): void;
    tj: CategorySeriesMarkerCollisionAvoidance;
    ht(a: Point): any;
    tk: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    gc(): number;
    protected get_ts(): number;
    protected get ts(): number;
    aq(a: Rect): AxisRange;
    private t7;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c1;
    get c2(): ITrendLineManager;
    set c2(a: ITrendLineManager);
    get c3(): boolean;
    c7(): void;
    c5(): void;
    c4(): void;
    cs(): CategoryBucketCalculator;
    c6(): void;
    c8(): void;
    c9(a: number): Rect;
    protected a5(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
