import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Clipper } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { LegendItemBadgeShape } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class FinancialIndicator extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_dq(): boolean;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    tn: FinancialIndicatorView;
    constructor();
    t0(a: boolean): void;
    protected ts(a: Point, b: Point, c: boolean): boolean;
    protected bp(): SeriesHitTestMode;
    pv(a: Point): Rect;
    ev(a: Point, b: boolean): boolean;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    tp: IndicatorDisplayType;
    protected get_to(): IndicatorDisplayType;
    get to(): IndicatorDisplayType;
    tv: number;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ud(): Brush;
    set ud(a: Brush);
    static readonly t3: DependencyProperty;
    trendLineThickness: number;
    uf: PenLineCap;
    ue: DoubleCollection;
    trendLinePeriod: number;
    protected tx(): number;
    tw: number;
    private _indicatorColumn;
    get indicatorColumn(): List$1<number>;
    set indicatorColumn(a: List$1<number>);
    protected tm: AxisRange;
    protected abstract tq(a: number, b: number): boolean;
    protected abstract tt(a: number, b: number): IList$1<string>;
    protected l4(a: any, b: string, c: any, d: any): void;
    gj(a: Point, b: boolean, c: boolean): number;
    hj(a: Point, b: boolean): number;
    hh(a: Point, b: boolean): number;
    protected get_e8(): boolean;
    private tr;
    private t2;
    ap(a: Axis): AxisRange;
    en(a: any): boolean;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    s3(a: CategoryFrame, b: FinancialSeriesView): void;
    kx(a: boolean, b: SeriesView): void;
    protected qm(): CategoryTransitionInMode;
    s5(a: CategoryFrame, b: FinancialSeriesView): void;
    protected mw(): void;
    protected t1(): void;
    protected k7(a: any): void;
    protected ba(a: LegendItemBadgeShape): LegendItemBadgeShape;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    static $t: Type;
    constructor(a: FinancialSeriesView);
    protected f: FinancialIndicatorView;
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class FinancialIndicatorView extends FinancialSeriesView {
    static $t: Type;
    b3: FinancialIndicator;
    constructor(a: FinancialIndicator);
    protected by(): FinancialBucketCalculator;
    as(): void;
    private readonly b6;
    private cg;
    private b9;
    cu: Path;
    cq: Path;
    cv: Path;
    cr: Path;
    cw: Path;
    cs: Path;
    ct: Path;
    cp: Path;
    private b4;
    get b5(): ITrendLineManager;
    set b5(a: ITrendLineManager);
    get b7(): boolean;
    b8(a: boolean): void;
    ce(): void;
    cc(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: Clipper): void;
    ca(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number, f: Clipper): void;
    cb(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number): void;
    cf(): void;
    private cm;
    private co;
    private cn;
    private cl;
    private ci;
    private ck;
    private cj;
    private ch;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    al(a: any): void;
    cd(): void;
}
