import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { PriceDisplayType } from "./PriceDisplayType";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Pool$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { GeometryGroup } from "igniteui-angular-core";
import { LegendItemBadgeShape } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    static $t: Type;
    protected get_ds(): boolean;
    protected gu(): number;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    tn: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get uv(): Brush;
    set uv(a: Brush);
    static readonly ud: DependencyProperty;
    trendLineThickness: number;
    uy: PenLineCap;
    ux: DoubleCollection;
    trendLinePeriod: number;
    tr: number;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    to: PriceDisplayType;
    protected bp(): SeriesHitTestMode;
    pv(a: Point): Rect;
    private tm;
    ak(a: Point): Rect[];
    ev(a: Point, b: boolean): boolean;
    protected ey(a: Point, b: boolean): boolean;
    protected l4(a: any, b: string, c: any, d: any): void;
    private uc;
    ap(a: Axis): AxisRange;
    aq(a: Rect): AxisRange;
    gc(): number;
    en(a: any): boolean;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    s3(a: CategoryFrame, b: FinancialSeriesView): void;
    kx(a: boolean, b: SeriesView): void;
    protected m5(a: Rect, b: Rect): void;
    p1(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected get_c2(): boolean;
    s5(a: CategoryFrame, b: FinancialSeriesView): void;
    ga(): number;
    private ub;
    private tp;
    private ua;
    hz(a: any, b: Point): any;
    protected mw(): void;
    protected k7(a: any): void;
    uw: Brush;
    pa(): Brush;
    mn(a: Brush, b: Brush): void;
    protected ba(a: LegendItemBadgeShape): LegendItemBadgeShape;
    t1: string;
    tx: string;
    ts: string;
    t6: string;
    t3: string;
    tz: string;
    tu: string;
    t8: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    static $t: Type;
    protected b3: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b6: Pool$1<Path>;
    co(): Path;
    protected b9: List$1<Path>;
    ce(a: Path): void;
    cg(a: Path): void;
    cf(a: Path): void;
    protected by(): FinancialBucketCalculator;
    as(): void;
    private cn;
    private cm;
    private b4;
    get b5(): ITrendLineManager;
    set b5(a: ITrendLineManager);
    get b7(): boolean;
    ch(): void;
    cb(): void;
    ca(): void;
    ck(): GeometryGroup;
    cj(): GeometryGroup;
    ci(): void;
    protected bb(): void;
    protected bc(): void;
    protected ac(a: number): any;
    private cl;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    protected a5(a: RenderingContext, b: boolean): void;
    al(a: any): void;
    cc(): void;
    b8: boolean;
    cd(): void;
}
