import { MarkerSeries } from "./MarkerSeries";
import { Point, Type } from "igniteui-angular-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { OwnedPoint } from "./OwnedPoint";
import { HashPool$2 } from "igniteui-angular-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { AssigningPolarStyleEventArgs } from "./AssigningPolarStyleEventArgs";
import { AssigningPolarMarkerStyleEventArgs } from "./AssigningPolarMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class PolarBase extends MarkerSeries {
    static $t: Type;
    protected bx(): SeriesView;
    lz(a: SeriesView): void;
    ry: PolarBaseView;
    private rz;
    ku(): void;
    protected get_d6(): boolean;
    c1(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    constructor();
    private tx;
    private tz;
    private rl;
    rx: PolarAxisInfoCache;
    private u1;
    private u0;
    sb: SeriesRenderer$2<PolarFrame, PolarBaseView>;
    te: string;
    ts: string;
    protected get sf(): IFastItemColumn$1<number>;
    protected set sf(a: IFastItemColumn$1<number>);
    private sd;
    protected get sg(): IFastItemColumn$1<number>;
    protected set sg(a: IFastItemColumn$1<number>);
    private se;
    ru: NumericAngleAxis;
    rv: NumericRadiusAxis;
    su: boolean;
    s4: number;
    sc: TrendLineType;
    uv: Brush;
    get uu(): Brush;
    set uu(a: Brush);
    static readonly t7: DependencyProperty;
    s2: number;
    ux: PenLineCap;
    uw: DoubleCollection;
    s5: number;
    s6: number;
    sl: boolean;
    r3: PolarFrame;
    r5: PolarFrame;
    r1: PolarFrame;
    r2(): PolarFrame;
    rw: PolarAxes;
    lf(): void;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected m5(a: Rect, b: Rect): void;
    protected m6(a: Rect, b: Rect): void;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    mj(a: boolean): void;
    private uz;
    ap(a: Axis): AxisRange;
    en(a: any): boolean;
    ht(a: Point): any;
    hd(a: Point): number;
    f5(a: Point): number;
    protected sy(a: Point): number;
    protected sx(a: Point): number;
    private sm;
    private sv;
    private s1;
    protected s0(a: Point): number;
    protected sz(a: Point): number;
    pm(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    hw(a: any, b: string): any;
    protected l4(a: any, b: string, c: any, d: any): void;
    private r7;
    get r8(): ScatterItemSearchMode;
    set r8(a: ScatterItemSearchMode);
    protected r9(): ScatterItemSearchMode;
    protected get_sp(): boolean;
    protected get sp(): boolean;
    protected sr(): boolean;
    protected sq(): boolean;
    sa: ScatterItemSearchMode;
    s3: number;
    sk(a: any): boolean;
    sj(a: any): boolean;
    kx(a: boolean, b: SeriesView): void;
    private rm;
    tw(a: PolarFrame, b: number, c: Rect, d: Rect): void;
    t2(a: PolarFrame, b: PolarBaseView): void;
    so: boolean;
    sn: boolean;
    protected si: boolean;
    protected sh: boolean;
    protected get_dx(): boolean;
    private rs;
    private rt;
    protected rq(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rr(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rp(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningPolarStyle: (sender: any, args: AssigningPolarStyleEventArgs) => void;
    assigningPolarMarkerStyle: (sender: any, args: AssigningPolarMarkerStyleEventArgs) => void;
    protected st(): boolean;
    protected ss(): boolean;
    t6(a: PolarFrame, b: PolarBaseView): void;
    rj(a: number, b: number): any[];
    protected rk(a: number, b: number): any[];
    protected r6: PolarSeriesRenderManager;
    ty(a: PolarBaseView, b: PolarFrame): void;
    protected t1(a: number, b: number, c: boolean): void;
    protected t0(a: number, b: number, c: boolean): void;
    protected t4(a: AssigningPolarStyleEventArgs): void;
    protected t3(a: AssigningPolarMarkerStyleEventArgs): void;
    private tv;
    protected mw(): void;
    r4: PolarFrame;
    mk(a: Rect, b: RenderSurface): void;
    private r0;
    mh(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    t5(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    ri(a: HashPool$2<any, Marker>, b: Rect, c: Rect): Point[];
    sw(a: HashPool$2<any, Marker>): List$1<number>;
    uy(a: number): Point;
    protected k7(a: any): void;
    to: string;
    ta: string;
    tq: string;
    tc: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PolarSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    au: AssigningPolarMarkerStyleEventArgs;
    av: AssigningPolarStyleEventArgs;
    aw(a: PolarBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ax(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ay(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class PolarBaseView extends MarkerSeriesView {
    static $t: Type;
    protected cu: PolarBase;
    ct: MarkerManagerBase;
    constructor(a: PolarBase);
    cv: PolarTrendLineManager;
    as(): void;
    cz(a: (arg1: Marker) => void): void;
    protected cs(): MarkerManagerBase;
    protected c0(a: IDictionary$2<any, OwnedPoint>): void;
    protected cr(): Point[];
    protected cx(): List$1<number>;
    cy(a: Rect, b: Rect, c: Rect, d: Rect): void;
    c1(): void;
    cw: HashPool$2<any, Marker>;
    cf(a: (arg1: Marker) => void): void;
    protected a5(a: RenderingContext, b: boolean): void;
    protected c2(): Rect;
    getDefaultTooltipTemplate(): string;
}
