import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-angular-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-angular-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { Size } from "igniteui-angular-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected bx(): SeriesView;
    ku(): void;
    lz(a: SeriesView): void;
    ry: ScatterBaseView;
    protected get_ec(): boolean;
    ag(): Axis[];
    hw(a: any, b: string): any;
    c1(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    protected bp(): SeriesHitTestMode;
    px(a: Point): Rect;
    ev(a: Point, b: boolean): boolean;
    constructor();
    rx: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    te: string;
    get sd(): IFastItemColumn$1<number>;
    set sd(a: IFastItemColumn$1<number>);
    private sb;
    tm: string;
    get se(): IFastItemColumn$1<number>;
    set se(a: IFastItemColumn$1<number>);
    private sc;
    ta: string;
    ti: string;
    tc: string;
    tk: string;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get ux(): Brush;
    set ux(a: Brush);
    static readonly ua: DependencyProperty;
    trendLineThickness: number;
    uz: PenLineCap;
    uy: DoubleCollection;
    trendLinePeriod: number;
    rp: CollisionAvoidanceType;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    sz: number;
    sy: number;
    r9: ScatterItemSearchMode;
    sx: number;
    lf(): void;
    rz: ScatterErrorBarSettings;
    protected l4(a: any, b: string, c: any, d: any): void;
    protected so(): boolean;
    protected sn(): boolean;
    si(a: any): boolean;
    sh(a: any): boolean;
    private t9;
    private u0;
    private u1;
    private to;
    protected sm(a: string, b: FastItemsSourceEventAction): boolean;
    protected k0(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    t0(a: ScatterFrame): void;
    t1(a: ScatterFrame, b: Clipper): void;
    ap(a: Axis): AxisRange;
    ht(a: Point): any;
    private r6;
    get r7(): ScatterItemSearchMode;
    set r7(a: ScatterItemSearchMode);
    protected r8(): ScatterItemSearchMode;
    hd(a: Point): number;
    f5(a: Point): number;
    protected st(a: Point): number;
    private ri;
    private rj;
    protected ss(a: Point): number;
    private tr;
    protected get_sl(): boolean;
    protected get sl(): boolean;
    private sw;
    protected sv(a: Point): number;
    protected su(a: Point): number;
    pm(a: Point, b: boolean, c: boolean): Point;
    en(a: any): boolean;
    protected m5(a: Rect, b: Rect): void;
    protected m6(a: Rect, b: Rect): void;
    r3: ScatterFrame;
    r5: ScatterFrame;
    r1: ScatterFrame;
    r2(): ScatterFrame;
    tp(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    tx(a: ScatterFrame, b: ScatterBaseView): void;
    kx(a: boolean, b: SeriesView): void;
    sk: boolean;
    sj: boolean;
    protected sg: boolean;
    protected sf: boolean;
    protected get_dx(): boolean;
    private rt;
    private ru;
    protected rr(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected rs(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    p1(a: SeriesPlotAreaMarginHorizontalMode, b: SeriesPlotAreaMarginVerticalMode): Thickness;
    protected rq(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    aw(a: any, b: Point, c: boolean): HighlightingInfo;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected sq(): boolean;
    protected sp(): boolean;
    t8(a: ScatterFrame, b: ScatterBaseView): void;
    rl(a: number, b: number): any[];
    protected rm(a: number, b: number): any[];
    protected sa: ScatterSeriesRenderManager;
    tq(a: ScatterBaseView, b: ScatterFrame): void;
    protected tt(a: number, b: number, c: boolean): void;
    protected ts(a: number, b: number, c: boolean): void;
    protected t3(a: AssigningScatterStyleEventArgs): void;
    protected t2(a: AssigningScatterMarkerStyleEventArgs): void;
    tv(a: ScatterFrame, b: ScatterBaseView): void;
    ty(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    tw(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    tu(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    tz(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    t5(a: ScatterFrame, b: ScatterBaseView): void;
    private t6;
    private t7;
    e9(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    mj(a: boolean): void;
    protected mw(): void;
    r4: ScatterFrame;
    mk(a: Rect, b: RenderSurface): void;
    private r0;
    mh(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    t4(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    rk(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    sr(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected k7(a: any): void;
    gc(): number;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    au: AssigningScatterMarkerStyleEventArgs;
    av: AssigningScatterStyleEventArgs;
    aw(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ax(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ay(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cv: MarkerManagerBase;
    protected ct: Point[];
    protected cw: ScatterBase;
    protected c1: List$1<number>;
    constructor(a: ScatterBase);
    private dc;
    private dd;
    cx: ScatterTrendLineManager;
    as(): void;
    private db;
    de(a: Marker): Size;
    protected cu(): MarkerManagerBase;
    protected c9(a: IDictionary$2<any, OwnedPoint>): void;
    c0(): List$1<Marker>;
    cs(): Point[];
    protected cr(): Point[];
    protected cz(): List$1<number>;
    c2(): void;
    c7(a: PathGeometry): void;
    c3(): void;
    c8(a: PathGeometry): void;
    da(): void;
    cy: HashPool$2<any, Marker>;
    cf(a: (arg1: Marker) => void): void;
    c5(a: (arg1: Marker) => void): void;
    c6(): void;
    protected a5(a: RenderingContext, b: boolean): void;
    c4(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
